
// AX_Pro_DemoDlg.h : header file
//

#pragma once

#include "foxitpdfsdkproctrl.h"
#include "CPDFPrinter.h"
#include "CPDFOutline.h"
#include "CLink_Dest.h"
#include "FindDlg.h"
#include "Zoom.h"
#include "Gotopage.h"
#include "MyToolBar.h"
#include "FindFoldDlg.h"
#include "findformtext.h"


// CAX_Pro_DemoDlg dialog
class CAX_Pro_DemoDlg : public CDialog
{
// Construction
public:
	CAX_Pro_DemoDlg(CWnd* pParent = NULL);	// standard constructor
	CFile m_f;
	BYTE*   m_pBuffer;
	BOOL	m_bOpenCustomer;
	int     m_step;
	int     m_pageindex;
	BOOL m_ToolState;
	BOOL m_TitleState;
	BOOL m_NavigationPanelState;

// Dialog Data
	enum { IDD = IDD_AX_PRO_DEMO_DIALOG };
	CTreeCtrl	m_outlinetree;
	CRect rect;
	long zoomfactor;
	short rotatefactor;	
	bool m_bhidebookmark;
	CFoxitPDFSDK	m_AX;

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;
	CMyToolBar m_wndToolBar;
	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnFileOpen();
	afx_msg void OnFilePrint();
	afx_msg void OnFindText();
	afx_msg void OnZoomIn();
	afx_msg void OnZoomOut();
	afx_msg void OnZoomTo();
	afx_msg void OnRotateRight();
	afx_msg void OnRotateLeft();
	afx_msg void OnFirstPage();
	afx_msg void OnLastPage();
	afx_msg void OnNextPage();
	afx_msg void OnPrevPage();
	afx_msg void OnClickTree1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnHandTool();
	afx_msg void OnZoomInTool();
	afx_msg void OnZoomOutTool();
	afx_msg void OnPreviousView();
	afx_msg void OnNextView();
	afx_msg void OnGotoPage();
	afx_msg void OnAbout();
	afx_msg void OnHideBookmark();
	afx_msg void OnFileClose();
	afx_msg void OnFindFile();
	afx_msg void OnSinglePage();
	afx_msg void OnFace();
	afx_msg void OnContinuousPage();
	afx_msg void OnContinuousFace();
	afx_msg void OnActualSize();
	afx_msg void OnFitPage();
	afx_msg void OnFitWidth();
	afx_msg void OnSelectText();
	afx_msg void OnSnapShot();
	afx_msg void OnOnHypeLinkFoxitpdfsdkproctrl1(LPCTSTR linktype, LPCTSTR linkdata, LPDISPATCH dest, BOOL FAR* cancel);
	afx_msg void OnJavaConsole();
	afx_msg void OnCustomFileGetSizeFoxitpdfsdkproctrl1(long FAR* size);
	afx_msg void OnCustomFileGetBlockFoxitpdfsdkproctrl1(long pos, long pBuf, long size);
	afx_msg void OnExit();
	afx_msg void OnCustomfileOpen();
	afx_msg void OnDocumentInfo();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveas();
	afx_msg void OnExportAnnotation();
	afx_msg void OnImportAnnotation();
	afx_msg void OnCopyText();
	afx_msg void OnOnSearchProgressFoxitpdfsdkproctrl1(long pageNumber, long PageCount);
	afx_msg void OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnFindFormtext();
	afx_msg void OnExportFrom();
	afx_msg void OnImportForm();
	afx_msg void OnPrintNotshow();
	afx_msg void OnHightlightRect();
	afx_msg void OnOnOpenPasswordFoxitpdfsdkproctrl1(BSTR FAR* Password, BOOL FAR* cancel);
	afx_msg void OnOnPageChangeFoxitpdfsdkproctrl1();
	afx_msg void OnOnZoomChangeFoxitpdfsdkproctrl1();
	afx_msg void OnAfterDrawFoxitpdfsdkproctrl1(long dc);
	afx_msg void OnBeforeDrawFoxitpdfsdkproctrl1(long dc);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnOpenMemfile();
	afx_msg void OnStreamfileOpen();
	afx_msg void OnChooseLanguage();
	afx_msg void OnAddWatermark();
	afx_msg void OnAdvanceTool();
	afx_msg void OnOnCloseDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnOnRButtonClickFoxitpdfsdkproctrl1(long hWnd, long ClientX, long Client);
	afx_msg void OnNavpanelShow();
	afx_msg void OnUpdateNavpanelShow(CCmdUI* pCmdUI);
	afx_msg void OnGetscroloc();
	afx_msg void OnUploadfile2ftp();
	afx_msg void OnSetcrashlog();
	afx_msg void OnCovert();
	afx_msg void OnRemovewatermark();
	afx_msg void OnGetpageText();
	afx_msg void OnExportPagetopdf();
	afx_msg void OnBufferfileOpen();
	afx_msg void OnZhongwen();
	afx_msg void OnFileProperties();
	afx_msg void OnGetHyperlink();
	afx_msg void OnGethyperlinkInfo();
	afx_msg void OnShowToolTip();
	afx_msg void OnShowToolBar();
	afx_msg void OnShowNavigationPanels();
	afx_msg void OnOK();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	void OnMENUITEMexpandtree();
	void MyExpandTree(HTREEITEM   hTreeItem);
	void ProcOutline(CPDFOutline outline,HTREEITEM hParentItem);
	CMap<HTREEITEM,HTREEITEM,CPDFOutline,CPDFOutline&> m_bookMarkMap;
	void ShowBookMark();
	void HideBookMark();
};
