// AX_Annot_DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Annot_Demo.h"
#include "AX_Annot_DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAX_Annot_DemoDlg dialog

CAX_Annot_DemoDlg::CAX_Annot_DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAX_Annot_DemoDlg::IDD, pParent)
	, m_color(RGB(255, 0, 0))
	, m_fillColor(RGB(255, 255, 255))
	, m_fontColor(RGB(255, 255, 255))
	, m_fontBorderColor(RGB(255, 255, 255))
	, m_fontFillColor(RGB(255, 255, 255))
	, m_pAnnotInfoDlg(NULL)
	,m_pAnnotRepleDlg(NULL)
{
	//{{AFX_DATA_INIT(CAX_Annot_DemoDlg)
	m_nOpacity = 0;
	m_bLockCheck = FALSE;
	m_bPopupCheck = FALSE;
	m_bPrintCheck = FALSE;
	m_bReadonlyCheck = FALSE;
	m_strLeftPos = _T("");
	m_strRightPos = _T("");
	m_strTopPos = _T("");
	m_strBottomPos = _T("");
	m_nBroderStyle = -1;
	m_nLineStartStyle = -1;
	m_nLineEndStyle = -1;
	m_strAuthor = _T("");
	m_strSubject = _T("");
	m_nReviewState = -1;
	m_nMarkedState = -1;
	m_strDescription = _T("");
	m_strCreateDate = _T("");
	m_strModifyDate = _T("");
	m_strFilePath = _T("");
	m_nMigrationState = -1;
	m_strContents = _T("");
	m_strFontName = _T("");
	m_strFontSize = _T("");
	m_nAlignStyle = -1;
	m_bFontBold = FALSE;
	m_bFontItalic = FALSE;
	m_strCharSpace = _T("");
	m_strCharHorzScale = _T("");
	m_bEmbedMedia = FALSE;
	m_bShowCtrlBar = FALSE;
	m_strPoint3XPos = _T("");
	m_strPoint3YPos = _T("");
	m_strPoint4XPos = _T("");
	m_strPoint4YPos = _T("");
	m_strWebURL = _T("");
	m_strLinkActionPageLeft = _T("");
	m_strLinkActionPageTop = _T("");
	m_strImagePath = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_AnnotMap.RemoveAll();
}

void CAX_Annot_DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAX_Annot_DemoDlg)
	DDX_Control(pDX, IDC_PAGE_INDEX_COMBO, m_linkPageIndexCombo);
	DDX_Control(pDX, IDC_LINK_ACTION_COMBO, m_linkActionTypeCombo);
	DDX_Control(pDX, IDC_ANNOT_TOOL_COMBO, m_annotToolsCombo);
	DDX_Control(pDX, IDC_MEDIA_CONTENTTYPE_COMBO, m_mediaContentTypeCombo);
	DDX_Control(pDX, IDC_OPACITY_SLIDER, m_opacitySlider);
	DDX_Control(pDX, IDC_THICKNESS_LIST, m_thickNessList);
	DDX_Control(pDX, IDC_ANNOT_SUBTYPE_COMBO, m_annotSubTypeCombo);
	DDX_Text(pDX, IDC_OPACITY_EDIT, m_nOpacity);
	DDV_MinMaxInt(pDX, m_nOpacity, 0, 100);
	DDX_Check(pDX, IDC_LOCK_CHECK, m_bLockCheck);
	DDX_Check(pDX, IDC_POPUP_CHECK, m_bPopupCheck);
	DDX_Check(pDX, IDC_PRINT_CHECK, m_bPrintCheck);
	DDX_Check(pDX, IDC_READONLY_CHECK, m_bReadonlyCheck);
	DDX_Text(pDX, IDC_LEFT_EDIT, m_strLeftPos);
	DDX_Text(pDX, IDC_RIGHT_EDIT, m_strRightPos);
	DDX_Text(pDX, IDC_TOP_EDIT, m_strTopPos);
	DDX_Text(pDX, IDC_BOTTOM_EDIT, m_strBottomPos);
	DDX_CBIndex(pDX, IDC_BORDER_STYLE_COMBO, m_nBroderStyle);
	DDX_CBIndex(pDX, IDC_LINE_START_STYLE_COMBO, m_nLineStartStyle);
	DDX_CBIndex(pDX, IDC_LINE_END_STYLE_COMBO, m_nLineEndStyle);
	DDX_Text(pDX, IDC_AUTHOR_EDIT, m_strAuthor);
	DDX_Text(pDX, IDC_SUBJECT_EDIT, m_strSubject);
	DDX_CBIndex(pDX, IDC_REVIEW_STATE_COMBO, m_nReviewState);
	DDX_CBIndex(pDX, IDC_MARKED_STATE_COMBO, m_nMarkedState);
	DDX_Text(pDX, IDC_DESCRIPTION_EDIT, m_strDescription);
	DDX_Text(pDX, IDC_CREATE_DATE_STATIC, m_strCreateDate);
	DDX_Text(pDX, IDC_MODIFY_DATE_STATIC, m_strModifyDate);
	DDX_Text(pDX, IDC_FILE_PATH_EDIT, m_strFilePath);
	DDX_CBIndex(pDX, IDC_MIGRATION_STATE_COMBO, m_nMigrationState);
	DDX_Text(pDX, IDC_CONTENT_EDIT, m_strContents);
	DDX_Text(pDX, IDC_FONT_NAME_EDIT, m_strFontName);
	DDX_Text(pDX, IDC_FONT_SIZE_EDIT, m_strFontSize);
	DDX_Radio(pDX, IDC_LEFT_ALIGN_RADIO, m_nAlignStyle);
	DDX_Check(pDX, IDC_FONT_BOLD_CHECK, m_bFontBold);
	DDX_Check(pDX, IDC_FONT_ITALIC_CHECK, m_bFontItalic);
	DDX_Text(pDX, IDC_CHAR_SPACE_EDIT, m_strCharSpace);
	DDX_Text(pDX, IDC_CHAR_HORZ_SCALE_EDIT, m_strCharHorzScale);
	DDX_Check(pDX, IDC_EMBED_MEDIA_CHECK, m_bEmbedMedia);
	DDX_Check(pDX, IDC_SHOW_CTRL_BAR_CHECK, m_bShowCtrlBar);
	DDX_Text(pDX, IDC_POINT3_X_POS, m_strPoint3XPos);
	DDX_Text(pDX, IDC_POINT3_Y_POS, m_strPoint3YPos);
	DDX_Text(pDX, IDC_POINT4_X_POS, m_strPoint4XPos);
	DDX_Text(pDX, IDC_POINT4_Y_POS, m_strPoint4YPos);
	DDX_Text(pDX, IDC_WEB_URL_EDIT, m_strWebURL);
	DDX_Text(pDX, IDC_LINK_ACTION_LEFT, m_strLinkActionPageLeft);
	DDX_Text(pDX, IDC_LINK_ACTION_TOP, m_strLinkActionPageTop);
	DDX_Text(pDX, IDC_IMAGE_PATH_EDIT, m_strImagePath);
	DDX_Control(pDX, IDC_FOXITPDFSDKPROCTRL1, m_fxAXSDK);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAX_Annot_DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CAX_Annot_DemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADD_ANNOT_BTN, OnAddAnnotBtn)
	ON_BN_CLICKED(IDC_COLOR_BTN, OnColorBtn)
	ON_WM_CTLCOLOR()
	ON_WM_DRAWITEM()
	ON_BN_CLICKED(IDC_FILL_COLOR_BTN, OnFillColorBtn)
	ON_CBN_SELCHANGE(IDC_ANNOT_SUBTYPE_COMBO, OnSelchangeAnnotSubtypeCombo)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_OPACITY_EDIT, OnChangeOpacityEdit)
	ON_BN_CLICKED(IDC_REMOVE_ANNOT_BTN, OnRemoveAnnotBtn)
	ON_BN_CLICKED(IDC_MODIFY_ANNOT_BTN, OnModifyAnnotBtn)
	ON_BN_CLICKED(IDC_CHOOSE_FILE_BTN, OnChooseFileBtn)
	ON_EN_CHANGE(IDC_LEFT_EDIT, OnChangeLeftEdit)
	ON_EN_CHANGE(IDC_RIGHT_EDIT, OnChangeRightEdit)
	ON_EN_CHANGE(IDC_TOP_EDIT, OnChangeTopEdit)
	ON_EN_CHANGE(IDC_BOTTOM_EDIT, OnChangeBottomEdit)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CHOOSE_FONT_BTN, OnChooseFontBtn)
	ON_BN_CLICKED(IDC_FONT_COLOR_BTN, OnFontColorBtn)
	ON_BN_CLICKED(IDC_BORDER_COLOR_BTN, OnBorderColorBtn)
	ON_BN_CLICKED(IDC_FONT_FILL_COLOR_BTN, OnFontFillColorBtn)
	ON_BN_CLICKED(IDC_FONT_BOLD_CHECK, OnFontBoldCheck)
	ON_BN_CLICKED(IDC_FONT_ITALIC_CHECK, OnFontItalicCheck)
	ON_BN_CLICKED(IDC_LEFT_ALIGN_RADIO, OnLeftAlignRadio)
	ON_BN_CLICKED(IDC_MIDDLE_ALIGN_RADIO, OnMiddleAlignRadio)
	ON_BN_CLICKED(IDC_RIGHT_ALIGN_RADIO, OnRightAlignRadio)
	ON_EN_CHANGE(IDC_CHAR_SPACE_EDIT, OnChangeCharSpaceEdit)
	ON_EN_CHANGE(IDC_CHAR_HORZ_SCALE_EDIT, OnChangeCharHorzScaleEdit)
	ON_BN_CLICKED(IDC_CHANGE_TOOL, OnChangeTool)
	ON_CBN_SELCHANGE(IDC_LINK_ACTION_COMBO, OnSelchangeLinkActionCombo)
	ON_BN_CLICKED(IDC_CHOOSE_IMAGE_BTN, OnChooseImageBtn)
	ON_BN_CLICKED(IDC_ANNOT_INFO_BTN, OnAnnotInfoBtn)
	ON_BN_CLICKED(IDC_Reply_Module, OnReplyModule)
	ON_CBN_SELCHANGE(IDC_BORDER_STYLE_COMBO, OnSelchangeBorderStyleCombo)
	ON_CBN_SELCHANGE(IDC_LINE_START_STYLE_COMBO, OnSelchangeLineStartStyleCombo)
	ON_CBN_SELCHANGE(IDC_LINE_END_STYLE_COMBO, OnSelchangeLineEndStyleCombo)
	ON_EN_CHANGE(IDC_AUTHOR_EDIT, OnChangeAuthorEdit)
	ON_EN_CHANGE(IDC_SUBJECT_EDIT, OnChangeSubjectEdit)
	ON_BN_CLICKED(IDC_LOCK_CHECK, OnLockCheck)
	ON_BN_CLICKED(IDC_PRINT_CHECK, OnPrintCheck)
	ON_BN_CLICKED(IDC_READONLY_CHECK, OnReadonlyCheck)
	ON_BN_CLICKED(IDC_POPUP_CHECK, OnPopupCheck)
	ON_CBN_SELCHANGE(IDC_REVIEW_STATE_COMBO, OnSelchangeReviewStateCombo)
	ON_CBN_SELCHANGE(IDC_MARKED_STATE_COMBO, OnSelchangeMarkedStateCombo)
	ON_CBN_SELCHANGE(IDC_MIGRATION_STATE_COMBO, OnSelchangeMigrationStateCombo)
	ON_COMMAND(IDC_OK_BTN, OnOK)
	ON_EN_CHANGE(IDC_CONTENT_EDIT, OnChangeContentEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAX_Annot_DemoDlg message handlers

void CAX_Annot_DemoDlg::OnOK()
{
	return;
}

BOOL CAX_Annot_DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//use UnLockActiveX Method to UnLock ActiveX 
	m_fxAXSDK.UnLockActiveX(_T("SDKAXYX8331"),_T("436597C704578097D98FC1081E57A5704B073563"));

	GetClientRect(&m_rcOriginal);

	CRect rect;
	GetDlgItem(IDC_ANNOTS_STATIC)->GetWindowRect(&rect);
	SetWindowPos(&wndNoTopMost, 0, 0, m_rcOriginal.Width() - rect.Width(), m_rcOriginal.Height(), SWP_NOMOVE);

	for (int i = 1; i < 13; i++)
	{
		CString str;
		str.Format(_T("%d"), i);
		m_thickNessList.AddString(str);
	}
	CString str;
	CSize sz;
	CDC* pDC = m_thickNessList.GetDC();
	for (int j = 0; j < m_thickNessList.GetCount(); j++)
	{
		m_thickNessList.GetText(j, str);
		sz = pDC->GetTextExtent(str);
		m_thickNessList.SetItemHeight(j, sz.cy + 5);
	}
	m_thickNessList.ReleaseDC(pDC);

	m_opacitySlider.SetRange(0, 100);
	CheckRadioButton(IDC_LEFT_ALIGN_RADIO, IDC_RIGHT_ALIGN_RADIO, IDC_LEFT_ALIGN_RADIO);
	DisableAllCtrl();
	EnableFormatToolCtrl(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAX_Annot_DemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAX_Annot_DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAX_Annot_DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CAX_Annot_DemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CAX_Annot_DemoDlg)
	ON_EVENT(CAX_Annot_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 8 /* OnOpenDocument */, OnOnOpenDocumentFoxitpdfsdkproctrl1, VTS_BSTR)
	ON_EVENT(CAX_Annot_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 16 /* OnCloseDocument */, OnOnCloseDocumentFoxitpdfsdkproctrl1, VTS_BSTR)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CAX_Annot_DemoDlg::OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath) 
{
	// TODO: Add your control notification handler code here
	SetWindowPos(&wndNoTopMost, 0, 0, m_rcOriginal.Width() + 5, m_rcOriginal.Height() + 30, SWP_NOMOVE);
	int nPageCount = m_fxAXSDK.GetPageCount();
	CString str;
	for (int i = 0; i < nPageCount; i++)
	{
		str.Empty();
		str.Format(_T("%d"), i + 1);
		m_linkPageIndexCombo.AddString(str);
	}
}

//////////////////////////////////////////////////////////////////////////
/*
Cloudy: Thickness, BorderStyle(1-7), Color, FillColor, Opacity, Lock, Author, Subject, CreateDate, ModDate, Review, Migration ,Print, Description, ReadOnly
Arrow: Thickness, BorderStyle(1-7), Color, FillColor, Opacity, Lock, Author, Subject, CreateDate, ModDate, Review, Migration ,Print, Description, ReadOnly, Start, End
Line: As Arrow
Square: As Cloudy
Rectangle: As Cloudy
Circle: As Cloudy
Ellipse: As Cloudy
Polygon: As Cloudy + PolygonVertices
PolyLine: As Line
Pencil: PencilVertices + Thickness, Color, Opacity, Lock, Author, Subject, CreateDate, ModDate, Review, Migration, Print, Description, ReadOnly
Underline: Color, Opacity, Lock, Author, Subject, CreateDate, ModDate, Review, Migration ,Print, Description, ReadOnly
Highlight: As UnderLine
Squiggly: As UnderLine
StrikeOut: As UnderLine
Replace: As UnderLine
Caret: As UnderLine
Note: As UnderLine + Note Type
Typewriter: Opacity, Lock, Author, Subject, CreateDate, ModDate, Review, Migration ,Print, Description, ReadOnly
Callout: Thickness, BorderStyle(1-7), Color, Opacity, Lock, Author, Subject, CreateDate, ModDate, Review, Migration ,Print, Description, ReadOnly, Start
Textbox: As Callout
FileAttachment: Path + Color, Opacity, Lock, Author, Subject, CreateDate, ModDate, Review, Migration ,Print, Description, ReadOnly + Icon Type
Image: Path
Movie: Path
Sound: Path
Rectangle Link: LinkQuadPoints + Action
Quadrilateral Link: LinkQuadPoints + Action
*/
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
/** 
*sContentType may be these values:
*
*	</Movie>
*	application/futuresplash
*	application/x-shockwave-flash
*	video/avi
*	video/mpeg
*	video/msvideo
*	video/x-ivf
*	video/x-mpeg
*	video/x-ms-asf
*	video/x-ms-asx
*	video/x-ms-wm
*	video/x-ms-wmp
*	video/x-ms-wmv
*	video/x-ms-wmx
*	video/x-ms-wvx
*	video/x-msvideo
*	video/x-mpg
*	video/mpg
*	</Movie>

*	application/sdp
*	application/smil
*	application/x-rtsp
*	video/quicktime
*	video/flc
*	video/x-dv

*	<Sound>
*	audio/aiff
*	audio/basic
*	audio/mid
*	audio/midi
*	audio/mp3
*	audio/mpeg
*	audio/mpeg3
*	audio/mpegurl
*	audio/wav
*	audio/x-aiff
*	audio/x-midi
*	audio/x-mp3
*	audio/x-mpeg
*	audio/x-mpeg3
*	audio/x-mpegurl
*	audio/x-wav
*	audio/x-ms-wax
*	audio/x-ms-wma
*	</Sound>

*	application/sdp
*	application/smil
*	application/x-rtsp
*	audio/vnd.qcelp
*	audio/x-gsm
*	audio/x-m4a
*	audio/x-m4b
*	audio/x-m4p
*	audio/x-pn-realaudio
*	audio/scpls
*	audio/vnd.rn-realaudio
*	application/vnd.rn-realmedia
*	application/vnd.rn-realmedia-secure
*	application/vnd.rn-realsystem-rjs
*	application/vnd.rn-realsystem-mj
*	application/vnd.rn-rn_music_package
*	application/vnd.rn-realsystem-rp
*	application/vnd.rn-realsystem-rt
*/
//////////////////////////////////////////////////////////////////////////

void CAX_Annot_DemoDlg::OnAddAnnotBtn() 
{
	// TODO: Add your control notification handler code here

	long pageIndex = m_fxAXSDK.GetCurPage();
	//Get the Page Annotation Manager
	
	CPDFPageAnnots pPageAnnots = m_fxAXSDK.GetPageAnnots(pageIndex);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	int nCurSel = m_annotSubTypeCombo.GetCurSel();
	if (nCurSel == -1)
	{
		return;
	}

	if (7 != nCurSel&&9 != nCurSel)
	{
		if ( _wtol(m_strRightPos) <= _wtol(m_strLeftPos) || _wtol(m_strTopPos) <= _wtol(m_strBottomPos) )
		{
			MessageBox(_T("Please check the the Left,Top,Right and Bottom value.\n\nNote that the Right must be greater than the Left value,and the Top  must be greater than the  Bottom value,and all must be positive."));
			return;
		}
	}

	UpdateData(TRUE);
	switch (nCurSel)
	{
	case 3://Square
	case 5://Circle
		{
			if ((_wtol(m_strRightPos) - _wtol(m_strLeftPos)) != ((_wtol(m_strTopPos) - _wtol(m_strBottomPos))))
			{
				MessageBox(_T("Add annot failed.\n\nFor Square and Circle annot, note that Right minus Left be equal to Top minus Bottom." ));
				return;
			}
		}
		break;
	}
	CString strSubType;
	m_annotSubTypeCombo.GetLBText(nCurSel, strSubType);
	CPDFAnnot pAddAnnot;
	if(m_AnnotMap.Lookup(nCurSel, pAddAnnot))
	{
		if (pPageAnnots.GetAnnotIndex(pAddAnnot) == -1)
		{
			m_AnnotMap.RemoveKey(nCurSel);
		}
		else
		{
			return;
		}
	}
	
	//Add A Special Annotation to a page
	pAddAnnot = pPageAnnots.AddAnnot(NULL, strSubType, (float)_wtol(m_strLeftPos), (float)_wtol(m_strTopPos), \
					(float)_wtol(m_strRightPos), (float)_wtol(m_strBottomPos));
	if (!pAddAnnot)
	{
		MessageBox(_T("Add Annot failure"));
		return;
	}
	switch (nCurSel)
	{
	case 0:			//Cloudy
	case 3:			//Square		
	case 4:			//Rectangle	
	case 5:			//Circle		
	case 6:			//eEllips
	case 7:			//Polygon
		{
			SetSimilarSquareCtrlProperties(pAddAnnot);
			if (nCurSel == 7)
			{
				float pointArray[8] = {(float)_wtol(m_strLeftPos), (float)_wtol(m_strTopPos), (float)_wtol(m_strRightPos), \
					(float)_wtol(m_strBottomPos), (float)_wtol(m_strPoint3XPos), (float)_wtol(m_strPoint3YPos), \
					(float)_wtol(m_strPoint4XPos), (float)_wtol(m_strPoint4YPos)};
				//Set Polygon Annotation's appearance, this method is only for Polygon Annotation
				pAddAnnot.SetPolygonVertices((long)&pointArray[0], 4);
			}
		}
		break;

	case 1:			//Arrow
	case 2:			//Line		
	case 8:			//PolyLine
		SetSimilarArrowCtrlProperties(pAddAnnot);
		break;

	case 9:			//Pencil
		SetPencilCtrlProperties(pAddAnnot);
		break;

	case 10:		//Underline	
	case 11:		//Highlight	
	case 12:		//Squiggly	
	case 13:		//StrikeOut	
	case 14:		//Replace
	case 15:		//Caret	
	case 16:		//Note
		SetSimilarUnderLineCtrlProperties(pAddAnnot);
		break;

	case 17:		//Typewriter
		SetTypeWriterCtrlProperties(pAddAnnot);
		GetFormatToolParameters();
		break;

	case 18:		//Callout	
	case 19:		//Textbox
		SetSimilarTextBoxCtrlProperties(pAddAnnot);
		GetFormatToolParameters();
		break;

	case 20:		//FileAttachment	
	case 21:		//Image	
	case 22:		//Movie
	case 23:		//Sound
		if ((m_strFilePath.IsEmpty() && nCurSel != 21) || (m_mediaContentTypeCombo.GetCurSel() == -1 && nCurSel >= 22))
		{
			pPageAnnots.RemoveAnnot(pAddAnnot);
			if (m_strFilePath.IsEmpty())
			{
				MessageBox(_T("Please choose the Media file!"));
 			}
			else
			{
				MessageBox(_T("Please choose the Media type!"));
			}
			return;
		}
		if (m_strImagePath.IsEmpty() && nCurSel == 21)
		{
			pPageAnnots.RemoveAnnot(pAddAnnot);
			MessageBox(_T("Please choose the image file!"));
			return;
		}
		SetSimilarFilePathCtrlProperties(pAddAnnot);
		break;

	case 24:		//Rectangle Link	
	case 25:		//Quadrilateral Link
		SetSimilarLinkCtrlProperties(pAddAnnot);
		if (nCurSel == 25)
		{
			long pointArray[8] = {(long)_wtol(m_strLeftPos), (long)_wtol(m_strTopPos), (long)_wtol(m_strRightPos), \
				(long)_wtol(m_strBottomPos), (long)_wtol(m_strPoint3XPos), (long)_wtol(m_strPoint3YPos), \
					(long)_wtol(m_strPoint4XPos), (long)_wtol(m_strPoint4YPos)};
			//Set Link Annotation's appearance, this method is only for Link Annotation
			pAddAnnot.SetLinkQuadPoints((long)&pointArray[0], 4);
		}
		break;
	}
	m_AnnotMap.SetAt(nCurSel, pAddAnnot);
}

void CAX_Annot_DemoDlg::OnColorBtn() 
{
	// TODO: Add your control notification handler code here
	CColorDialog colorDlg;
	if (colorDlg.DoModal() == IDOK)
	{
		m_color = colorDlg.GetColor();
		CRect rect;
		GetDlgItem(IDC_COLOR_BTN)->GetWindowRect(&rect);
		ScreenToClient(&rect);
		InvalidateRect(&rect);
	}
}

HBRUSH CAX_Annot_DemoDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here

	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CAX_Annot_DemoDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	// TODO: Add your message handler code here and/or call default
	COLORREF color;
	if (nIDCtl == IDC_COLOR_BTN)
	{
		color = m_color;
	}
	else if (nIDCtl == IDC_FILL_COLOR_BTN)
	{
		color = m_fillColor;
	}
	else if (nIDCtl == IDC_FONT_COLOR_BTN)
	{
		color = m_fontColor;
	}
	else if (nIDCtl == IDC_BORDER_COLOR_BTN)
	{
		color = m_fontBorderColor;
	}
	else if (nIDCtl == IDC_FONT_FILL_COLOR_BTN)
	{
		color = m_fontFillColor;
	}
	if(nIDCtl == IDC_COLOR_BTN || nIDCtl == IDC_FILL_COLOR_BTN || nIDCtl == IDC_FONT_COLOR_BTN || \
		nIDCtl == IDC_BORDER_COLOR_BTN || nIDCtl == IDC_FONT_FILL_COLOR_BTN)      
    {
		CDC dc;
		RECT rect;
		dc.Attach(lpDrawItemStruct->hDC);
		
		rect = lpDrawItemStruct->rcItem;
		
		dc.Draw3dRect(&rect, color, RGB(0,0,0)); 
		
		dc.FillSolidRect(&rect, color);
		
		UINT state = lpDrawItemStruct->itemState; 
		
		if((state & ODS_SELECTED))
		{
			dc.DrawEdge(&rect, EDGE_SUNKEN, BF_RECT);
		}
		else
		{
			dc.DrawEdge(&rect, EDGE_RAISED, BF_RECT);
		}
		
		dc.SetBkColor(color);
		dc.SetTextColor(color);    
		
		TCHAR buffer[MAX_PATH];        
		ZeroMemory(buffer, MAX_PATH); 
        ::GetWindowText(lpDrawItemStruct->hwndItem, buffer, MAX_PATH);

		dc.DrawText(buffer, &rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		dc.Detach();  
    }                

	CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}

void CAX_Annot_DemoDlg::OnFillColorBtn() 
{
	// TODO: Add your control notification handler code here
	CColorDialog colorDlg;
	if (colorDlg.DoModal() == IDOK)
	{
		m_fillColor = colorDlg.GetColor();
		CRect rect;
		GetDlgItem(IDC_FILL_COLOR_BTN)->GetWindowRect(&rect);
		ScreenToClient(&rect);
		InvalidateRect(&rect);
	}
}

void CAX_Annot_DemoDlg::ClearAllCtrlContents()
{
	m_strLeftPos = "";
	m_strTopPos = "";
	m_strRightPos = "";
	m_strBottomPos = "";
	m_thickNessList.SetTopIndex(0);
	m_nBroderStyle = -1;
	m_color = RGB(255, 0, 0);
	m_fillColor = RGB(255, 255, 255);
	m_opacitySlider.SetPos(80);
	m_nOpacity = 80;
	m_nLineStartStyle = -1;
	m_nLineEndStyle = -1;
	m_strAuthor = "";
	m_strSubject = "";
	m_nReviewState = -1;
	m_nMarkedState = -1;
	m_nMigrationState = -1;
	m_bLockCheck = FALSE;
	m_bPrintCheck = FALSE;
	m_bPopupCheck = FALSE;
	m_bReadonlyCheck = FALSE;
	m_strDescription = "";
	m_strFilePath = "";
	m_strImagePath = "";
	m_mediaContentTypeCombo.ResetContent();
	m_mediaContentTypeCombo.SetCurSel(-1);
	m_bEmbedMedia = FALSE;
	m_bShowCtrlBar = FALSE;
	m_strContents = "";
	m_strCreateDate = "";
	m_strModifyDate = "";
	GetDlgItem(IDC_LEFT_POINT1)->SetWindowText(_T("Left:"));
	GetDlgItem(IDC_TOP_POINT2)->SetWindowText(_T("Top:"));
	GetDlgItem(IDC_RIGHT_POINT3)->SetWindowText(_T("Right:"));
	GetDlgItem(IDC_BOTTOM_POINT4)->SetWindowText(_T("Bottom:"));
	m_annotToolsCombo.SetCurSel(-1);
	m_linkActionTypeCombo.SetCurSel(-1);
	m_linkPageIndexCombo.SetCurSel(-1);
	m_strWebURL = "";
	m_strLinkActionPageLeft = "";
	m_strLinkActionPageTop = "";
	m_strPoint3XPos = "";
	m_strPoint3YPos = "";
	m_strPoint4XPos = "";
	m_strPoint4YPos = "";
	UpdateData(FALSE);
}

void CAX_Annot_DemoDlg::DisableAllCtrl()
{
	GetDlgItem(IDC_LEFT_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_TOP_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_RIGHT_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_BOTTOM_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_THICKNESS_LIST)->EnableWindow(FALSE);
	GetDlgItem(IDC_BORDER_STYLE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_COLOR_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_FILL_COLOR_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_OPACITY_SLIDER)->EnableWindow(FALSE);
	GetDlgItem(IDC_OPACITY_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_LINE_START_STYLE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_LINE_END_STYLE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_AUTHOR_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_SUBJECT_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_REVIEW_STATE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_MARKED_STATE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_MIGRATION_STATE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_LOCK_CHECK)->EnableWindow(FALSE);
	GetDlgItem(IDC_PRINT_CHECK)->EnableWindow(FALSE);
	GetDlgItem(IDC_READONLY_CHECK)->EnableWindow(FALSE);
	GetDlgItem(IDC_POPUP_CHECK)->EnableWindow(FALSE);
	GetDlgItem(IDC_DESCRIPTION_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHOOSE_FILE_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHOOSE_IMAGE_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_ADD_ANNOT_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_REMOVE_ANNOT_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_MODIFY_ANNOT_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_CONTENT_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_MEDIA_CONTENTTYPE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_EMBED_MEDIA_CHECK)->EnableWindow(FALSE);
	GetDlgItem(IDC_SHOW_CTRL_BAR_CHECK)->EnableWindow(FALSE);
	GetDlgItem(IDC_LINK_ACTION_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_WEB_URL_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_PAGE_INDEX_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_LINK_ACTION_LEFT)->EnableWindow(FALSE);
	GetDlgItem(IDC_LINK_ACTION_TOP)->EnableWindow(FALSE);
	GetDlgItem(IDC_POINT3_X_STATIC)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_POINT3_Y_STATIC)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_POINT4_X_STATIC)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_POINT4_Y_STATIC)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_POINT3_X_POS)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_POINT3_Y_POS)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_POINT4_X_POS)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_POINT4_Y_POS)->ShowWindow(SW_HIDE);	
}

void CAX_Annot_DemoDlg::EnableSimialSquareCtrl(BOOL bEnable)
{
	GetDlgItem(IDC_LEFT_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_TOP_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_RIGHT_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_BOTTOM_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_THICKNESS_LIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_BORDER_STYLE_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_COLOR_BTN)->EnableWindow(bEnable);
	GetDlgItem(IDC_FILL_COLOR_BTN)->EnableWindow(bEnable);
	GetDlgItem(IDC_OPACITY_SLIDER)->EnableWindow(bEnable);
	GetDlgItem(IDC_OPACITY_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_AUTHOR_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_SUBJECT_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_REVIEW_STATE_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_MARKED_STATE_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_MIGRATION_STATE_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_LOCK_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_PRINT_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_READONLY_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_POPUP_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_CONTENT_EDIT)->EnableWindow(bEnable);
}

void CAX_Annot_DemoDlg::GetTime_TimeZoom(CPDFAnnot pPDFAnnot)
{
	DATE nCreateDate = pPDFAnnot.GetCreatationDate();
	COleDateTime pDateTime(nCreateDate);
	TIME_ZONE_INFORMATION tzi;
	GetTimeZoneInformation(&tzi);
	m_strCreateDate.Format(_T("%d-%02d-%02d %02d:%02d:%02d +%02d:%02d"), pDateTime.GetYear(), pDateTime.GetMonth(), pDateTime.GetDay(), pDateTime.GetHour(), \
		pDateTime.GetMinute(), pDateTime.GetSecond(), tzi.Bias/ -60, 0);
	
	DATE nModifyDate = pPDFAnnot.GetModificationDate();
	pDateTime = nModifyDate;
	m_strModifyDate.Format(_T("%d-%02d-%02d %02d:%02d:%02d +%02d:%02d"), pDateTime.GetYear(), pDateTime.GetMonth(), pDateTime.GetDay(), pDateTime.GetHour(), \
		pDateTime.GetMinute(), pDateTime.GetSecond(), tzi.Bias/ -60, 0);
	UpdateData(FALSE);
}

void CAX_Annot_DemoDlg::SetSimilarSquareCtrlProperties(CPDFAnnot pPDFAnnot)
{
	//Set the Annotation's Properties
	pPDFAnnot.SetThickness(m_thickNessList.GetTopIndex() + 1);
	pPDFAnnot.SetBorderStyle(m_nBroderStyle + 1);
	pPDFAnnot.SetColor(m_color);
	pPDFAnnot.SetFillColor(m_fillColor);
	pPDFAnnot.SetOpacity(m_nOpacity);
	pPDFAnnot.SetAuthor(m_strAuthor);
	pPDFAnnot.SetSubject(m_strSubject);
	pPDFAnnot.SetReviewState(m_nReviewState);
	pPDFAnnot.SetMarkedState(m_nMarkedState);
	pPDFAnnot.SetMigrationState(m_nMigrationState);
	pPDFAnnot.SetLocked(m_bLockCheck);
	pPDFAnnot.SetPrint(m_bPrintCheck);
	pPDFAnnot.SetReadOnly(m_bReadonlyCheck);
	pPDFAnnot.SetPopupOpen(m_bPopupCheck);
	pPDFAnnot.SetDescription(m_strDescription);
	pPDFAnnot.SetContents(m_strContents);

	GetTime_TimeZoom(pPDFAnnot);
}

void CAX_Annot_DemoDlg::EnableSimilarArrowCtrl(BOOL bEnable)
{
	EnableSimialSquareCtrl(bEnable);
	GetDlgItem(IDC_LINE_START_STYLE_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_LINE_END_STYLE_COMBO)->EnableWindow(bEnable);
}

void CAX_Annot_DemoDlg::SetSimilarArrowCtrlProperties(CPDFAnnot pPdfAnnot)
{
	SetSimilarSquareCtrlProperties(pPdfAnnot);
	pPdfAnnot.SetLineStartingStyle(m_nLineStartStyle);
	pPdfAnnot.SetLineEndingStyle(m_nLineEndStyle);
}

void CAX_Annot_DemoDlg::EnableSimilarUnderLineCtrl(BOOL bEnable)
{
	EnableSimialSquareCtrl(bEnable);
	GetDlgItem(IDC_THICKNESS_LIST)->EnableWindow(FALSE);
	GetDlgItem(IDC_BORDER_STYLE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_FILL_COLOR_BTN)->EnableWindow(FALSE);
}

void CAX_Annot_DemoDlg::SetSimilarUnderLineCtrlProperties(CPDFAnnot pPDFAnnot)
{
	//Set the Annotation's Properties
	pPDFAnnot.SetColor(m_color);
	pPDFAnnot.SetOpacity(m_nOpacity);
	pPDFAnnot.SetAuthor(m_strAuthor);
	pPDFAnnot.SetSubject(m_strSubject);
	pPDFAnnot.SetReviewState(m_nReviewState);
	pPDFAnnot.SetMarkedState(m_nMarkedState);
	pPDFAnnot.SetMigrationState(m_nMigrationState);
	pPDFAnnot.SetLocked(m_bLockCheck);
	pPDFAnnot.SetPrint(m_bPrintCheck);
	pPDFAnnot.SetReadOnly(m_bReadonlyCheck);
	pPDFAnnot.SetPopupOpen(m_bPopupCheck);
	pPDFAnnot.SetDescription(m_strDescription);
	pPDFAnnot.SetContents(m_strContents);
	
	GetTime_TimeZoom(pPDFAnnot);
}

void CAX_Annot_DemoDlg::EnableTypeWriterCtrl(BOOL bEnable)
{
	EnableSimialSquareCtrl(bEnable);
	GetDlgItem(IDC_THICKNESS_LIST)->EnableWindow(FALSE);
	GetDlgItem(IDC_BORDER_STYLE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_COLOR_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_FILL_COLOR_BTN)->EnableWindow(FALSE);		
}

void CAX_Annot_DemoDlg::SetTypeWriterCtrlProperties(CPDFAnnot pPDFAnnot)
{
	//Set the Annotation's Properties
	pPDFAnnot.SetOpacity(m_nOpacity);
	pPDFAnnot.SetAuthor(m_strAuthor);
	pPDFAnnot.SetSubject(m_strSubject);
	pPDFAnnot.SetReviewState(m_nReviewState);
	pPDFAnnot.SetMarkedState(m_nMarkedState);
	pPDFAnnot.SetMigrationState(m_nMigrationState);
	pPDFAnnot.SetLocked(m_bLockCheck);
	pPDFAnnot.SetPrint(m_bPrintCheck);
	pPDFAnnot.SetReadOnly(m_bReadonlyCheck);
	pPDFAnnot.SetPopupOpen(m_bPopupCheck);
	pPDFAnnot.SetDescription(m_strDescription);
	pPDFAnnot.SetContents(m_strContents);
	
	GetTime_TimeZoom(pPDFAnnot);
}

void CAX_Annot_DemoDlg::EnableSimilarTextBoxCtrl(BOOL bEnable)
{
	EnableSimialSquareCtrl(bEnable);
	GetDlgItem(IDC_LINE_START_STYLE_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_FILL_COLOR_BTN)->EnableWindow(FALSE);
}

void CAX_Annot_DemoDlg::SetSimilarTextBoxCtrlProperties(CPDFAnnot pPDFAnnot)
{
	//Set the Annotation's Properties
	pPDFAnnot.SetThickness(m_thickNessList.GetTopIndex() + 1);
	pPDFAnnot.SetBorderStyle(m_nBroderStyle + 1);
	pPDFAnnot.SetColor(m_color);
	pPDFAnnot.SetOpacity(m_nOpacity);
	pPDFAnnot.SetAuthor(m_strAuthor);
	pPDFAnnot.SetSubject(m_strSubject);
	pPDFAnnot.SetReviewState(m_nReviewState);
	pPDFAnnot.SetMarkedState(m_nMarkedState);
	pPDFAnnot.SetMigrationState(m_nMigrationState);
	pPDFAnnot.SetLocked(m_bLockCheck);
	pPDFAnnot.SetPrint(m_bPrintCheck);
	pPDFAnnot.SetReadOnly(m_bReadonlyCheck);
	pPDFAnnot.SetPopupOpen(m_bPopupCheck);
	pPDFAnnot.SetDescription(m_strDescription);
	pPDFAnnot.SetContents(m_strContents);
	
	GetTime_TimeZoom(pPDFAnnot);
}

void CAX_Annot_DemoDlg::EnableSimilarFilePathCtrl(BOOL bEnable)
{
	EnableSimilarUnderLineCtrl(bEnable);
}

void CAX_Annot_DemoDlg::SetSimilarFilePathCtrlProperties(CPDFAnnot pPDFAnnot)
{
	//Set the Annotation's Properties
	pPDFAnnot.SetColor(m_color);
	pPDFAnnot.SetOpacity(m_nOpacity);
	pPDFAnnot.SetAuthor(m_strAuthor);
	pPDFAnnot.SetSubject(m_strSubject);
	pPDFAnnot.SetReviewState(m_nReviewState);
	pPDFAnnot.SetMarkedState(m_nMarkedState);
	pPDFAnnot.SetMigrationState(m_nMigrationState);
	pPDFAnnot.SetPrint(m_bPrintCheck);
	pPDFAnnot.SetPopupOpen(m_bPopupCheck);
	pPDFAnnot.SetDescription(m_strDescription);
	pPDFAnnot.SetContents(m_strContents);
	
	GetTime_TimeZoom(pPDFAnnot);

	int nCurSel = m_annotSubTypeCombo.GetCurSel();

	switch (nCurSel)
	{
	case 20:		//FileAttachment
		pPDFAnnot.AttachFile(m_strFilePath);
		break;

	case 21:		//Image	
		pPDFAnnot.SetMediaPoster(m_strImagePath);
		break;

	case 22:		//Movie
	case 23:		//Sound
		{
			int nMediaSel = m_mediaContentTypeCombo.GetCurSel();
			CString str;
			m_mediaContentTypeCombo.GetLBText(nMediaSel, str);
			pPDFAnnot.SetMediaPoster(m_strImagePath);
			pPDFAnnot.SetMultimedia(m_strFilePath, str, m_bEmbedMedia, m_bShowCtrlBar);
		}
		break;
	}
}

void CAX_Annot_DemoDlg::EnablePencilCtrl(BOOL bEnable)
{
	EnableSimialSquareCtrl(bEnable);
	GetDlgItem(IDC_BORDER_STYLE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_FILL_COLOR_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_LEFT_POINT1)->SetWindowText(_T("x1:"));
	GetDlgItem(IDC_TOP_POINT2)->SetWindowText(_T("y1:"));
	GetDlgItem(IDC_RIGHT_POINT3)->SetWindowText(_T("x2:"));
	GetDlgItem(IDC_BOTTOM_POINT4)->SetWindowText(_T("y2:"));
	GetDlgItem(IDC_POINT3_X_STATIC)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_POINT3_Y_STATIC)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_POINT4_X_STATIC)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_POINT4_Y_STATIC)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_POINT3_X_POS)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_POINT3_Y_POS)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_POINT4_X_POS)->ShowWindow(SW_SHOW);
	GetDlgItem(IDC_POINT4_Y_POS)->ShowWindow(SW_SHOW);	
}

void CAX_Annot_DemoDlg::SetPencilCtrlProperties(CPDFAnnot pPDFAnnot)
{
	//Set the Annotation's Properties
	pPDFAnnot.SetThickness(m_thickNessList.GetTopIndex() + 1);
	pPDFAnnot.SetColor(m_color);
	pPDFAnnot.SetOpacity(m_nOpacity);
	pPDFAnnot.SetAuthor(m_strAuthor);
	pPDFAnnot.SetSubject(m_strSubject);
	pPDFAnnot.SetReviewState(m_nReviewState);
	pPDFAnnot.SetMarkedState(m_nMarkedState);
	pPDFAnnot.SetMigrationState(m_nMigrationState);
	pPDFAnnot.SetLocked(m_bLockCheck);
	pPDFAnnot.SetPrint(m_bPrintCheck);
	pPDFAnnot.SetReadOnly(m_bReadonlyCheck);
	pPDFAnnot.SetPopupOpen(m_bPopupCheck);
	pPDFAnnot.SetDescription(m_strDescription);
	pPDFAnnot.SetContents(m_strContents);


	float pointArray[8] = {(float)_wtol(m_strLeftPos), (float)_wtol(m_strTopPos), (float)_wtol(m_strRightPos), \
		(float)_wtol(m_strBottomPos), (float)_wtol(m_strPoint3XPos), (float)_wtol(m_strPoint3YPos), \
					(float)_wtol(m_strPoint4XPos), (float)_wtol(m_strPoint4YPos)};
	//Set Pencil Annotation's appearance, this method is only for pencil Annotation
	pPDFAnnot.SetPencilVertices((long)&pointArray[0], 4);

	GetTime_TimeZoom(pPDFAnnot);
}

void CAX_Annot_DemoDlg::EnableSimilarLinkCtrl(BOOL bEnable)
{
	EnableSimialSquareCtrl(bEnable);
//	GetDlgItem(IDC_BORDER_STYLE_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_FILL_COLOR_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_LINK_ACTION_COMBO)->EnableWindow(TRUE);
	GetDlgItem(IDC_AUTHOR_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_SUBJECT_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_POPUP_CHECK)->EnableWindow(FALSE);
}

void CAX_Annot_DemoDlg::SetSimilarLinkCtrlProperties(CPDFAnnot pPDFAnnot)
{
	//Set the Annotation's Properties
	pPDFAnnot.SetThickness(m_thickNessList.GetTopIndex() + 1);
	pPDFAnnot.SetColor(m_color);
	pPDFAnnot.SetOpacity(m_nOpacity);
	pPDFAnnot.SetAuthor(m_strAuthor);
	pPDFAnnot.SetSubject(m_strSubject);
	pPDFAnnot.SetReviewState(m_nReviewState);
	pPDFAnnot.SetMarkedState(m_nMarkedState);
	pPDFAnnot.SetMigrationState(m_nMigrationState);
	pPDFAnnot.SetPrint(m_bPrintCheck);
	pPDFAnnot.SetPopupOpen(m_bPopupCheck);
	pPDFAnnot.SetDescription(m_strDescription);
	pPDFAnnot.SetContents(m_strContents);
	
	GetTime_TimeZoom(pPDFAnnot);

	int nCurSel = m_linkActionTypeCombo.GetCurSel();
	if (nCurSel == 0)
	{
		int nPageIndex = m_linkPageIndexCombo.GetCurSel();
		//Set Link Annotation's Action
		pPDFAnnot.SetLinkGoToAction(nPageIndex, (float)_wtol(m_strLinkActionPageLeft), (float)_wtol(m_strLinkActionPageTop), 1);
	}
	else
	{
		UpdateData(TRUE);
		if (!m_strWebURL.IsEmpty())
		{
			//Set Link Annotation's Action
			pPDFAnnot.SetLinkURLAction(m_strWebURL);
		}
	}
}

void CAX_Annot_DemoDlg::OnSelchangeAnnotSubtypeCombo() 
{
	// TODO: Add your control notification handler code here
	int nCurSel = m_annotSubTypeCombo.GetCurSel();
	ClearAllCtrlContents();
	DisableAllCtrl();
	switch (nCurSel)
	{
	case 0:			//Cloudy
	case 3:			//Square		
	case 4:			//Rectangle	
	case 5:			//Circle		
	case 6:			//Ellipse
	case 7:			//Polygon
		EnableFormatToolCtrl(FALSE);
		EnableSimialSquareCtrl(TRUE);
		if (nCurSel == 7)
		{
			GetDlgItem(IDC_LEFT_POINT1)->SetWindowText(_T("x1:"));
			GetDlgItem(IDC_TOP_POINT2)->SetWindowText(_T("y1:"));
			GetDlgItem(IDC_RIGHT_POINT3)->SetWindowText(_T("x2:"));
			GetDlgItem(IDC_BOTTOM_POINT4)->SetWindowText(_T("y2:"));
			GetDlgItem(IDC_POINT3_X_STATIC)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT3_Y_STATIC)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT4_X_STATIC)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT4_Y_STATIC)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT3_X_POS)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT3_Y_POS)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT4_X_POS)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT4_Y_POS)->ShowWindow(SW_SHOW);	
		}
		break;

	case 1:			//Arrow
	case 2:			//Line		
	case 8:			//PolyLine
		EnableFormatToolCtrl(FALSE);
		EnableSimilarArrowCtrl(TRUE);
		break;
		
	case 9:			//Pencil
		EnableFormatToolCtrl(FALSE);
		EnablePencilCtrl(TRUE);
		break;

	case 10:		//Underline	
	case 11:		//Highlight	
	case 12:		//Squiggly	
	case 13:		//StrikeOut	
	case 14:		//Replace
	case 15:		//Caret	
	case 16:		//Note
		EnableFormatToolCtrl(FALSE);
		EnableSimilarUnderLineCtrl(TRUE);
		break;
		
	case 17:		//Typewriter
		EnableFormatToolCtrl(TRUE);
		GetFormatToolParameters();
		EnableTypeWriterCtrl(TRUE);
		break;
		
	case 18:		//Callout	
	case 19:		//Textbox
		EnableFormatToolCtrl(TRUE);
		GetFormatToolParameters();
		EnableSimilarTextBoxCtrl(TRUE);
		if (nCurSel == 19)
		{
			GetDlgItem(IDC_LINE_START_STYLE_COMBO)->EnableWindow(FALSE);
		}
		break;

	case 20:		//FileAttachment	
	case 21:		//Image	
	case 22:		//Movie
	case 23:		//Sound
		EnableFormatToolCtrl(FALSE);
		EnableSimilarFilePathCtrl(TRUE);
		if (nCurSel == 20)
		{
			GetDlgItem(IDC_DESCRIPTION_EDIT)->EnableWindow(TRUE);
			GetDlgItem(IDC_CHOOSE_FILE_BTN)->EnableWindow(TRUE);
		}	
		else if (nCurSel == 21)
		{
			GetDlgItem(IDC_CHOOSE_IMAGE_BTN)->EnableWindow(TRUE);
		}
		else if (nCurSel == 22)
		{
			GetDlgItem(IDC_MEDIA_CONTENTTYPE_COMBO)->EnableWindow(TRUE);
			GetDlgItem(IDC_EMBED_MEDIA_CHECK)->EnableWindow(TRUE);
			GetDlgItem(IDC_SHOW_CTRL_BAR_CHECK)->EnableWindow(TRUE);
			GetDlgItem(IDC_CHOOSE_FILE_BTN)->EnableWindow(TRUE);
			GetDlgItem(IDC_CHOOSE_IMAGE_BTN)->EnableWindow(TRUE);
			SetMediaContentType(TRUE);
		}
		else if (nCurSel == 23)
		{
			GetDlgItem(IDC_MEDIA_CONTENTTYPE_COMBO)->EnableWindow(TRUE);
			GetDlgItem(IDC_EMBED_MEDIA_CHECK)->EnableWindow(TRUE);
			GetDlgItem(IDC_SHOW_CTRL_BAR_CHECK)->EnableWindow(TRUE);
			GetDlgItem(IDC_CHOOSE_FILE_BTN)->EnableWindow(TRUE);
			GetDlgItem(IDC_CHOOSE_IMAGE_BTN)->EnableWindow(TRUE);
			SetMediaContentType(FALSE);
		}

		if (nCurSel != 20)
		{
			GetDlgItem(IDC_AUTHOR_EDIT)->EnableWindow(FALSE);
			GetDlgItem(IDC_SUBJECT_EDIT)->EnableWindow(FALSE);
			GetDlgItem(IDC_POPUP_CHECK)->EnableWindow(FALSE);
			GetDlgItem(IDC_BORDER_STYLE_COMBO)->EnableWindow(TRUE);
		}
		break;
		
	case 24:		//Rectangle Link
	case 25:		//Quadrilateral Link
		EnableFormatToolCtrl(FALSE);
		EnableSimilarLinkCtrl(TRUE);
		if (nCurSel == 25)
		{
			GetDlgItem(IDC_LEFT_POINT1)->SetWindowText(_T("x1:"));
			GetDlgItem(IDC_TOP_POINT2)->SetWindowText(_T("y1:"));
			GetDlgItem(IDC_RIGHT_POINT3)->SetWindowText(_T("x2:"));
			GetDlgItem(IDC_BOTTOM_POINT4)->SetWindowText(_T("y2:"));
			GetDlgItem(IDC_POINT3_X_STATIC)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT3_Y_STATIC)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT4_X_STATIC)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT4_Y_STATIC)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT3_X_POS)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT3_Y_POS)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT4_X_POS)->ShowWindow(SW_SHOW);
			GetDlgItem(IDC_POINT4_Y_POS)->ShowWindow(SW_SHOW);	
		}
		break;

	default:
		EnableFormatToolCtrl(FALSE);
		break;
	}
	GetDlgItem(IDC_ADD_ANNOT_BTN)->EnableWindow(TRUE);
	GetDlgItem(IDC_REMOVE_ANNOT_BTN)->EnableWindow(TRUE);
	GetDlgItem(IDC_MODIFY_ANNOT_BTN)->EnableWindow(TRUE);
	if (CheckAnnotAddin())
	{
		return;
	}
	m_opacitySlider.SetPos(80);
	m_nOpacity = 80;
	UpdateData(FALSE);
}

void CAX_Annot_DemoDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	if (pScrollBar->GetDlgCtrlID() == IDC_OPACITY_SLIDER)
	{
		int pos = m_opacitySlider.GetPos();
		m_nOpacity = pos;
		UpdateData(FALSE);
	}
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CAX_Annot_DemoDlg::OnChangeOpacityEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_nOpacity >= 100)
	{
		m_nOpacity = 100;
	}
	m_opacitySlider.SetPos(m_nOpacity);
	UpdateData(FALSE);
}

void CAX_Annot_DemoDlg::OnOnCloseDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath) 
{
	// TODO: Add your control notification handler code here
	ClearAllCtrlContents();
	m_annotSubTypeCombo.SetCurSel(-1);
	m_linkPageIndexCombo.ResetContent();
	m_AnnotMap.RemoveAll();
	if(m_pAnnotRepleDlg)
	{
		m_pAnnotRepleDlg->Close();
		delete m_pAnnotRepleDlg;
		m_pAnnotRepleDlg = NULL;
	}
	
	//DisableAllCtrl();
//	m_pAnnotRepleDlg->OnClose();
	CRect rect;
	GetDlgItem(IDC_ANNOTS_STATIC)->GetWindowRect(&rect);
	SetWindowPos(&wndNoTopMost, 0, 0, m_rcOriginal.Width() - rect.Width(), m_rcOriginal.Height(), SWP_NOMOVE);
}

void CAX_Annot_DemoDlg::OnRemoveAnnotBtn() 
{
	// TODO: Add your control notification handler code here
	long pageIndex = m_fxAXSDK.GetCurPage();
	CPDFPageAnnots pPageAnnots = m_fxAXSDK.GetPageAnnots(pageIndex);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	CPDFAnnot pAddAnnot;
	int nCurSel = m_annotSubTypeCombo.GetCurSel();
	if(m_AnnotMap.Lookup(nCurSel, pAddAnnot))
	{
		//remove a special Annotation from a page
		if (pPageAnnots.GetAnnotIndex(pAddAnnot) != -1)
		{
			pPageAnnots.RemoveAnnot(pAddAnnot);
		}
		m_AnnotMap.RemoveKey(nCurSel);
		ClearAllCtrlContents();
		m_annotSubTypeCombo.SetCurSel(-1);
		DisableAllCtrl();
	}
}

void CAX_Annot_DemoDlg::OnModifyAnnotBtn() 
{
	// TODO: Add your control notification handler code here
	long pageIndex = m_fxAXSDK.GetCurPage();
	CPDFPageAnnots pPageAnnots = m_fxAXSDK.GetPageAnnots(pageIndex);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	CPDFAnnot pAddAnnot;
	int nCurSel = m_annotSubTypeCombo.GetCurSel();
	if(m_AnnotMap.Lookup(nCurSel, pAddAnnot))
	{
		if (pPageAnnots.GetAnnotIndex(pAddAnnot) != -1)
		{
			ModifyAnnotParameters(pAddAnnot);
		}
		else
		{
			m_AnnotMap.RemoveKey(nCurSel);
			ClearAllCtrlContents();
			m_annotSubTypeCombo.SetCurSel(-1);
			DisableAllCtrl();
		}
	}
}

void CAX_Annot_DemoDlg::OnChooseFileBtn() 
{
	// TODO: Add your control notification handler code here
	CFileDialog chooseFile(TRUE);
	if (IDOK == chooseFile.DoModal())
	{
		UpdateData(TRUE);
		m_strFilePath = chooseFile.GetPathName();
		UpdateData(FALSE);
	}
}

void CAX_Annot_DemoDlg::OnChangeLeftEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnChangeRightEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnChangeTopEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnChangeBottomEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	ClearAllCtrlContents();
	m_annotSubTypeCombo.SetCurSel(-1);
	m_AnnotMap.RemoveAll();
	DisableAllCtrl();
	if (NULL != m_pAnnotInfoDlg)
	{
		delete m_pAnnotInfoDlg;
		m_pAnnotInfoDlg = NULL;
	}
	CDialog::OnClose();
}

void CAX_Annot_DemoDlg::OnChooseFontBtn() 
{
	// TODO: Add your control notification handler code here
	CFontDialog chooseFont;
	if (IDOK == chooseFont.DoModal())
	{
		m_strFontName = chooseFont.GetFaceName();
		m_strFontSize.Format(_T("%d"), chooseFont.GetSize() / 10);

		//Set the Format Tool's Properties
		CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
		if (pFormatTool.GetFontBoldEnable())
		{
			m_bFontBold = chooseFont.IsBold();
			pFormatTool.SetFontBold(m_bFontBold);
		}
		if (pFormatTool.GetFontItalicEnable())
		{
			m_bFontItalic = chooseFont.IsItalic();
			pFormatTool.SetFontItalic(m_bFontItalic);
		}
		pFormatTool.SetFontName(m_strFontName);
		pFormatTool.SetFontSize((float)(chooseFont.GetSize() / 10));
		UpdateData(FALSE);
	}
}

void CAX_Annot_DemoDlg::EnableFormatToolCtrl(BOOL bEnable)
{
	ClearFormatToolCtrlContents();
	GetDlgItem(IDC_FONT_NAME_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_FONT_SIZE_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_FONT_COLOR_BTN)->EnableWindow(bEnable);
	GetDlgItem(IDC_BORDER_COLOR_BTN)->EnableWindow(bEnable);
	GetDlgItem(IDC_FONT_FILL_COLOR_BTN)->EnableWindow(bEnable);
	GetDlgItem(IDC_LEFT_ALIGN_RADIO)->EnableWindow(bEnable);
	GetDlgItem(IDC_MIDDLE_ALIGN_RADIO)->EnableWindow(bEnable);
	GetDlgItem(IDC_RIGHT_ALIGN_RADIO)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHAR_SPACE_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHAR_HORZ_SCALE_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_FONT_BOLD_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_FONT_ITALIC_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHOOSE_FONT_BTN)->EnableWindow(bEnable);
}

void CAX_Annot_DemoDlg::ClearFormatToolCtrlContents()
{
	m_strFontName = _T("");
	m_strFontSize = _T("");
	m_fontColor = RGB(255, 255, 255);
	m_fontBorderColor = RGB(255, 255, 255);
	m_fontFillColor = RGB(255, 255, 255);
	m_nAlignStyle = 0;
	m_strCharSpace = _T("");
	m_strCharHorzScale = _T("");
	m_bFontBold = FALSE;
	m_bFontItalic = FALSE;
	UpdateData(FALSE);
}

BOOL CAX_Annot_DemoDlg::CheckAnnotAddin()
{
	long pageIndex = m_fxAXSDK.GetCurPage();
	CPDFPageAnnots pPageAnnots = m_fxAXSDK.GetPageAnnots(pageIndex);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return FALSE;
	}
	CPDFAnnot pAddAnnot;
	int nCurSel = m_annotSubTypeCombo.GetCurSel();
	if(m_AnnotMap.Lookup(nCurSel, pAddAnnot))
	{
		if (pPageAnnots.GetAnnotIndex(pAddAnnot) != -1)
		{
			SetAnnotParametersInCtrl(pAddAnnot);
		}	
		return TRUE;
	}
	return FALSE;
}

void CAX_Annot_DemoDlg::SetAnnotParametersInCtrl(CPDFAnnot pPDFAnnot)
{
	ClearAllCtrlContents();
	float left = 0, top = 0, right = 0, bottom = 0;
	pPDFAnnot.GetRect(&left, &top, &right, &bottom);
	m_strLeftPos.Format(_T("%.0f"), left);
	m_strTopPos.Format(_T("%.0f"), left);
	m_strRightPos.Format(_T("%.0f"), right);
	m_strBottomPos.Format(_T("%.0f"), bottom);
	m_thickNessList.SetTopIndex(pPDFAnnot.GetThickness() - 1);
	m_nBroderStyle = pPDFAnnot.GetBorderStyle() - 1;
	m_color = pPDFAnnot.GetColor();
	m_fillColor = pPDFAnnot.GetFillColor();
	m_nOpacity = pPDFAnnot.GetOpacity();
	m_opacitySlider.SetPos(m_nOpacity);
	m_nLineStartStyle = pPDFAnnot.GetLineStartingStyle();
	m_nLineEndStyle = pPDFAnnot.GetLineEndingStyle();
	m_strAuthor = pPDFAnnot.GetAuthor();
	m_strSubject = pPDFAnnot.GetSubject();
	m_nReviewState = pPDFAnnot.GetReviewState();
	m_nMarkedState = pPDFAnnot.GetMarkedState();
	m_nMigrationState = pPDFAnnot.GetMigrationState();
	m_bLockCheck = pPDFAnnot.GetLocked();
	m_bReadonlyCheck = pPDFAnnot.GetReadOnly();
	m_bPopupCheck = pPDFAnnot.IsPopupOpen();
	m_bPrintCheck = pPDFAnnot.GetPrint();
	m_strContents = pPDFAnnot.GetContents();
	m_strDescription = pPDFAnnot.GetDescription();
	UpdateData(FALSE);
	GetTime_TimeZoom(pPDFAnnot);
	Invalidate(FALSE);
}

void CAX_Annot_DemoDlg::ModifyAnnotParameters(CPDFAnnot pPDFAnnot)
{
	UpdateData(TRUE);
	//pPDFAnnot.SetRect((float)_wtol(m_strLeftPos), (float)_wtol(m_strTopPos), (float)_wtol(m_strRightPos), (float)_wtol(m_strBottomPos));
	pPDFAnnot.SetThickness(m_thickNessList.GetTopIndex() + 1);
	pPDFAnnot.SetBorderStyle(m_nBroderStyle + 1);
	pPDFAnnot.SetColor(m_color);
	pPDFAnnot.SetFillColor(m_fillColor);
	pPDFAnnot.SetOpacity(m_nOpacity);
	pPDFAnnot.SetLineStartingStyle(m_nLineStartStyle);
	pPDFAnnot.SetLineEndingStyle(m_nLineEndStyle);
	pPDFAnnot.SetAuthor(m_strAuthor);
	pPDFAnnot.SetSubject(m_strSubject);
	pPDFAnnot.SetReviewState(m_nReviewState);
	pPDFAnnot.SetMarkedState(m_nMarkedState);
	pPDFAnnot.SetMigrationState(m_nMigrationState);
	pPDFAnnot.SetPrint(m_bPrintCheck);
	pPDFAnnot.SetPopupOpen(m_bPopupCheck);
	pPDFAnnot.SetContents(m_strContents);
	pPDFAnnot.SetDescription(m_strDescription);

	if (pPDFAnnot.GetSubType() == _T("Pencil"))
	{
		long pointArray[8] = {(long)_wtol(m_strLeftPos), (long)_wtol(m_strTopPos), (long)_wtol(m_strRightPos), \
			(long)_wtol(m_strBottomPos), (long)_wtol(m_strPoint3XPos), (long)_wtol(m_strPoint3YPos), \
			(long)_wtol(m_strPoint4XPos), (long)_wtol(m_strPoint4YPos)};
		//Set Pencil Annotation's appearance, this method is only for pencil Annotation
		pPDFAnnot.SetPencilVertices((long)&pointArray[0], 4);
	}

	if (pPDFAnnot.GetSubType() == _T("Polygon"))
	{
		long pointArray[8] = {(long)_wtol(m_strLeftPos), (long)_wtol(m_strTopPos), (long)_wtol(m_strRightPos), \
			(long)_wtol(m_strBottomPos), (long)_wtol(m_strPoint3XPos), (long)_wtol(m_strPoint3YPos), \
			(long)_wtol(m_strPoint4XPos), (long)_wtol(m_strPoint4YPos)};
		//Set Polygon Annotation's appearance, this method is only for Polygon Annotation
		pPDFAnnot.SetPolygonVertices((long)&pointArray[0], 4);
	}

	if (pPDFAnnot.GetSubType() != _T("Image") && pPDFAnnot.GetSubType() != _T("Movie") && pPDFAnnot.GetSubType() != _T("Sound") \
		&& pPDFAnnot.GetType() != _T("Link"))
	{
		pPDFAnnot.SetLocked(m_bLockCheck);
		pPDFAnnot.SetReadOnly(m_bReadonlyCheck);
	}

	if (pPDFAnnot.GetType() == _T("Link"))
	{
		if (pPDFAnnot.GetSubType() == _T("Quadrilateral Link"))
		{
			long pointArray[8] = {(long)_wtol(m_strLeftPos), (long)_wtol(m_strTopPos), (long)_wtol(m_strRightPos), \
				(long)_wtol(m_strBottomPos), (long)_wtol(m_strPoint3XPos), (long)_wtol(m_strPoint3YPos), \
				(long)_wtol(m_strPoint4XPos), (long)_wtol(m_strPoint4YPos)};
			//Set Link Annotation's appearance, this method is only for Link Annotation
			pPDFAnnot.SetLinkQuadPoints((long)&pointArray[0], 4);
		}
		int nCurSel = m_linkActionTypeCombo.GetCurSel();
		if (nCurSel == 0)
		{
			int nPageIndex = m_linkPageIndexCombo.GetCurSel();
			int nZoomScale = m_fxAXSDK.GetZoomLevel(); //you may pass the zoom scale value by yourself
			pPDFAnnot.SetLinkGoToAction(nPageIndex, (float)_wtol(m_strLinkActionPageLeft), (float)_wtol(m_strLinkActionPageTop), (float)nZoomScale);
		}
		else
		{
			if (!m_strWebURL.IsEmpty())
			{
				pPDFAnnot.SetLinkURLAction(m_strWebURL);
			}
		}
	}

	int nCurSel = m_annotSubTypeCombo.GetCurSel();
	
	switch (nCurSel)
	{
	case 20:		//FileAttachment
		pPDFAnnot.AttachFile(m_strFilePath);
		break;
		
	case 21:		//Image	
		pPDFAnnot.SetMediaPoster(m_strImagePath);
		break;
		
	case 22:		//Movie
	case 23:		//Sound
		{
			int nMediaSel = m_mediaContentTypeCombo.GetCurSel();
			CString str;
			m_mediaContentTypeCombo.GetLBText(nMediaSel, str);
			pPDFAnnot.SetMediaPoster(m_strImagePath);
			pPDFAnnot.SetMultimedia(m_strFilePath, str, m_bEmbedMedia, m_bShowCtrlBar);
		}
		break;
	}

	GetTime_TimeZoom(pPDFAnnot);
}

void CAX_Annot_DemoDlg::GetFormatToolParameters()
{
	CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();

	m_strFontName = pFormatTool.GetFontName();
	m_fontColor = pFormatTool.GetFontColor();
	
	m_fontBorderColor = pFormatTool.GetBorderColor();
	m_fontFillColor = pFormatTool.GetFillColor();
	m_bFontItalic = pFormatTool.GetFontItalic();
	m_bFontBold = pFormatTool.GetFontBold();
	m_nAlignStyle = pFormatTool.GetAlign();

	m_strFontSize.Format(_T("%.1f"),pFormatTool.GetFontSize());

	CRect rect;
	GetDlgItem(IDC_FONT_COLOR_BTN)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	InvalidateRect(&rect);
	GetDlgItem(IDC_BORDER_COLOR_BTN)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	InvalidateRect(&rect);
	GetDlgItem(IDC_FONT_FILL_COLOR_BTN)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	InvalidateRect(&rect);

	m_strCharSpace.Format(_T("%.0f"), pFormatTool.GetCharSpace());
	m_strCharHorzScale.Format(_T("%.0f"), pFormatTool.GetCharHorzScale());
	if (pFormatTool.GetFontBoldEnable())
	{
		GetDlgItem(IDC_FONT_BOLD_CHECK)->EnableWindow(TRUE);
		m_bFontBold = pFormatTool.GetFontBold();
	}
	else
	{
		GetDlgItem(IDC_FONT_BOLD_CHECK)->EnableWindow(FALSE);
	}
	if (pFormatTool.GetFontItalicEnable())
	{
		GetDlgItem(IDC_FONT_ITALIC_CHECK)->EnableWindow(TRUE);
		m_bFontItalic = pFormatTool.GetFontItalic();
	}
	else
	{
		GetDlgItem(IDC_FONT_ITALIC_CHECK)->EnableWindow(FALSE);
	}
	UpdateData(FALSE);
}


void CAX_Annot_DemoDlg::OnFontColorBtn() 
{
	// TODO: Add your control notification handler code here
	CColorDialog colorDlg;
	if (colorDlg.DoModal() == IDOK)
	{
		m_fontColor = colorDlg.GetColor();
		CRect rect;
		GetDlgItem(IDC_FONT_COLOR_BTN)->GetWindowRect(&rect);
		ScreenToClient(&rect);
		InvalidateRect(&rect);
		CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
		pFormatTool.SetFontColor(m_fontColor);
	}
}

void CAX_Annot_DemoDlg::OnBorderColorBtn() 
{
	// TODO: Add your control notification handler code here
	CColorDialog colorDlg;
	if (colorDlg.DoModal() == IDOK)
	{
		m_fontBorderColor = colorDlg.GetColor();
		CRect rect;
		GetDlgItem(IDC_BORDER_COLOR_BTN)->GetWindowRect(&rect);
		ScreenToClient(&rect);
		InvalidateRect(&rect);
		CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
		pFormatTool.SetBorderColor(m_fontBorderColor);
	}
}

void CAX_Annot_DemoDlg::OnFontFillColorBtn() 
{
	// TODO: Add your control notification handler code here
	CColorDialog colorDlg;
	if (colorDlg.DoModal() == IDOK)
	{
		m_fontFillColor = colorDlg.GetColor();
		CRect rect;
		GetDlgItem(IDC_FONT_FILL_COLOR_BTN)->GetWindowRect(&rect);
		ScreenToClient(&rect);
		InvalidateRect(&rect);
		CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
		pFormatTool.SetFillColor(m_fontFillColor);
	}
}

void CAX_Annot_DemoDlg::OnFontBoldCheck() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
	pFormatTool.SetFontBold(m_bFontBold);
}

void CAX_Annot_DemoDlg::OnFontItalicCheck() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
	pFormatTool.SetFontItalic(m_bFontItalic);
}

void CAX_Annot_DemoDlg::OnLeftAlignRadio() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
	pFormatTool.SetAlign(m_nAlignStyle);
}

void CAX_Annot_DemoDlg::OnMiddleAlignRadio() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
	pFormatTool.SetAlign(m_nAlignStyle);
}

void CAX_Annot_DemoDlg::OnRightAlignRadio() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
	pFormatTool.SetAlign(m_nAlignStyle);
}

void CAX_Annot_DemoDlg::OnChangeCharSpaceEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
	pFormatTool.SetCharSpace((float)_wtol(m_strCharSpace));
}

void CAX_Annot_DemoDlg::OnChangeCharHorzScaleEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CPDFormatTool pFormatTool = m_fxAXSDK.GetFormatTool();
	pFormatTool.SetCharHorzScale((float)_wtol(m_strCharHorzScale));
}

void CAX_Annot_DemoDlg::SetMediaContentType(BOOL nType /* = TRUE */)
{
	m_mediaContentTypeCombo.ResetContent();
	if (nType)
	{
		m_mediaContentTypeCombo.AddString(_T("application/futuresplash"));
		m_mediaContentTypeCombo.AddString(_T("application/x-shockwave-flash"));
		m_mediaContentTypeCombo.AddString(_T("video/avi"));
		m_mediaContentTypeCombo.AddString(_T("video/mpeg"));
		m_mediaContentTypeCombo.AddString(_T("video/msvideo"));
		m_mediaContentTypeCombo.AddString(_T("video/x-ivf"));
		m_mediaContentTypeCombo.AddString(_T("video/x-mpeg"));
		m_mediaContentTypeCombo.AddString(_T("video/x-ms-asf"));
		m_mediaContentTypeCombo.AddString(_T("video/x-ms-asx"));
		m_mediaContentTypeCombo.AddString(_T("video/x-ms-wm"));
		m_mediaContentTypeCombo.AddString(_T("video/x-ms-wmp"));
		m_mediaContentTypeCombo.AddString(_T("video/x-ms-wmv"));
		m_mediaContentTypeCombo.AddString(_T("video/x-ms-wmx"));
		m_mediaContentTypeCombo.AddString(_T("video/x-ms-wvx"));
		m_mediaContentTypeCombo.AddString(_T("video/x-msvideo"));
		m_mediaContentTypeCombo.AddString(_T("video/x-mpg"));
		m_mediaContentTypeCombo.AddString(_T("video/mpg"));
	}
	else
	{
		m_mediaContentTypeCombo.AddString(_T("audio/aiff"));
		m_mediaContentTypeCombo.AddString(_T("audio/basic"));
		m_mediaContentTypeCombo.AddString(_T("audio/mid"));
		m_mediaContentTypeCombo.AddString(_T("audio/midi"));
		m_mediaContentTypeCombo.AddString(_T("audio/mp3"));
		m_mediaContentTypeCombo.AddString(_T("audio/mpeg"));
		m_mediaContentTypeCombo.AddString(_T("audio/mpeg3"));
		m_mediaContentTypeCombo.AddString(_T("audio/mpegurl"));
		m_mediaContentTypeCombo.AddString(_T("audio/wav"));
		m_mediaContentTypeCombo.AddString(_T("audio/x-aiff"));
		m_mediaContentTypeCombo.AddString(_T("audio/x-midi"));
		m_mediaContentTypeCombo.AddString(_T("audio/x-mp3"));
		m_mediaContentTypeCombo.AddString(_T("audio/x-mpeg"));
		m_mediaContentTypeCombo.AddString(_T("audio/x-mpeg3"));
		m_mediaContentTypeCombo.AddString(_T("audio/x-mpegurl"));
		m_mediaContentTypeCombo.AddString(_T("audio/x-wav"));
		m_mediaContentTypeCombo.AddString(_T("audio/x-ms-wax"));
		m_mediaContentTypeCombo.AddString(_T("audio/x-ms-wma"));
	}
}

void CAX_Annot_DemoDlg::OnChangeTool() 
{
	// TODO: Add your control notification handler code here
	int nToolSel = m_annotToolsCombo.GetCurSel();
	if (nToolSel == -1)
	{
		return;
	}
	CString str;
	m_annotToolsCombo.GetLBText(nToolSel, str);
	m_fxAXSDK.SetCurrentTool(str);
}

void CAX_Annot_DemoDlg::OnSelchangeLinkActionCombo() 
{
	// TODO: Add your control notification handler code here
	int nCurSel = m_linkActionTypeCombo.GetCurSel();
	if (nCurSel == 0)
	{
		EnableLinkActionOptions(TRUE);
	}
	else if (nCurSel == 1)
	{
		EnableLinkActionOptions(FALSE);
	}
}

void CAX_Annot_DemoDlg::EnableLinkActionOptions(BOOL bOption)
{
	if (bOption)
	{
		GetDlgItem(IDC_WEB_URL_EDIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_PAGE_INDEX_COMBO)->EnableWindow(TRUE);
		GetDlgItem(IDC_LINK_ACTION_LEFT)->EnableWindow(TRUE);
		GetDlgItem(IDC_LINK_ACTION_TOP)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_WEB_URL_EDIT)->EnableWindow(TRUE);
		m_linkPageIndexCombo.SetCurSel(-1);
		GetDlgItem(IDC_PAGE_INDEX_COMBO)->EnableWindow(FALSE);
		GetDlgItem(IDC_LINK_ACTION_LEFT)->SetWindowText(_T(""));
		GetDlgItem(IDC_LINK_ACTION_LEFT)->EnableWindow(FALSE);
		GetDlgItem(IDC_LINK_ACTION_TOP)->SetWindowText(_T(""));
		GetDlgItem(IDC_LINK_ACTION_TOP)->EnableWindow(FALSE);
	}
}

void CAX_Annot_DemoDlg::OnChooseImageBtn() 
{
	// TODO: Add your control notification handler code here
	CFileDialog chooseFile(TRUE, NULL, NULL, OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, _T("Image Files(*.jpg; *.bmp; *.png)|*.jpg; *.bmp; *.png|||"));
	if (IDOK == chooseFile.DoModal())
	{
		UpdateData(TRUE);
		m_strImagePath = chooseFile.GetPathName();
		UpdateData(FALSE);
	}
}

void CAX_Annot_DemoDlg::OnAnnotInfoBtn() 
{
	// TODO: Add your control notification handler code here
	if (NULL != m_pAnnotInfoDlg)
	{
		m_pAnnotInfoDlg->ShowWindow(SW_SHOW);
		return;
	}
	m_pAnnotInfoDlg = new CAnnotInfoDlg(&m_fxAXSDK);
	m_pAnnotInfoDlg->Create(IDD_ANNOT_INFO_DIALOG, NULL);
	m_pAnnotInfoDlg->ShowWindow(SW_SHOW);
}

void CAX_Annot_DemoDlg::OnReplyModule() 
{
	// TODO: Add your control notification handler code here
	if(m_pAnnotRepleDlg)
	{
		m_pAnnotRepleDlg->Close();
		delete m_pAnnotRepleDlg;
	}
	m_pAnnotRepleDlg = new CAnnotReplyDlg(&m_fxAXSDK);
	m_pAnnotRepleDlg->Create(IDD_AnnotReply_DIALOG, NULL);
	m_pAnnotRepleDlg->ShowWindow(SW_SHOW);
}

void CAX_Annot_DemoDlg::OnSelchangeBorderStyleCombo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnSelchangeLineStartStyleCombo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnSelchangeLineEndStyleCombo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnChangeAuthorEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnChangeSubjectEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnLockCheck() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnPrintCheck() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnReadonlyCheck() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnPopupCheck() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnSelchangeReviewStateCombo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnSelchangeMarkedStateCombo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnSelchangeMigrationStateCombo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CAX_Annot_DemoDlg::OnChangeContentEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}
