// FormDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Form_Demo.h"
#include "AX_Form_DemoDlg.h"
#include "InputDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int g_index = 0;

//
BSTR TCHAR2BSTR (TCHAR* szBuf) 
{  
	WCHAR* wszBuf;  
#ifndef UNICODE 
	wszBuf = new WCHAR [512]; 
	MultiByteToWideChar( CP_ACP, 0, szBuf, -1, wszBuf, 512 ); 
#else
wszBuf = szBuf; 
#endif  
	BSTR bstrNew = ::SysAllocString (szBuf);  
#ifndef UNICODE 
	delete [] wszBuf; 
#endif  
	return bstrNew; 
} 
//
VARIANT GetVariantFromStrings(TCHAR **strLst, unsigned long numStrings) 
{
	VARIANT pArray;
	unsigned long i;
	
	SAFEARRAYBOUND bounds={numStrings,0};
	//	SAFEARRAY* sa=SafeArrayCreate(VT_BSTR,1,&bounds);
	SAFEARRAY* sa=SafeArrayCreate(VT_VARIANT,1,&bounds);
	
	// 	BSTR* pbstr;
	// 	SafeArrayAccessData(sa,(void**)&pbstr);
	// 	for(i=0; i<numStrings; i++)
	// 		pbstr[i]=TCHAR2BSTR(strLst[i]);
	
	VARIANT* vaItem; 
	VARIANT va;
	SafeArrayAccessData( sa, (void**)&vaItem );
	for( i = 0; i < numStrings; i++ ) 
	{
		va.vt = VT_BSTR;
		va.bstrVal = TCHAR2BSTR( strLst[i] );
		vaItem[i] = va ;		
	}
	
	SafeArrayUnaccessData(sa);
	//	pArray.vt=VT_ARRAY|VT_BSTR;
	pArray.vt = VT_ARRAY | VT_VARIANT;
	pArray.parray=sa;
	
	return pArray;
}
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormDlg dialog

CFormDlg::CFormDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFormDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFormDlg)
	m_alphakstr = _T("");
	m_blueystr = _T("");
	m_borderwidthstr = _T("");
	m_captionstr = _T("");
	m_charlimitstr = _T("");
	m_defaultvaluestr = _T("");
	m_bottomstr = _T("");
	m_leftstr = _T("");
	m_rightstr = _T("");
	m_fieldnamestr = _T("");
	m_topstr = _T("");
	m_filepathstr = _T("");
	m_greenmstr = _T("");
	m_orientationstr = _T("");
	m_redcstr = _T("");
	m_textsizestr = _T("");
	m_tooltipstr = _T("");
	m_urlstr = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_PDFForm = NULL;
	m_text = NULL;
	m_radio = NULL;
	m_button = NULL;
	m_checkbox = NULL;
	m_combobox = NULL;
	m_listbox = NULL;
	m_PDFFormField = NULL;
	m_CurFieldtype = _T("");
	m_JSButton1 = NULL;
	m_JSButton2 = NULL;
	m_submitfield = NULL;
    m_listbox1 = NULL;
	m_combobox1 = NULL;
    m_CurFormField = NULL;
	m_bfirst = TRUE;
}

void CFormDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFormDlg)
	DDX_Control(pDX, IDC_ENTER_LIST, m_inputlist);
	DDX_Control(pDX, IDC_TRIGGER_COMBO, m_triggercombox);
	DDX_Control(pDX, IDC_TEXTFONT_COMBO, m_textfontcombox);
	DDX_Control(pDX, IDC_STYLE_COMBO, m_stylecombox);
	DDX_Control(pDX, IDC_REMOVEFIELDNAME_COMBO, m_removefieldnamecombox);
	DDX_Control(pDX, IDC_PRINTFLAG_CHECK, m_printflagcheck);
	DDX_Control(pDX, IDC_NOVIEWFLAG_CHECK, m_noviewflagcheck);
	DDX_Control(pDX, IDC_LIST_Field, m_fieldlist);
	DDX_Control(pDX, IDC_ISREQUIRED_CHECK, m_isrequiredcheck);
	DDX_Control(pDX, IDC_ISREADONLY_CHECK, m_isreadonlycheck);
	DDX_Control(pDX, IDC_ISPASSWORD_CHECK, m_ispasswordcheck);
	DDX_Control(pDX, IDC_ISMULTILINE_CHECK, m_ismultilinecheck);
	DDX_Control(pDX, IDC_ISINCLUDE_CHECK, m_isincludecheck);
	DDX_Control(pDX, IDC_ISHIDDEN_CHECK, m_ishiddencheck);
	DDX_Control(pDX, IDC_ISEXCLUDE_CHECK, m_isexcludecheck);
	DDX_Control(pDX, IDC_ISEDITABLE_CHECK, m_iseditablecheck);
	DDX_Control(pDX, IDC_FIELDTYPE_COMBO, m_fieldtypecombox);
	DDX_Control(pDX, IDC_FIELDNAME_COMBO, m_fieldnamecombox);
	DDX_Control(pDX, IDC_FGCOLOR_CHECK, m_fgcolorcheck);
	DDX_Control(pDX, IDC_BUTTONLAYOUT_COMBO, m_btnlayoutcombox);
	DDX_Control(pDX, IDC_BUTTONFACE_COMBO, m_btnfacecombox);
	DDX_Control(pDX, IDC_BORDERSTYLE_COMBO, m_borderstylecombox);
	DDX_Control(pDX, IDC_BORDERCOLOR_CHECK, m_bordercolorcheck);
	DDX_Control(pDX, IDC_BGCOLOR_CHECK, m_bgcolorcheck);
	DDX_Control(pDX, IDC_ALIGNMENT_COMBO, m_aligncombox);
	DDX_Control(pDX, IDC_COLORSPACE_COMBO, m_colorspacecombox);
	DDX_Text(pDX, IDC_ALPHAK_EDIT, m_alphakstr);
	DDX_Text(pDX, IDC_BLUEY_EDIT, m_blueystr);
	DDX_Text(pDX, IDC_BORDERWIDTH_EDIT, m_borderwidthstr);
	DDX_Text(pDX, IDC_CAPTION_EDIT, m_captionstr);
	DDX_Text(pDX, IDC_CHARLIMIT_EDIT, m_charlimitstr);
	DDX_Text(pDX, IDC_DEFAULTVALUE_EDIT, m_defaultvaluestr);
	DDX_Text(pDX, IDC_FIELDBOTTOM_EDIT, m_bottomstr);
	DDX_Text(pDX, IDC_FIELDLEFT_EDIT, m_leftstr);
	DDX_Text(pDX, IDC_FIELDRIGHT_EDIT, m_rightstr);
	DDX_Text(pDX, IDC_FIELDNAME_EDIT, m_fieldnamestr);
	DDX_Text(pDX, IDC_FIELDTOP_EDIT, m_topstr);
	DDX_Text(pDX, IDC_FILEPATH_EDIT, m_filepathstr);
	DDX_Text(pDX, IDC_GREENM_EDIT, m_greenmstr);
	DDX_Text(pDX, IDC_ORIENTATION_EDIT, m_orientationstr);
	DDX_Text(pDX, IDC_REDC_EDIT, m_redcstr);
	DDX_Text(pDX, IDC_TEXTSIZE_EDIT, m_textsizestr);
	DDX_Text(pDX, IDC_TOOLTIP_EDIT, m_tooltipstr);
	DDX_Text(pDX, IDC_URL_EDIT, m_urlstr);
	DDX_Control(pDX, IDC_FOXITPDFSDKPROCTRL1, m_ax);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFormDlg, CDialog)
	//{{AFX_MSG_MAP(CFormDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_FIELDTYPE_COMBO, OnSelchangeFieldtypeCombo)
	ON_NOTIFY(NM_CLICK, IDC_LIST_Field, OnClickLISTField)
	ON_BN_CLICKED(IDC_ADDFORMFIELD_BTN, OnAddformfieldBtn)
	ON_EN_CHANGE(IDC_BORDERWIDTH_EDIT, OnChangeBorderwidthEdit)
	ON_EN_CHANGE(IDC_CHARLIMIT_EDIT, OnChangeCharlimitEdit)
	ON_EN_CHANGE(IDC_TEXTSIZE_EDIT, OnChangeTextsizeEdit)
	ON_EN_CHANGE(IDC_ORIENTATION_EDIT, OnChangeOrientationEdit)
	ON_BN_CLICKED(IDC_SETCOLOR_BTN, OnSetcolorBtn)
	ON_EN_CHANGE(IDC_REDC_EDIT, OnChangeRedcEdit)
	ON_EN_CHANGE(IDC_GREENM_EDIT, OnChangeGreenmEdit)
	ON_EN_CHANGE(IDC_BLUEY_EDIT, OnChangeBlueyEdit)
	ON_EN_CHANGE(IDC_ALPHAK_EDIT, OnChangeAlphakEdit)
	ON_BN_CLICKED(IDC_SETBTNCAPTION_BTN, OnSetbtncaptionBtn)
	ON_BN_CLICKED(IDC_SETBTNICON_BTN, OnSetbtniconBtn)
	ON_BN_CLICKED(IDC_CHOOSEFILEPATH_BTN, OnChoosefilepathBtn)
	ON_BN_CLICKED(IDC_ADDTWOBUTTON_BTN, OnAddtwobuttonBtn)
	ON_BN_CLICKED(IDC_SETJSACTION_BTN, OnSetjsactionBtn)
	ON_BN_CLICKED(IDC_RESETJSACTION_BTN, OnResetjsactionBtn)
	ON_BN_CLICKED(IDC_ADDSUBMITFORM_BTN, OnAddsubmitformBtn)
	ON_CBN_SELCHANGE(IDC_REMOVEFIELDNAME_COMBO, OnSelchangeRemovefieldnameCombo)
	ON_CBN_DROPDOWN(IDC_REMOVEFIELDNAME_COMBO, OnDropdownRemovefieldnameCombo)
	ON_BN_CLICKED(IDC_REMOVEFIELD_BTN, OnRemovefieldBtn)
	ON_BN_CLICKED(IDC_ENTER_BTN, OnEnterBtn)
	ON_BN_CLICKED(IDC_CREATEPOPULATE_BTN, OnCreatepopulateBtn)
	ON_COMMAND(IDM_OPEN_FILE, OnOpenFile)
	ON_COMMAND(IDM_SAVE, OnSave)
	ON_COMMAND(IDM_SAVEAS, OnSaveas)
	ON_COMMAND(IDM_CLOSE_FILE, OnCloseFile)
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_COMMAND(IDM_EXPORTTO_FDF, OnExporttoFdf)
	ON_COMMAND(IDM_IMPORTFROM_FDF, OnImportfromFdf)
	ON_BN_CLICKED(IDC_MODIFYFORMFIELD_BTN, OnModifyformfieldBtn)
	ON_WM_CLOSE()
	ON_COMMAND(IDC_OK_BTN, OnOK)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormDlg message handlers

void CFormDlg::OnOK()
{
	return;
}

BOOL CFormDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	GetClientRect(&m_rectOCX);
	
	CRect rect;
	GetDlgItem(IDC_STATIC_FROMOPERATOR)->GetWindowRect(&rect);
	SetWindowPos(&wndNoTopMost, 0, 0, m_rectOCX.Width() - rect.Width()-5, m_rectOCX.Height(), SWP_NOMOVE);
	// TODO: Add extra initialization here
	m_ax.ShowTitleBar(FALSE);
	this->DisorEnableCtrl(FALSE);
    this->IsEnableColorCtrl(FALSE);
	this->IsEnableButtonCtrl(FALSE);

	GetDlgItem(IDC_TRIGGER_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETJSACTION_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_ISEXCLUDE_CHECK)->EnableWindow(FALSE);
	GetDlgItem(IDC_FIELDNAME_COMBO)->EnableWindow(FALSE);
    GetDlgItem(IDC_RESETJSACTION_BTN)->EnableWindow(FALSE);

    m_fieldlist.InsertColumn(0,_T("NO"),LVCFMT_CENTER, 60);
	m_fieldlist.InsertColumn(1,_T("Type"),LVCFMT_CENTER,100);
	m_fieldlist.InsertColumn(2,_T("Name"),LVCFMT_CENTER,100);
	m_fieldlist.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES );

	//use UnLockActiveX Method to UnLock ActiveX 
	m_ax.UnLockActiveX(_T("Licence_ID"),_T("Unlock_code"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFormDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFormDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFormDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CFormDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CFormDlg)
	ON_EVENT(CFormDlg, IDC_FOXITPDFSDKPROCTRL1, 8 /* OnOpenDocument */, OnOnOpenDocumentFoxitpdfsdkproctrl1, VTS_BSTR)
	ON_EVENT(CFormDlg, IDC_FOXITPDFSDKPROCTRL1, 16 /* OnCloseDocument */, OnOnCloseDocumentFoxitpdfsdkproctrl1, VTS_BSTR)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CFormDlg::OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath) 
{
	// TODO: Add your control notification handler code here
	SetWindowPos(&wndNoTopMost, 0, 0, m_rectOCX.Width() + 5, m_rectOCX.Height() + 30, SWP_NOMOVE);
	this->InitListFormField();
}

void CFormDlg::OnOnCloseDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath) 
{
	// TODO: Add your control notification handler code here
	m_fieldnamecombox.ResetContent();
	this->ClearAllCtrlValue();
	this->DisorEnableCtrl(FALSE);
    this->IsEnableColorCtrl(FALSE);
	this->IsEnableButtonCtrl(FALSE);

	GetDlgItem(IDC_TRIGGER_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETJSACTION_BTN)->EnableWindow(FALSE);
	GetDlgItem(IDC_ISEXCLUDE_CHECK)->EnableWindow(FALSE);
	GetDlgItem(IDC_FIELDNAME_COMBO)->EnableWindow(FALSE);
    GetDlgItem(IDC_RESETJSACTION_BTN)->EnableWindow(FALSE);
    m_fieldlist.DeleteAllItems();
	m_inputlist.ResetContent();
	m_removefieldnamecombox.SetCurSel(-1);
	m_fieldtypecombox.SetCurSel(-1);
	g_index = 0;
    
	CRect rect;
	GetDlgItem(IDC_STATIC_FROMOPERATOR)->GetWindowRect(&rect);
	SetWindowPos(&wndNoTopMost, 0, 0, m_rectOCX.Width() - rect.Width()-5, m_rectOCX.Height(), SWP_NOMOVE);
}

CString CFormDlg::FileDialog(BOOL IsOpen, WCHAR * filext,WCHAR *Filter)
{
	CString FileName;
	WCHAR FilePath[MAX_PATH];
	CFileDialog dlg(IsOpen, filext, NULL, OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT, Filter, this);
	
	memset(FilePath, 0, sizeof(FilePath));
	
	if (IsOpen) {
		dlg.m_ofn.Flags |= OFN_FILEMUSTEXIST;
		dlg.m_ofn.lpstrTitle = _T("Open file");
	} else {
		dlg.m_ofn.lpstrTitle = _T("Save as");
	}
    dlg.m_ofn.nMaxFile = MAX_PATH; 
    dlg.m_ofn.lpstrFile = FilePath; 
	
	if (dlg.DoModal() == IDOK) {
		FileName = dlg.GetPathName();
	}
    
	return FileName;
}

void CFormDlg::DisorEnableCtrl(BOOL bEnable)
{
	GetDlgItem(IDC_FIELDLEFT_EDIT)->EnableWindow(bEnable);
    GetDlgItem(IDC_FIELDTOP_EDIT)->EnableWindow(bEnable);
    GetDlgItem(IDC_FIELDRIGHT_EDIT)->EnableWindow(bEnable);
    GetDlgItem(IDC_FIELDBOTTOM_EDIT)->EnableWindow(bEnable);
    GetDlgItem(IDC_FIELDNAME_EDIT)->EnableWindow(bEnable);
	
	GetDlgItem(IDC_BORDERSTYLE_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_BUTTONLAYOUT_COMBO)->EnableWindow(bEnable);

	GetDlgItem(IDC_ISHIDDEN_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_ISREADONLY_CHECK)->EnableWindow(bEnable);
	
	GetDlgItem(IDC_NOVIEWFLAG_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_PRINTFLAG_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_BORDERWIDTH_EDIT)->EnableWindow(bEnable);
	
	GetDlgItem(IDC_DEFAULTVALUE_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_TOOLTIP_EDIT)->EnableWindow(bEnable);
    GetDlgItem(IDC_ORIENTATION_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_ADDFORMFIELD_BTN)->EnableWindow(bEnable);
    //only for textfield
    GetDlgItem(IDC_ALIGNMENT_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHARLIMIT_EDIT)->EnableWindow(bEnable);
    GetDlgItem(IDC_ISMULTILINE_CHECK)->EnableWindow(bEnable);
    GetDlgItem(IDC_ISPASSWORD_CHECK)->EnableWindow(bEnable);

	//only for Combo Box
    GetDlgItem(IDC_ISEDITABLE_CHECK)->EnableWindow(bEnable);

	//for Combo box,Radio button,TextField
    GetDlgItem(IDC_ISREQUIRED_CHECK)->EnableWindow(bEnable);

    //for checkbox,radio button
    GetDlgItem(IDC_STYLE_COMBO)->EnableWindow(bEnable);

	//for all except for check box,radio box
	GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(bEnable);
}

void CFormDlg::EnableALLCtrl()
{
	GetDlgItem(IDC_FIELDLEFT_EDIT)->EnableWindow(TRUE);
    GetDlgItem(IDC_FIELDTOP_EDIT)->EnableWindow(TRUE);
    GetDlgItem(IDC_FIELDRIGHT_EDIT)->EnableWindow(TRUE);
    GetDlgItem(IDC_FIELDBOTTOM_EDIT)->EnableWindow(TRUE);
    GetDlgItem(IDC_FIELDNAME_EDIT)->EnableWindow(TRUE);
	GetDlgItem(IDC_BORDERSTYLE_COMBO)->EnableWindow(TRUE);
	
	GetDlgItem(IDC_ISHIDDEN_CHECK)->EnableWindow(TRUE);
	GetDlgItem(IDC_ISREADONLY_CHECK)->EnableWindow(TRUE);
	GetDlgItem(IDC_NOVIEWFLAG_CHECK)->EnableWindow(TRUE);
	GetDlgItem(IDC_PRINTFLAG_CHECK)->EnableWindow(TRUE);
	GetDlgItem(IDC_BORDERWIDTH_EDIT)->EnableWindow(TRUE);
	GetDlgItem(IDC_DEFAULTVALUE_EDIT)->EnableWindow(TRUE);
	GetDlgItem(IDC_TOOLTIP_EDIT)->EnableWindow(TRUE);
    GetDlgItem(IDC_ORIENTATION_EDIT)->EnableWindow(TRUE);
	GetDlgItem(IDC_ADDFORMFIELD_BTN)->EnableWindow(TRUE);
}

void CFormDlg::ClearAllCtrlValue()
{
    m_alphakstr = _T("");
	m_blueystr = _T("");
	m_borderwidthstr = _T("");
	m_captionstr = _T("");
	m_charlimitstr = _T("");
	m_defaultvaluestr = _T("");
	m_bottomstr = _T("");
	m_leftstr = _T("");
	m_rightstr = _T("");
	m_fieldnamestr = _T("");
	m_topstr = _T("");
	m_filepathstr = _T("");
	m_greenmstr = _T("");
	m_orientationstr = _T("");
	m_redcstr = _T("");
	m_textsizestr = _T("");
	m_tooltipstr = _T("");
	m_urlstr = _T("");
	/*m_fieldtypecombox.SetCurSel(-1);*/
	m_aligncombox.SetCurSel(-1);
	m_stylecombox.SetCurSel(-1);
	m_textfontcombox.SetCurSel(-1);
	m_borderstylecombox.SetCurSel(-1);
	m_btnlayoutcombox.SetCurSel(-1);
	m_ishiddencheck.SetCheck(FALSE);
	m_ismultilinecheck.SetCheck(FALSE);
	m_ispasswordcheck.SetCheck(FALSE);
	m_isreadonlycheck.SetCheck(FALSE);
	m_isrequiredcheck.SetCheck(FALSE);
	m_iseditablecheck.SetCheck(FALSE);
	m_noviewflagcheck.SetCheck(FALSE);
	m_printflagcheck.SetCheck(FALSE);
    
	/*m_inputlist.ResetContent();*/
	m_triggercombox.SetCurSel(-1);
	m_fieldnamecombox.SetCurSel(-1);
	m_isexcludecheck.SetCheck(FALSE);
	m_isincludecheck.SetCheck(FALSE);
	m_urlstr = _T("");
	UpdateData(FALSE);
}

void CFormDlg::InitListFormField()
{
	m_fieldlist.DeleteAllItems();
	m_PDFForm = m_ax.GetCurrentForm();
	if(!m_PDFForm)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		this->IsEnableButtonCtrl(FALSE);
		this->IsEnableColorCtrl(FALSE);
		return;
	}

	CString strTemp = _T("");
    int nCount = m_PDFForm.GetFieldsCount();
	for (int i = 0;i< nCount;++i)
	{
		m_PDFFormField = m_PDFForm.GetFieldByIndex(i);
		//fieldname = m_formfield.GetName();
		m_fieldlist.InsertItem(i,_T("Obj 1"));
		
		strTemp.Format(_T("%d"),i);
		m_fieldlist.SetItemText(i, 0, strTemp);
		
		strTemp = m_PDFFormField.GetType();
		m_fieldlist.SetItemText(i, 1, strTemp); 
		
		strTemp = m_PDFFormField.GetName();
		m_fieldlist.SetItemText(i, 2, strTemp);
	}
		m_bfirst = TRUE;
}

void CFormDlg::OnClickLISTField(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	this->DisorEnableCtrl(TRUE);
	this->ClearAllCtrlValue();
	int nIndex = m_fieldlist.GetSelectionMark();
	CString str;
	str = m_fieldlist.GetItemText(nIndex,0);
    int nCurIndex = _wtoi(str);
    ShowFieldProperty(nCurIndex);
	GetDlgItem(IDC_FIELDNAME_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_ADDFORMFIELD_BTN)->EnableWindow(FALSE);
	if(nIndex>-1)
		GetDlgItem(IDC_MODIFYFORMFIELD_BTN)->EnableWindow(TRUE);
	this->IsEnableColorCtrl(TRUE);

	*pResult = 0;
}

int CFormDlg::SetComboBoxCurSel(CComboBox &comboBox,CString str)
{
    int nCount = comboBox.GetCount();
	int i = 0;
	while (i < nCount)
	{
		CString tempstr;
		comboBox.GetLBText(i,tempstr);
		if (str.Compare(tempstr) == 0)
		{
			return i;
		}
		++i;
	}
	return -1;
}

void CFormDlg::ShowFieldProperty(int index)
{
    CPDFFormField formfield = m_PDFForm.GetFieldByIndex(index);	
	if (formfield == NULL) return;
	m_CurFormField = formfield;

	int nPageindex = formfield.GetPageIndex();
	m_stylecombox.SetCurSel(-1);
	m_aligncombox.SetCurSel(-1);
    float fRtop = formfield.GetRectTop();
	float fRbottom = formfield.GetRectBottom();
	float fRright = formfield.GetRectRight();
	float fRleft = formfield.GetRectLeft();
	m_topstr.Format(_T("%f"),fRtop);
    m_bottomstr.Format(_T("%f"),fRbottom);
	m_rightstr.Format(_T("%f"),fRright);
	m_leftstr.Format(_T("%f"),fRleft);
    m_fieldnamestr = formfield.GetName();
    CString borderStyle = formfield.GetBorderStyle();
	int nborderwidth = formfield.GetBorderWidth();
	CString defaultvalue = formfield.GetDefaultValue();
    int nbuttonlayout = formfield.GetButtonLayout();
//     int nCount = m_borderstylecombox.GetCount();
// 	int i = 0;
// 	while (i < nCount)
// 	{
// 	  CString tempstr;
// 	  m_borderstylecombox.GetLBText(i,tempstr);
// 	  if (borderStyle.Compare(tempstr) == 0)
//       {
//           m_borderstylecombox.SetCurSel(i);
//       }
// 	  ++i;
// 	}
    int iSel = this->SetComboBoxCurSel(m_borderstylecombox,borderStyle);
    m_borderstylecombox.SetCurSel(iSel);
	m_borderwidthstr.Format(_T("%d"),nborderwidth);
    m_defaultvaluestr = defaultvalue;
	m_btnlayoutcombox.SetCurSel(nbuttonlayout);
	m_borderwidthstr.Format(_T("%d"),formfield.GetBorderWidth());
	m_defaultvaluestr = formfield.GetDefaultValue();
	m_tooltipstr = formfield.GetTooltip();
	m_orientationstr.Format(_T("%d"),formfield.GetOrientation());
	m_textsizestr.Format(_T("%d"),formfield.GetTextSize());

	BOOL isHidden = formfield.GetIsHidden();
    BOOL isReadOnly = formfield.GetIsReadOnly();
	BOOL isNoViewFlag = formfield.GetNoViewFlag();
    BOOL isPrintFlag = formfield.GetPrintFlag();
    
    m_ishiddencheck.SetCheck(isHidden);
	m_isreadonlycheck.SetCheck(isReadOnly);
    m_noviewflagcheck.SetCheck(isNoViewFlag);
	m_printflagcheck.SetCheck(isPrintFlag);

	CString type = formfield.GetType();
	iSel = this->SetComboBoxCurSel(m_fieldtypecombox,type);
	m_fieldtypecombox.SetCurSel(iSel);
    CString textfont;int textsize;

	if (type!= _T("checkbox")||type != _T("radiobutton"))
	{
        GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(TRUE);
	    GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(TRUE);
		textfont = formfield.GetTextFont();
		textsize = formfield.GetTextSize();
		iSel = this->SetComboBoxCurSel(m_textfontcombox,textfont);
		m_textfontcombox.SetCurSel(iSel);
		m_textsizestr.Format(_T("%d"),textsize);
	}
    //disable ctrl////////////////////////////////////////////////////////////////
	//for textfield only
	GetDlgItem(IDC_ALIGNMENT_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHARLIMIT_EDIT)->EnableWindow(FALSE);
    GetDlgItem(IDC_ISMULTILINE_CHECK)->EnableWindow(FALSE);
    GetDlgItem(IDC_ISPASSWORD_CHECK)->EnableWindow(FALSE);
	
    //only for Combo Box
    GetDlgItem(IDC_ISEDITABLE_CHECK)->EnableWindow(FALSE);
	
	//for Combo box,Radio button,TextField
    GetDlgItem(IDC_ISREQUIRED_CHECK)->EnableWindow(FALSE);
	
    //for checkbox,radio button
    GetDlgItem(IDC_STYLE_COMBO)->EnableWindow(FALSE);
	
	//for all except for check box,radio box
	GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(FALSE);
	GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(FALSE);
    //////////////////////////////////////////////////////////////////////////

	BOOL IsRequired;
    if (type == "text")
    {
		GetDlgItem(IDC_ALIGNMENT_COMBO)->EnableWindow(TRUE);
		GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHARLIMIT_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_ISMULTILINE_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_ISPASSWORD_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_ISREQUIRED_CHECK)->EnableWindow(TRUE);
        CString alignment = formfield.GetAlignment();
		int ncharlimit = formfield.GetCharLimit();
        BOOL isMultiline = formfield.GetIsMultiline();
        BOOL isPassword = formfield.GetIsPassword();
        IsRequired = formfield.GetIsRequired();
        iSel = this->SetComboBoxCurSel(m_aligncombox,alignment);
		m_aligncombox.SetCurSel(iSel);
		m_charlimitstr.Format(_T("%d"),ncharlimit);
		
		m_ismultilinecheck.SetCheck(isMultiline);
		m_ispasswordcheck.SetCheck(isPassword);
        m_isrequiredcheck.SetCheck(IsRequired);
    }

	if (type == _T("button"))
	{
		GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(TRUE);
		GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHARLIMIT_EDIT)->EnableWindow(TRUE);
		this->IsEnableButtonCtrl(TRUE);
	}

	if (type == _T("combobox"))
	{
		GetDlgItem(IDC_ISEDITABLE_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_ISREQUIRED_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHARLIMIT_EDIT)->EnableWindow(TRUE);
		BOOL isEditable = formfield.GetIsEditable();
        IsRequired = formfield.GetIsRequired();
		m_iseditablecheck.SetCheck(isEditable);
        m_isrequiredcheck.SetCheck(IsRequired);
	}
    CString style;
	if (type == _T("radiobutton"))
	{
		GetDlgItem(IDC_ISREQUIRED_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_STYLE_COMBO)->EnableWindow(TRUE);
		IsRequired = formfield.GetIsRequired();
		style = formfield.GetStyle();
		m_isrequiredcheck.SetCheck(IsRequired);
		iSel = this->SetComboBoxCurSel(m_stylecombox,style);
		m_stylecombox.SetCurSel(iSel);
	}

	if (type == _T("checkbox"))
	{
		GetDlgItem(IDC_STYLE_COMBO)->EnableWindow(TRUE);
		style = formfield.GetStyle();
		iSel = this->SetComboBoxCurSel(m_stylecombox,style);
		m_stylecombox.SetCurSel(iSel);
	}
    UpdateData(FALSE);
}

void CFormDlg::OnSelchangeFieldtypeCombo() 
{
	// TODO: Add your control notification handler code here
	this->DisorEnableCtrl(FALSE);
	this->ClearAllCtrlValue();
	int nSel = m_fieldtypecombox.GetCurSel();
	int nPageindex = m_ax.GetCurPage();
	CString m_fieldtypestr;
	this->IsEnableButtonCtrl(FALSE);
	switch(nSel)
	{
	case 0:
		m_CurFieldtype = _T("text");
		this->EnableALLCtrl();
		GetDlgItem(IDC_ALIGNMENT_COMBO)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHARLIMIT_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_ISMULTILINE_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_ISPASSWORD_CHECK)->EnableWindow(TRUE);
        GetDlgItem(IDC_ISREQUIRED_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(TRUE);
	    GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(TRUE);
		break;
	case 1:
		this->EnableALLCtrl();
		m_CurFieldtype = _T("button");
		GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHARLIMIT_EDIT)->EnableWindow(TRUE);
	    GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTONLAYOUT_COMBO)->EnableWindow(TRUE);
		
		this->IsEnableButtonCtrl(TRUE);
		break;
	case 2:
		this->EnableALLCtrl();
		m_CurFieldtype = _T("combobox");
	    GetDlgItem(IDC_ISEDITABLE_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_ISREQUIRED_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(TRUE);
	    GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHARLIMIT_EDIT)->EnableWindow(TRUE);
		break;
	case 3:
		this->EnableALLCtrl();
		m_CurFieldtype = "listbox";
		GetDlgItem(IDC_ISEDITABLE_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_TEXTFONT_COMBO)->EnableWindow(TRUE);
	    GetDlgItem(IDC_TEXTSIZE_EDIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHARLIMIT_EDIT)->EnableWindow(TRUE);
		break;
	case 4:
		this->EnableALLCtrl();
		m_CurFieldtype = _T("checkbox");
	    GetDlgItem(IDC_STYLE_COMBO)->EnableWindow(TRUE);
		break;
	case 5:
		this->EnableALLCtrl();
		m_CurFieldtype = _T("radiobutton");
	    GetDlgItem(IDC_ISREQUIRED_CHECK)->EnableWindow(TRUE);
		GetDlgItem(IDC_STYLE_COMBO)->EnableWindow(TRUE);
		break;
	default:
		break;
	}
    
}

void CFormDlg::SetFormFieldProperties(CPDFFormField &pdfFormField,CString type)
{
    CString bStyle = _T("");
	if (m_borderstylecombox.GetCurSel() != -1)
	    m_borderstylecombox.GetLBText(m_borderstylecombox.GetCurSel(),bStyle);
	pdfFormField.SetBorderStyle(bStyle);
    int bWidth = _wtoi(m_borderwidthstr);
	pdfFormField.SetBorderWidth(bWidth);
    if (m_btnlayoutcombox.GetCurSel() != -1)
    {
        pdfFormField.SetButtonLayout(m_btnlayoutcombox.GetCurSel());
    }
	int isHidden = m_ishiddencheck.GetCheck();
    pdfFormField.SetDefaultValue(m_defaultvaluestr);
    pdfFormField.SetIsHidden(m_ishiddencheck.GetCheck());
    pdfFormField.SetIsReadOnly(m_isreadonlycheck.GetCheck());
	pdfFormField.SetNoViewFlag(m_noviewflagcheck.GetCheck());
	pdfFormField.SetPrintFlag(m_printflagcheck.GetCheck());
    pdfFormField.SetTooltip(m_tooltipstr);
    int orient = _wtoi(m_orientationstr);
	pdfFormField.SetOrientation(orient);

}

void CFormDlg::OnAddformfieldBtn() 
{
	// TODO: Add your control notification handler code here
	if(!m_PDFForm)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

    if (m_fieldtypecombox.GetCurSel() == -1)
	{
		MessageBox(_T("Please select a field type."));
        return;
	}
	UpdateData(TRUE);
	float fleft = (float)_wtol((LPCTSTR)m_leftstr);
	float ftop = (float)_wtol((LPCTSTR)m_topstr);
	float fbottom = (float)_wtol((LPCTSTR)m_bottomstr);
	float fright = (float)_wtol((LPCTSTR)m_rightstr);
	int nPageindex = m_ax.GetCurPage();
    if (m_CurFieldtype == "text")
    {
       m_text = m_PDFForm.AddField(m_fieldnamestr,m_CurFieldtype,nPageindex,fleft,ftop,fright,fbottom);
	   this->SetFormFieldProperties(m_text,m_CurFieldtype);
       //only for text field
	   CString aligstr = "";
	   if (m_aligncombox.GetCurSel() != -1)
		   m_aligncombox.GetLBText(m_aligncombox.GetCurSel(),aligstr);
	   m_text.SetAlignment(aligstr);
       int ncharlimit = _wtoi(m_charlimitstr);
       m_text.SetCharLimit(ncharlimit);
       m_text.SetIsMultiline(m_ismultilinecheck.GetCheck());
	   m_text.SetIsPassword(m_ispasswordcheck.GetCheck());
	   m_text.SetIsRequired(m_isrequiredcheck.GetCheck());
       
	   CString textfontstr = _T("");
	   if (m_textfontcombox.GetCurSel() != -1)
		   m_textfontcombox.GetLBText(m_textfontcombox.GetCurSel(),textfontstr);
	   m_text.SetTextFont(textfontstr);

	   int ntextsize = _wtoi(m_textsizestr);
	   m_text.SetTextSize(ntextsize);
       
    }
	else if (m_CurFieldtype == _T("button"))
	{
		m_button = m_PDFForm.AddField(m_fieldnamestr,m_CurFieldtype,nPageindex,fleft,ftop,fright,fbottom);
		this->SetFormFieldProperties(m_button,m_CurFieldtype);
		CString textfontstr = _T("");
		if (m_textfontcombox.GetCurSel() != -1)
			m_textfontcombox.GetLBText(m_textfontcombox.GetCurSel(),textfontstr);
		m_button.SetTextFont(textfontstr);
		
		int ntextsize = _wtoi(m_textsizestr);
	    m_button.SetTextSize(ntextsize);
      
        this->IsEnableButtonCtrl(TRUE);
	}
	else if (m_CurFieldtype == _T("combobox"))
	{
		m_combobox = m_PDFForm.AddField(m_fieldnamestr,m_CurFieldtype,nPageindex,fleft,ftop,fright,fbottom);
		this->SetFormFieldProperties(m_combobox,m_CurFieldtype);
        //only for combobox
		m_combobox.SetIsEditable(m_iseditablecheck.GetCheck());
        m_combobox.SetIsRequired(m_isrequiredcheck.GetCheck());

		CString textfontstr = _T("");
		if (m_textfontcombox.GetCurSel() != -1)
			m_textfontcombox.GetLBText(m_textfontcombox.GetCurSel(),textfontstr);
		m_combobox.SetTextFont(textfontstr);
		
		int ntextsize = _wtoi(m_textsizestr);
	    m_combobox.SetTextSize(ntextsize);
	}
	else if (m_CurFieldtype == _T("listbox"))
	{
		m_listbox = m_PDFForm.AddField(m_fieldnamestr,m_CurFieldtype,nPageindex,fleft,ftop,fright,fbottom);
		this->SetFormFieldProperties(m_listbox,m_CurFieldtype);

		CString textfontstr = _T("");
		if (m_textfontcombox.GetCurSel() != -1)
			m_textfontcombox.GetLBText(m_textfontcombox.GetCurSel(),textfontstr);
		m_listbox.SetTextFont(textfontstr);
		
		int ntextsize = _wtoi(m_textsizestr);
	    m_listbox.SetTextSize(ntextsize);

	}
	else if (m_CurFieldtype == _T("checkbox"))
	{
		m_checkbox = m_PDFForm.AddField(m_fieldnamestr,m_CurFieldtype,nPageindex,fleft,ftop,fright,fbottom);
		this->SetFormFieldProperties(m_checkbox,m_CurFieldtype);
		CString stylestr = _T("");
		if (m_stylecombox.GetCurSel() != -1)
			m_stylecombox.GetLBText(m_stylecombox.GetCurSel(),stylestr);
		m_checkbox.SetStyle(stylestr);

	}
	else if (m_CurFieldtype == _T("radiobutton"))
	{
		m_radio = m_PDFForm.AddField(m_fieldnamestr,m_CurFieldtype,nPageindex,fleft,ftop,fright,fbottom);
		this->SetFormFieldProperties(m_radio,m_CurFieldtype);
		m_radio.SetIsRequired(m_isrequiredcheck.GetCheck());
		CString stylestr = _T("");
		if (m_stylecombox.GetCurSel() != -1)
			m_stylecombox.GetLBText(m_stylecombox.GetCurSel(),stylestr);
		m_radio.SetStyle(stylestr);

	}
	else
	{
       MessageBox(_T("The field type has some error!"));
	   return;
	}
    this->InitListFormField();
}

void CFormDlg::OnChangeBorderwidthEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int borderwidth = _wtoi(m_borderwidthstr);
    if (borderwidth<0)
    {
		MessageBox(_T("Please enter a positive value."));
		m_borderwidthstr = _T("0");
		UpdateData(FALSE);
    }
}

void CFormDlg::OnChangeCharlimitEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int charlimit = _wtoi(m_charlimitstr);
    if (charlimit<0)
    {
		MessageBox(_T("Please enter a positive value."));
		m_charlimitstr = _T("0");
		UpdateData(FALSE);
    }
}

void CFormDlg::OnChangeTextsizeEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int textsize = _wtoi(m_textsizestr);
    if (textsize<0)
    {
		MessageBox(_T("Please enter a positive value."));
		m_textsizestr = _T("0");
		UpdateData(FALSE);
    }
}

void CFormDlg::OnChangeOrientationEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int orient = _wtoi(m_orientationstr);
    if (orient<0 || orient >3)
    {
		MessageBox(_T("The value is invalid.Please enter the value in the range form 0 to 3."));
		m_orientationstr = _T("0");
		UpdateData(FALSE);
    }
}


void CFormDlg::OnChangeRedcEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	float redc = (float)_wtol((LPCTSTR)m_redcstr);
	if (redc<0.0||redc>1.0)
	{
		MessageBox(_T("The value is invalid. Please enter the value in the range form 0 to 1."));
		m_redcstr = _T("0.0");
		UpdateData(FALSE);
	}

}

void CFormDlg::OnChangeGreenmEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	float greenm = (float)_wtol((LPCTSTR)m_greenmstr);
	if (greenm<0.0||greenm>1.0)
	{
		MessageBox(_T("The value is invalid.Please enter the value in the range form 0 to 1."));
		m_greenmstr = _T("0.0");
		UpdateData(FALSE);
	}
}

void CFormDlg::OnChangeBlueyEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	float bluey = (float)_wtol((LPCTSTR)m_blueystr);
	if (bluey<0.0||bluey>1.0)
	{
		MessageBox(_T("The value is invalid.Please enter the value in the range form 0 to 1."));
		m_blueystr = "0.0";
		UpdateData(FALSE);
	}
}

void CFormDlg::OnChangeAlphakEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	float alphak = (float)_wtol((LPCTSTR)m_alphakstr);
	if (alphak<0.0||alphak>1.0)
	{
		MessageBox(_T("The value is invalid.Please enter the value in the range form 0 to 1."));
		m_alphakstr = _T("0.0");
		UpdateData(FALSE);
	}
}

void    CFormDlg::IsEnableColorCtrl(BOOL bEnable)
{
	GetDlgItem(IDC_COLORSPACE_COMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_REDC_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_BLUEY_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_GREENM_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_ALPHAK_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_BGCOLOR_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_FGCOLOR_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_BORDERCOLOR_CHECK)->EnableWindow(bEnable);
	GetDlgItem(IDC_SETCOLOR_BTN)->EnableWindow(bEnable);
}

void CFormDlg::OnSetcolorBtn() 
{
	// TODO: Add your control notification handler code here	
	if (m_CurFormField == NULL)
	{
		MessageBox(_T("Please select a form field and then try again."));
		return;
	}
	UpdateData(TRUE);
	CString spacestr = _T("");
    if (m_colorspacecombox.GetCurSel()==-1) return;
	float redc =0; //(float)wcstod((LPCTSTR)m_redcstr);
    float greenm =0; //(float)wcstod((LPCTSTR)m_greenmstr);
	float bluey =0 ;//(float)wcstod((LPCTSTR)m_blueystr);
    float alphak = 0;//(float)wcstod((LPCTSTR)m_alphakstr);
	swscanf(m_redcstr,L"%f",&redc);
	swscanf(m_greenmstr,L"%f",&greenm);
	swscanf(m_blueystr,L"%f",&bluey);
	swscanf(m_alphakstr,L"%f",&alphak);
	m_colorspacecombox.GetLBText(m_colorspacecombox.GetCurSel(),spacestr);
    if (m_bgcolorcheck.GetCheck())
    { 
		m_CurFormField.SetBackgroundColor(spacestr,redc,greenm,bluey,alphak);
    }
	if (m_fgcolorcheck.GetCheck())
	{
		m_CurFormField.SetForegroundColor(spacestr,redc,greenm,bluey,alphak);
	}
	if (m_bordercolorcheck.GetCheck())
	{
		m_CurFormField.SetBorderColor(spacestr,redc,greenm,bluey,alphak);
	}
}

void CFormDlg::IsEnableButtonCtrl(BOOL bEnable)
{
   GetDlgItem(IDC_BUTTONFACE_COMBO)->EnableWindow(bEnable);
   GetDlgItem(IDC_CAPTION_EDIT)->EnableWindow(bEnable);
   GetDlgItem(IDC_SETBTNCAPTION_BTN)->EnableWindow(bEnable);
   GetDlgItem(IDC_FILEPATH_EDIT)->EnableWindow(bEnable);
   GetDlgItem(IDC_CHOOSEFILEPATH_BTN)->EnableWindow(bEnable);
   GetDlgItem(IDC_SETBTNICON_BTN)->EnableWindow(bEnable);
   GetDlgItem(IDC_MODIFYFORMFIELD_BTN)->EnableWindow(bEnable);
}

void CFormDlg::OnSetbtncaptionBtn() 
{
	// TODO: Add your control notification handler code here
	
	if (m_CurFormField == NULL)
	{
		MessageBox(_T("Please select a form field and then try again."));
		return;
	}

	UpdateData(TRUE);
	CString btnfacestr = _T("");
	if (m_btnfacecombox.GetCurSel() != -1)
	{
		m_btnfacecombox.GetLBText(m_btnfacecombox.GetCurSel(),btnfacestr);
	}
	m_CurFormField.SetButtonCaption(btnfacestr,m_captionstr);
}

void CFormDlg::OnSetbtniconBtn() 
{
	// TODO: Add your control notification handler code here
	if (m_CurFormField == NULL) 
	{
		MessageBox(_T("Please select a form field and then try again."));
		return;
	}
	
	UpdateData(TRUE);
	CString btnfacestr = _T("");
	if (m_btnfacecombox.GetCurSel() != -1)
	{
		m_btnfacecombox.GetLBText(m_btnfacecombox.GetCurSel(),btnfacestr);
	}
	m_CurFormField.SetButtonIcon(btnfacestr,m_filepathstr);
}

void CFormDlg::OnChoosefilepathBtn() 
{
	// TODO: Add your control notification handler code here
	WCHAR Filter[100] = _T("jpg Files (*.jpg)|*.jpg|All Files (*.*)|*.*|||");
	UpdateData();
	m_filepathstr = FileDialog(TRUE,NULL, Filter);
	UpdateData(FALSE);
}

void CFormDlg::OnAddtwobuttonBtn() 
{
	// TODO: Add your control notification handler code here
	if(!m_PDFForm)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	m_JSButton1 = m_PDFForm.AddField(_T("JSBtn1"),_T("button"),m_ax.GetCurPage(),100,200,200,100);
    m_JSButton2 = m_PDFForm.AddField(_T("JSBtn2"),_T("button"),m_ax.GetCurPage(),200,300,300,200);
	GetDlgItem(IDC_TRIGGER_COMBO)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETJSACTION_BTN)->EnableWindow(TRUE);
	GetDlgItem(IDC_ISEXCLUDE_CHECK)->EnableWindow(TRUE);
	GetDlgItem(IDC_FIELDNAME_COMBO)->EnableWindow(TRUE);
    GetDlgItem(IDC_RESETJSACTION_BTN)->EnableWindow(TRUE);

	m_fieldnamecombox.AddString(_T("JSBtn1"));
	m_fieldnamecombox.AddString(_T("JSBtn2"));
	this->InitListFormField();
}

void CFormDlg::OnSetjsactionBtn() 
{
	// TODO: Add your control notification handler code here
	CString triggerstr = _T("");
	if (m_triggercombox.GetCurSel() != -1)
		m_triggercombox.GetLBText(m_triggercombox.GetCurSel(),triggerstr);
	CString bstrJS = _T("");
	if (triggerstr == _T("up"))
	{
		bstrJS = _T("app.alert(\"Mouse Up!\")");
	}
	else if (triggerstr == _T("down"))
	{
		bstrJS = _T("app.alert(\"Mouse Down!\")");
	}
	else if (triggerstr == "enter")
	{
		bstrJS = _T("app.alert(\"Mouse enter!\")");
	}
	else if (triggerstr == _T("exit"))
	{
		bstrJS = _T("app.alert(\"exit!\")");
	}
	if (m_JSButton1)
		m_JSButton1.SetJavaScriptAction(triggerstr,bstrJS);
	if (m_JSButton2)
		m_JSButton2.SetJavaScriptAction(_T("down"),_T("app.alert(\"Mouse Down!\")"));
    
}

void CFormDlg::OnResetjsactionBtn() 
{
	// TODO: Add your control notification handler code here
	CPDFFormField pdfformfield = NULL;
	CString fieldnamestr;	
	WCHAR *t;	
	WCHAR *arr1[1];

	CString triggerstr;
	if (m_fieldnamecombox.GetCurSel() == -1)
		return;
	m_fieldnamecombox.GetLBText(m_fieldnamecombox.GetCurSel(),fieldnamestr);
	if (fieldnamestr == _T("JSBtn1"))
	{
       pdfformfield = m_JSButton1;
	   if (m_triggercombox.GetCurSel() != -1)
		m_triggercombox.GetLBText(m_triggercombox.GetCurSel(),triggerstr);
	   t = _T("JSBtn1");
	}
	else if (fieldnamestr == _T("JSBtn2"))
	{
	   pdfformfield = m_JSButton2;
	   triggerstr = _T("down");
	   t = _T("JSBtn2");
	}
	arr1[0] = t;
    if (pdfformfield == NULL) return;
	VARIANT var1 = GetVariantFromStrings(arr1,1);
	pdfformfield.SetResetFormAction(triggerstr,m_isexcludecheck.GetCheck(),var1);//flag 1,exclude null reset all
}

void CFormDlg::OnAddsubmitformBtn() 
{
	// TODO: Add your control notification handler code here
    UpdateData(TRUE);

	m_submitfield = m_PDFForm.AddField(_T("Subbtn"),_T("button"),m_ax.GetCurPage(),0,100,100,0);
	TCHAR *t = _T("Subbtn");	TCHAR *arr1[1];	arr1[0] = t;
	VARIANT var3 = GetVariantFromStrings(arr1,1);

    m_submitfield.SetSubmitFormAction(_T("down"),m_urlstr,m_isincludecheck.GetCheck(),var3);
	this->InitListFormField();
}


void CFormDlg::OnSelchangeRemovefieldnameCombo() 
{
	// TODO: Add your control notification handler code here
	
}

void CFormDlg::OnDropdownRemovefieldnameCombo() 
{
	// TODO: Add your control notification handler code here
	if (m_bfirst)
	{
		if (m_PDFForm == NULL) return;
		CPDFFormField pdfformfield;
		int nCount = m_PDFForm.GetFieldsCount();
		CString fieldnamestr;
		m_removefieldnamecombox.ResetContent();
		for(int i = 0;i<nCount;++i)
		{
			pdfformfield = m_PDFForm.GetFieldByIndex(i);
			fieldnamestr = pdfformfield.GetName();
			m_removefieldnamecombox.AddString(fieldnamestr);
		}
		m_bfirst = FALSE;
	}
}

void CFormDlg::OnRemovefieldBtn() 
{
	// TODO: Add your control notification handler code here
	CString fieldname = "";
	if (m_removefieldnamecombox.GetCurSel() == -1) return;
	m_removefieldnamecombox.GetLBText(m_removefieldnamecombox.GetCurSel(),fieldname);
	if (m_CurFormField.GetName() == fieldname)
		m_CurFormField = NULL;
    m_PDFForm.RemoveFieldsByName(fieldname);
	if (fieldname == _T("JSBtn1"))
		m_JSButton1 = NULL;
	if (fieldname == _T("JSBtn2"))
		m_JSButton2 = NULL;
	m_removefieldnamecombox.DeleteString(m_removefieldnamecombox.GetCurSel());
	this->InitListFormField();
	//you also can call RemoveField to remove field
	/*int nsel = m_removefieldnamecombox.GetCurSel();
	CPDFFormField tempField = m_PDFForm.GetFieldByIndex(nsel);
    m_PDFForm.RemoveField(tempField);*/
}


void CFormDlg::OnEnterBtn() 
{
	// TODO: Add your control notification handler code here
	CInputDlg dlg;
	dlg.DoModal();
	CString inputstr = dlg.GetInputContent();
	m_inputlist.InsertString(g_index,inputstr);
	g_index++;
	m_bfirst = TRUE;
}

void CFormDlg::OnCreatepopulateBtn() 
{
	// TODO: Add your control notification handler code here
	if(!m_PDFForm)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	m_listbox1 = m_PDFForm.AddField(_T("PopListbox1"),_T("listbox"),m_ax.GetCurPage(),300,400,400,300);
	m_combobox1 = m_PDFForm.AddField(_T("PopCombox1"),_T("combobox"),m_ax.GetCurPage(),400,500,500,400);

	if (m_inputlist.GetCount() == 0)
	{
		MessageBox(_T("Please Input Content!"));
		return;
	}

	int nCount = m_inputlist.GetCount();
	TCHAR **export = new TCHAR *[nCount];
	CString strTemp;
	for (int i = 0;i<nCount;++i)
	{
		m_inputlist.GetText(i,strTemp);
		int strLength = strTemp.GetLength() + 1;
		export[i] = new TCHAR[strLength+1];
		export[i][strLength] = '\0';
		wcsncpy(export[i],strTemp,strLength);
	}
	
	TCHAR *t = _T("123");
	TCHAR *t1 = _T("456");
	TCHAR *t3 = _T("789");
	TCHAR *export1[3];
	export1[0] = t;
	export1[1] = t1;
	export1[2] = t3;
	
	VARIANT var_export = GetVariantFromStrings(export1,3);
	VARIANT var_items1 = GetVariantFromStrings(export,nCount);

	if (m_listbox1 == NULL) return;
	m_listbox1.PopulateListOrComboBox(var_items1,var_export);
   
    if (m_combobox1 == NULL) return;
	m_combobox1.PopulateListOrComboBox(var_export,var_items1);
	
	this->InitListFormField();
}

void CFormDlg::OnOpenFile() 
{
	// TODO: Add your command handler code here
	WCHAR Filter[100] = _T("pdf Files (*.pdf)|*.pdf|All Files (*.*)|*.*|||");
	UpdateData();
	CString pdffilenamestr = FileDialog(TRUE, NULL,Filter);
	m_ax.OpenFile(pdffilenamestr,_T(""));
}

void CFormDlg::OnSave() 
{
	// TODO: Add your command handler code here
	m_ax.Save();
}

void CFormDlg::OnSaveas() 
{
	// TODO: Add your command handler code here
	WCHAR Filter[100] = _T("pdf Files (*.pdf)|*.pdf|All Files (*.*)|*.*|||");
	UpdateData();
	CString pdffilenamestr = FileDialog(FALSE, _T(".pdf"),Filter);
	m_ax.SaveAs(pdffilenamestr);
}

void CFormDlg::OnCloseFile() 
{
	// TODO: Add your command handler code here
	m_ax.CloseFile();
}

void CFormDlg::OnExit() 
{
	// TODO: Add your command handler code here
	CDialog::OnCancel();
}

void ExceptionFun(TCHAR * pchar,const TCHAR* pcchar,int nlength)
{
	__try
	{
       wcsncpy(pchar,pcchar,nlength);
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
       return;
	}
}

void CFormDlg::OnExporttoFdf() 
{
	// TODO: Add your command handler code here
	if (m_PDFForm == NULL)return;
	CString strTemp;
    int nCount = m_PDFForm.GetFieldsCount();
	if(nCount == 0)
	{
		MessageBox(_T("The Document doesn't have any Form Field."));
		return;
	}
	WCHAR **export = new WCHAR *[nCount];
	
	for (int i = 0;i<nCount;++i)
    {
		CPDFFormField pdffield = m_PDFForm.GetFieldByIndex(i);
		strTemp = pdffield.GetName();
        int strLength = strTemp.GetLength() + 1;
		export[i] = new WCHAR[strLength+1];
		export[i][strLength] = '\0';
		//strncpy(export[i],strTemp,strLength);
		ExceptionFun(export[i],strTemp,strLength);
		// 		char *r = new char[strLength];
		// 	    strncpy(r, strTemp, strLength);
    }
	
	VARIANT var_items1 = GetVariantFromStrings(export,nCount);
	TCHAR Filter[100] = _T("fdf Files (*.fdf)|*.fdf|All Files (*.*)|*.*||");
	UpdateData();
	m_filepath = FileDialog(FALSE, _T(".fdf"),Filter);
    m_PDFForm.ExportToFDF(m_filepath,TRUE,var_items1);//TRUE export var_items1,FALSE export all except var_items1
	delete *export;
}

void CFormDlg::OnImportfromFdf() 
{
	// TODO: Add your command handler code here
	WCHAR Filter[100] = _T("fdf Files (*.fdf)|*.fdf|All Files (*.*)|*.*|||");
	UpdateData();
	m_filepath = FileDialog(TRUE, _T(""),Filter);
	m_PDFForm.ImportFromFDF(m_filepath);
}

void CFormDlg::OnModifyformfieldBtn() 
{
	// TODO: Add your control notification handler code here
	if(!m_PDFForm)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	if (m_CurFormField == NULL)
	{
		MessageBox(_T("Please select a form field and then try again."));
		return;
	}

	CString strFormType = m_CurFormField.GetType();

	UpdateData(TRUE);
	float fleft = (float)_wtol((LPCTSTR)m_leftstr);
	float ftop = (float)_wtol((LPCTSTR)m_topstr);
	float fbottom = (float)_wtol((LPCTSTR)m_bottomstr);
	float fright = (float)_wtol((LPCTSTR)m_rightstr);
	int nPageindex = m_ax.GetCurPage();

	if(strFormType == "text")
	{
		this->SetFormFieldProperties(m_CurFormField,strFormType);
		//only for text field
		CString aligstr = _T("");
		if (m_aligncombox.GetCurSel() != -1)
			m_aligncombox.GetLBText(m_aligncombox.GetCurSel(),aligstr);
		m_CurFormField.SetAlignment(aligstr);
		int ncharlimit = _wtoi(m_charlimitstr);
		m_CurFormField.SetCharLimit(ncharlimit);
		m_CurFormField.SetIsMultiline(m_ismultilinecheck.GetCheck());
		m_CurFormField.SetIsPassword(m_ispasswordcheck.GetCheck());
		m_CurFormField.SetIsRequired(m_isrequiredcheck.GetCheck());
		
		CString textfontstr = "";
		if (m_textfontcombox.GetCurSel() != -1)
			m_textfontcombox.GetLBText(m_textfontcombox.GetCurSel(),textfontstr);
		m_CurFormField.SetTextFont(textfontstr);
		
		int ntextsize = _wtoi(m_textsizestr);
		 m_CurFormField.SetTextSize(ntextsize);
	}
	if(strFormType == _T("button"))
	{
		this->SetFormFieldProperties(m_CurFormField,strFormType);
		CString textfontstr = _T("");
		if (m_textfontcombox.GetCurSel() != -1)
			m_textfontcombox.GetLBText(m_textfontcombox.GetCurSel(),textfontstr);
		m_CurFormField.SetTextFont(textfontstr);
		
		int ntextsize = _wtoi(m_textsizestr);
		m_CurFormField.SetTextSize(ntextsize);
		
        this->IsEnableButtonCtrl(TRUE);
	}
	if(strFormType == _T("combobox"))
	{
		this->SetFormFieldProperties(m_CurFormField,strFormType);
        //only for combobox
		m_CurFormField.SetIsEditable(m_iseditablecheck.GetCheck());
        m_CurFormField.SetIsRequired(m_isrequiredcheck.GetCheck());
		
		CString textfontstr = _T("");
		if (m_textfontcombox.GetCurSel() != -1)
			m_textfontcombox.GetLBText(m_textfontcombox.GetCurSel(),textfontstr);
		m_CurFormField.SetTextFont(textfontstr);
		
		int ntextsize = _wtoi(m_textsizestr);
	    m_CurFormField.SetTextSize(ntextsize);
	}
	if(strFormType == _T("listbox"))
	{
		this->SetFormFieldProperties(m_CurFormField,strFormType);
		
		CString textfontstr = _T("");
		if (m_textfontcombox.GetCurSel() != -1)
			m_textfontcombox.GetLBText(m_textfontcombox.GetCurSel(),textfontstr);
		m_CurFormField.SetTextFont(textfontstr);
		
		int ntextsize = _wtoi(m_textsizestr);
	    m_CurFormField.SetTextSize(ntextsize);
	}
	if(strFormType == _T("checkbox"))
	{
		this->SetFormFieldProperties(m_CurFormField,strFormType);
		CString stylestr = _T("");
		if (m_stylecombox.GetCurSel() != -1)
			m_stylecombox.GetLBText(m_stylecombox.GetCurSel(),stylestr);
		m_CurFormField.SetStyle(stylestr);
	}
	if(strFormType == _T("radiobox"))
	{
		this->SetFormFieldProperties(m_CurFormField,strFormType);
		m_CurFormField.SetIsRequired(m_isrequiredcheck.GetCheck());
	}
}

void CFormDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	m_ax.CloseFile();
	CDialog::OnClose();
}
