// FormDlg.h : header file
//
//{{AFX_INCLUDES()
#include "pdfform.h"
#include "pdfformfield.h"
#include "foxitpdfsdk.h"
//}}AFX_INCLUDES

#if !defined(AFX_FORMDLG_H__25B62DA9_8AA0_4495_86D8_B81797ECC35D__INCLUDED_)
#define AFX_FORMDLG_H__25B62DA9_8AA0_4495_86D8_B81797ECC35D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CFormDlg dialog

class CFormDlg : public CDialog
{
// Construction
private:
	CRect          m_rectOCX;
	CPDFForm       m_PDFForm;
	CPDFFormField  m_checkbox;
	CPDFFormField  m_radio;
	CPDFFormField  m_text;
	CPDFFormField  m_listbox;
	CPDFFormField  m_combobox;
    CPDFFormField  m_button;
	CPDFFormField  m_PDFFormField;
	CPDFFormField  m_JSButton1;
	CPDFFormField  m_JSButton2;
	CPDFFormField  m_submitfield;
    CPDFFormField  m_listbox1;
	CPDFFormField  m_combobox1;
    CPDFFormField  m_CurFormField;
	CString        m_filepath;
	CString        m_CurFieldtype;
	BOOL           m_bfirst;
public:
	CFormDlg(CWnd* pParent = NULL);	// standard constructor
    CString FileDialog(BOOL IsOpen,WCHAR * filext ,WCHAR *Filter);
	void    DisorEnableCtrl(BOOL bEnable);
	void    EnableALLCtrl();
	void    ClearAllCtrlValue();
	void    InitListFormField();
	void    ShowFieldProperty(int index);
	int     SetComboBoxCurSel(CComboBox &comboBox,CString str);
	void    SetFormFieldProperties(CPDFFormField &pdfFormField,CString type);
	void    IsEnableColorCtrl(BOOL bEnable);
	void    IsEnableButtonCtrl(BOOL bEnable);
// Dialog Data
	//{{AFX_DATA(CFormDlg)
	enum { IDD = IDD_FORM_DIALOG };
	CListBox	m_inputlist;
	CComboBox	m_triggercombox;
	CComboBox	m_textfontcombox;
	CComboBox	m_stylecombox;
	CComboBox	m_removefieldnamecombox;
	CButton	m_printflagcheck;
	CButton	m_noviewflagcheck;
	CListCtrl	m_fieldlist;
	CButton	m_isrequiredcheck;
	CButton	m_isreadonlycheck;
	CButton	m_ispasswordcheck;
	CButton	m_ismultilinecheck;
	CButton	m_isincludecheck;
	CButton	m_ishiddencheck;
	CButton	m_isexcludecheck;
	CButton	m_iseditablecheck;
	CComboBox	m_fieldtypecombox;
	CComboBox	m_fieldnamecombox;
	CButton	m_fgcolorcheck;
	CComboBox	m_btnlayoutcombox;
	CComboBox	m_btnfacecombox;
	CComboBox	m_borderstylecombox;
	CButton	m_bordercolorcheck;
	CButton	m_bgcolorcheck;
	CComboBox	m_aligncombox;
	CComboBox	m_colorspacecombox;
	CString	m_alphakstr;
	CString	m_blueystr;
	CString	m_borderwidthstr;
	CString	m_captionstr;
	CString	m_charlimitstr;
	CString	m_defaultvaluestr;
	CString	m_bottomstr;
	CString	m_leftstr;
	CString	m_rightstr;
	CString	m_fieldnamestr;
	CString	m_topstr;
	CString	m_filepathstr;
	CString	m_greenmstr;
	CString	m_orientationstr;
	CString	m_redcstr;
	CString	m_textsizestr;
	CString	m_tooltipstr;
	CString	m_urlstr;
	CFoxitPDFSDK	m_ax;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFormDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CFormDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnOnCloseDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnSelchangeFieldtypeCombo();
	afx_msg void OnClickLISTField(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnAddformfieldBtn();
	afx_msg void OnChangeBorderwidthEdit();
	afx_msg void OnChangeCharlimitEdit();
	afx_msg void OnChangeTextsizeEdit();
	afx_msg void OnChangeOrientationEdit();
	afx_msg void OnSetcolorBtn();
	afx_msg void OnChangeRedcEdit();
	afx_msg void OnChangeGreenmEdit();
	afx_msg void OnChangeBlueyEdit();
	afx_msg void OnChangeAlphakEdit();
	afx_msg void OnSetbtncaptionBtn();
	afx_msg void OnSetbtniconBtn();
	afx_msg void OnChoosefilepathBtn();
	afx_msg void OnAddtwobuttonBtn();
	afx_msg void OnSetjsactionBtn();
	afx_msg void OnResetjsactionBtn();
	afx_msg void OnAddsubmitformBtn();
	afx_msg void OnSelchangeRemovefieldnameCombo();
	afx_msg void OnDropdownRemovefieldnameCombo();
	afx_msg void OnRemovefieldBtn();
	afx_msg void OnEnterBtn();
	afx_msg void OnCreatepopulateBtn();
	afx_msg void OnOpenFile();
	afx_msg void OnSave();
	afx_msg void OnSaveas();
	afx_msg void OnCloseFile();
	afx_msg void OnExit();
	afx_msg void OnExporttoFdf();
	afx_msg void OnImportfromFdf();
	afx_msg void OnModifyformfieldBtn();
	afx_msg void OnClose();
	afx_msg void OnOK();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FORMDLG_H__25B62DA9_8AA0_4495_86D8_B81797ECC35D__INCLUDED_)
