// AX_Ppo_DemoDlg.h : header file
//
//{{AFX_INCLUDES()
#include "foxitpdfsdk.h"
//}}AFX_INCLUDES

#if !defined(AFX_AX_PPO_DEMODLG_H__FFD638EE_B36C_4EC3_8700_A4B814A2D464__INCLUDED_)
#define AFX_AX_PPO_DEMODLG_H__FFD638EE_B36C_4EC3_8700_A4B814A2D464__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CAX_Ppo_DemoDlg dialog

class CAX_Ppo_DemoDlg : public CDialog
{
// Construction
public:
	CAX_Ppo_DemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CAX_Ppo_DemoDlg)
	enum { IDD = IDD_AX_PPO_DEMO_DIALOG };
	CComboBox	m_iPageToIndex;
	CEdit	m_strBottomPos;
	CEdit	m_strRightPos;
	CEdit	m_strTopPos;
	CEdit	m_strLeftPos;
	CComboBox	m_flattenIndex;
	CComboBox	m_PageStop;
	CComboBox	m_dPageStart;
	CComboBox	m_iAtPageIndex;
	CComboBox	m_cPageIndex;
	CComboBox	m_iPageIndex2;
	CComboBox	m_iPageIndex1;
	CComboBox	m_iNewIndex;
	CComboBox	m_iOldIndex;
	CComboBox	m_rPageIndex;
	CComboBox	m_iRotate;
	CString	m_LeftBox;
	CString	m_TopBox;
	CString	m_RightBox;
	CString	m_BottomBox;
	CString	m_Width;
	CString	m_Height;
	CString	m_FilePath;
	BOOL	m_StateCheck;
	CString	m_fPageIndex;
	CString	m_tPageIndex;
	CString	m_Password;
	CFoxitPDFSDK	m_AX;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAX_Ppo_DemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CAX_Ppo_DemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSetRotate();
	afx_msg void OnSetIndex();
	afx_msg void OnSwap();
	afx_msg void OnSetCrop();
	afx_msg void OnInsert();
	afx_msg void OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnChooseFile();
	afx_msg void OnInsertFromFile();
	afx_msg void OnDelete();
	afx_msg void OnFlattenPage();
	afx_msg void OnShowContextMenu();
	afx_msg void OnOnCloseDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnOK();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	
	void ClearAllCtrlContents();
	
	void InitAllCtrlContents();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AX_PPO_DEMODLG_H__FFD638EE_B36C_4EC3_8700_A4B814A2D464__INCLUDED_)
