// AddWatermarkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Pro_Demo.h"
#include "AddWatermarkDlg.h"
#include "foxitpdfsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddWatermarkDlg dialog


CAddWatermarkDlg::CAddWatermarkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddWatermarkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddWatermarkDlg)
	m_csMark = _T("");
	m_nFontSize = 0;
	m_nLeft = 0;
	m_nBottom = 0;
	m_nAlpha = 0;
	m_nRotate = 0;
	m_nFontColor = 0;
	//}}AFX_DATA_INIT
	m_pAX = NULL;
}


void CAddWatermarkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddWatermarkDlg)
	DDX_Control(pDX, IDC_COMBO1, m_ctlMode);
	DDX_Text(pDX, IDC_EDIT1, m_csMark);
	DDX_Text(pDX, IDC_EDIT4, m_nFontSize);
	DDX_Text(pDX, IDC_EDIT2, m_nLeft);
	DDX_Text(pDX, IDC_EDIT3, m_nBottom);
	DDX_Text(pDX, IDC_EDIT6, m_nAlpha);
	DDX_Text(pDX, IDC_EDIT7, m_nRotate);
	DDX_Text(pDX, IDC_EDIT5, m_strFontColor);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddWatermarkDlg, CDialog)
	//{{AFX_MSG_MAP(CAddWatermarkDlg)
	ON_BN_CLICKED(IDC_PicColor, OnPicColor)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddWatermarkDlg message handlers
void CAddWatermarkDlg::init(CFoxitPDFSDK* pAX)
{
	m_pAX = pAX;
}

BOOL CAddWatermarkDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_csMark = _T("");
	m_nFontSize = 10;
	m_nFontColor = 0x00000000;
	m_nLeft = 0;
	m_nBottom = 0;
	m_nAlpha = 128;
	m_nRotate = 0;

	
	m_ctlMode.AddString(_T("Fill"));
	m_ctlMode.AddString(_T("Stroke"));
	m_ctlMode.AddString(_T("Fill and Stroke"));

	m_ctlMode.SetCurSel(0);
		
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddWatermarkDlg::OnPicColor() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CColorDialog cd;
	if(cd.DoModal() == IDOK)
	{
		COLORREF clRef = cd.GetColor();
		m_nFontColor = clRef;
		m_strFontColor.Format(_T("%0x"),clRef);
       
		UpdateData(FALSE);
	}
}

void CAddWatermarkDlg::OnAdd() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	long m_page = m_pAX->GetCurPage();
	 BOOL bSuccss = m_pAX->AddWaterMark((short)m_pAX->GetCurPage(), m_csMark, m_nLeft, m_nBottom, m_nFontSize, m_nFontColor,
		m_ctlMode.GetCurSel(), m_nAlpha, m_nRotate);
	OnOK();
}

void CAddWatermarkDlg::OnCancel() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();
}
