// DlgNavShow.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Pro_Demo.h"
#include "DlgNavShow.h"
#include "foxitpdfsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgNavShow dialog


CDlgNavShow::CDlgNavShow(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgNavShow::IDD, pParent)
	, m_pAx(NULL)
{
	//{{AFX_DATA_INIT(CDlgNavShow)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgNavShow::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgNavShow)
	DDX_Control(pDX, IDC_CBNAVSHOW, m_cbNavShow);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgNavShow, CDialog)
	//{{AFX_MSG_MAP(CDlgNavShow)
	ON_CBN_SELCHANGE(IDC_CBNAVSHOW, OnSelchangeCbnavshow)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgNavShow message handlers

void CDlgNavShow::init(CFoxitPDFSDK* pAX)
{
	m_pAx = pAX;
//	m_cbNavShow.SetCurSel(0);
}

void CDlgNavShow::OnSelchangeCbnavshow() 
{
	// TODO: Add your control notification handler code here
	CString str;
	int index = m_cbNavShow.GetCurSel();
	m_cbNavShow.GetLBText(index, str);
	if (!str.IsEmpty())
		if (NULL != m_pAx)
			m_pAx->ShowNavPanelByString(str);
}

BOOL CDlgNavShow::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class

	return CDialog::Create(IDD, pParentWnd);
}

BOOL CDlgNavShow::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_cbNavShow.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
