
// AX_Signature_DemoDlg.h : header file
//

#pragma once

#include "foxitpdfsdkproctrl.h"
#include "CPDFSignatureMgr.h"
#include "CPDFSignatureField.h"



// CAX_Signature_DemoDlg dialog
class CAX_Signature_DemoDlg : public CDialog
{
// Construction
public:
	CAX_Signature_DemoDlg(CWnd* pParent = NULL);	// standard constructor

public:
	void SetSignatureInfo(CPDFSignatureField signField);
	CPDFSignatureMgr m_SigFieldMgr;
// Dialog Data
	enum { IDD = IDD_AX_SIGNATURE_DEMO_DIALOG };
	CListCtrl	m_signlist;
	CButton	m_Click3rdSign;
	CButton	m_ClickSign;
	BOOL	m_bGray;
	BOOL	m_bBlur;
	BOOL	m_bHide;
	BOOL	m_bGrayPrint;
	CString	m_StraddleType;
	CFoxitPDFSDK	m_AX;

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;
	int m_nFileIndex;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSigndocument();
	afx_msg void OnVerity();
	afx_msg void On3rdsign();
	afx_msg void On3rdverify();
	afx_msg void OnOnSetSignatureInfoFoxitpdfsdkproctrl1(LPDISPATCH pSignature);
	afx_msg void OnAdd();
	afx_msg void OnOnSigningFoxitpdfsdkproctrl1(LPDISPATCH pSignature);
	afx_msg void OnOnVerifyingFoxitpdfsdkproctrl1(LPDISPATCH pSignature);
	afx_msg void OnStraddlesign();
	afx_msg void OnClear();
	afx_msg void OnRemove();
	afx_msg void OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnChturngray();
	afx_msg void OnChturnblur();
	afx_msg void OnChhidesign();
	afx_msg void OnChgrayprint();
	afx_msg void OnBtnprint();
	afx_msg void OnClickListSign(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnOK();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void SignDocument( BYTE* pSrcBuf, DWORD dwSrcLen, BYTE*& pSignedBuf, DWORD& dwSignedLen );
	BOOL VerifyByCustom( BYTE* pSrcBuf, DWORD dwSrcLen, BYTE* pSignedBuf, DWORD dwSignedLen );
	CString GetModulePath();
	void UpdateSignList();
};
