// AX_Pro_DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Pro_Demo.h"
#include "AX_Pro_DemoDlg.h"
#include "LanSelDlg.h"
#include "AddWatermarkDlg.h"
#include "PasswordInputDlg.h"
#include "DlgNavShow.h"
#include "DlgConvert.h"
#include "UploadFtpFileDlg.h"
#include "GetPageTextDlg.h"
#include "ExportPageDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAX_Pro_DemoDlg dialog

CAX_Pro_DemoDlg::CAX_Pro_DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAX_Pro_DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAX_Pro_DemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pBuffer = NULL;
	m_bOpenCustomer = FALSE;
	m_step = 0;
	m_pageindex = 0;
}

void CAX_Pro_DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAX_Pro_DemoDlg)
	DDX_Control(pDX, IDC_TREE1, m_outlinetree);
	DDX_Control(pDX, IDC_FOXITPDFSDKPROCTRL1, m_AX);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAX_Pro_DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CAX_Pro_DemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_FIND_TEXT, OnFindText)
	ON_COMMAND(ID_ZOOM_IN, OnZoomIn)
	ON_COMMAND(ID_ZOOM_OUT, OnZoomOut)
	ON_COMMAND(ID_ZOOM_TO, OnZoomTo)
	ON_COMMAND(IDD_ROTATE_RIGHT, OnRotateRight)
	ON_COMMAND(IDD_ROTATE_LEFT, OnRotateLeft)
	ON_COMMAND(IDD_FIRST_PAGE, OnFirstPage)
	ON_COMMAND(IDD_LAST_PAGE, OnLastPage)
	ON_COMMAND(IDD_NEXE_PAGE, OnNextPage)
	ON_COMMAND(IDD_PREV_PAGE, OnPrevPage)
	ON_NOTIFY(NM_CLICK, IDC_TREE1, OnClickTree1)
	ON_COMMAND(IDD_HAND_TOOL, OnHandTool)
	ON_COMMAND(IDD_ZOOM_IN_TOOL, OnZoomInTool)
	ON_COMMAND(IDD_ZOOM_OUT_TOOL, OnZoomOutTool)
	ON_COMMAND(IDD_PREVIOUS_VIEW, OnPreviousView)
	ON_COMMAND(IDD_NEXT_VIEW, OnNextView)
	ON_COMMAND(IDD_GOTO_PAGE, OnGotoPage)
	ON_COMMAND(IDD_ABOUT, OnAbout)
	ON_COMMAND(ID_HIDE_BOOKMARK, OnHideBookmark)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_COMMAND(IDD_FIND_FILE, OnFindFile)
	ON_COMMAND(IDD_SINGLE_PAGE, OnSinglePage)
	ON_COMMAND(IDD_FACE, OnFace)
	ON_COMMAND(IDD_CONTINUOUS_PAGE, OnContinuousPage)
	ON_COMMAND(IDD_CONTINUOUS_FACE, OnContinuousFace)
	ON_COMMAND(IDD_ACTUAL_SIZE, OnActualSize)
	ON_COMMAND(IDD_FIT_PAGE, OnFitPage)
	ON_COMMAND(IDD_FIT_WIDTH, OnFitWidth)
	ON_COMMAND(ID_SELECT_TEXT, OnSelectText)
	ON_COMMAND(IDD_SNAP_SHOT, OnSnapShot)
	ON_COMMAND(IDD_JAVA_CONSOLE, OnJavaConsole)
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(IDM_CUSTOMFILE_OPEN, OnCustomfileOpen)
	ON_COMMAND(IDM_DOCUMENT_INFO, OnDocumentInfo)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(IDM_FILE_SAVEAS, OnFileSaveas)
	ON_COMMAND(IDM_EXPORT_ANNOTATION, OnExportAnnotation)
	ON_COMMAND(IDM_IMPORT_ANNOTATION, OnImportAnnotation)
	ON_COMMAND(IDM_COPY_TEXT, OnCopyText)
	ON_COMMAND(IDM_FIND_FORMTEXT, OnFindFormtext)
	ON_COMMAND(IDM_EXPORT_FROM, OnExportFrom)
	ON_COMMAND(IDM_IMPORT_FORM, OnImportForm)
	ON_COMMAND(IDM_PRINT_NOTSHOW, OnPrintNotshow)
	ON_COMMAND(IDM_HIGHTLIGHT_RECT, OnHightlightRect)
	ON_WM_SIZE()
	ON_COMMAND(ID_OPEN_MEMFILE, OnOpenMemfile)
	ON_COMMAND(IDM_STREAMFILE_OPEN, OnStreamfileOpen)
	ON_COMMAND(ID_CHOOSE_LANGUAGE, OnChooseLanguage)
	ON_COMMAND(IDM_ADD_WATERMARK, OnAddWatermark)
	ON_COMMAND(IDM_ADVANCE_TOOL, OnAdvanceTool)
	ON_COMMAND(IDM_NAVPANEL_SHOW, OnNavpanelShow)
	ON_UPDATE_COMMAND_UI(IDM_NAVPANEL_SHOW, OnUpdateNavpanelShow)
	ON_COMMAND(IDM_GETSCROLOC, OnGetscroloc)
	ON_COMMAND(IDM_UPLOADFILE2FTP, OnUploadfile2ftp)
	ON_COMMAND(IDM_SETCRASHLOG, OnSetcrashlog)
	ON_COMMAND(IDM_COVERT, OnCovert)
	ON_COMMAND(IDM_REMOVEWATERMARK, OnRemovewatermark)
	ON_COMMAND(IDM_GETPAGE_TEXT, OnGetpageText)
	ON_COMMAND(IDM_EXPORT_PAGETOPDF, OnExportPagetopdf)
	ON_COMMAND(ID_BUFFERFILE_OPEN, OnBufferfileOpen)
	ON_COMMAND(ID_FILE_PROPERTIES, OnFileProperties)
	ON_COMMAND(IDM_GETHYPERLINK_BYSTEP, OnGetHyperlink)
	ON_COMMAND(IDM_GETHYPERLINK_INFO, OnGethyperlinkInfo)
	ON_COMMAND(IDD_Show_ToolTip, OnShowToolTip)
	ON_COMMAND(IDD_Show_ToolBar, OnShowToolBar)
	ON_COMMAND(IDM_PREVIOUS_VIEW, OnPreviousView)
	ON_COMMAND(IDM_NEXT_VIEW, OnNextView)
	ON_COMMAND(IDD_ShowNavigationPanels, OnShowNavigationPanels)
	ON_COMMAND(IDC_OK, OnOK)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAX_Pro_DemoDlg message handlers

void CAX_Pro_DemoDlg::OnOK()
{
	return;
}

BOOL CAX_Pro_DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

if (!m_wndToolBar.CreateEx(this, /*TBSTYLE_FLAT | TBSTYLE_LIST,*/ WS_CHILD | WS_VISIBLE | CBRS_TOP
		 | CBRS_TOOLTIPS  ) ||
		!m_wndToolBar.LoadToolBarEx(IDR_TOOLBAR1))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}  
    
	m_wndToolBar.init(&m_AX);



	CImageList ImgList;
	CBitmap bm;
	ImgList.Create(22,22,ILC_COLOR8|ILC_MASK, 21, 21);
	ImgList.SetBkColor(::GetSysColor(15));
	bm.LoadBitmap(IDB_BITMAP31);//OPEN
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP40);//Print
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP27);//first page
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP39);//prev page
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP37);//next page
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP45);//last page
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP47);//Previous View
	ImgList.Add(&bm, RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP46);//Next View
	ImgList.Add(&bm, RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP26);//count clockwise
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP25);//clockwise
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP42);//zoom in
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP21);//zoom out
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP23);//actual size
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP28);//fit page
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP29);//fit width
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP44);//search
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP24);//Bookmark
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP30);//hand tool
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP41);//snap shot
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	bm.LoadBitmap(IDB_BITMAP43);//select text
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();	
	bm.LoadBitmap(IDB_BITMAP22);//about
	ImgList.Add(&bm,RGB(0,255,0));
	bm.Detach();
	m_wndToolBar.GetToolBarCtrl().SetImageList(&ImgList);
	ImgList.Detach();
	
    RepositionBars(AFX_IDW_CONTROLBAR_FIRST,AFX_IDW_CONTROLBAR_LAST,0);
	
	CSize size(34,34);
	m_wndToolBar.GetToolBarCtrl().SetButtonSize(size);

	for(int i=0;i<m_AX.CountTools();i++)
    m_wndToolBar.m_ctrlWzdCombo.AddString( m_AX.GetToolByIndex( i ) );
	m_wndToolBar.m_ctrlWzdCombo.SetCurSel( 0 );
     
	m_bhidebookmark = false;
	rotatefactor = 0;
	zoomfactor = 0;
	m_ToolState = FALSE;
	m_TitleState = FALSE;
	m_NavigationPanelState = FALSE;
	//use UnLockActiveX Method to UnLock ActiveX 
	m_AX.UnLockActiveX(_T("Licence_ID"),_T("Unlock_code"));

	m_AX.ShowToolBar( m_ToolState );
	m_AX.ShowNavigationPanels(m_NavigationPanelState);
	m_AX.ShowTitleBar( m_TitleState );
	m_outlinetree.ShowWindow( 0 );
   
	this->ShowWindow(SW_SHOWMAXIMIZED);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CAX_Pro_DemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAX_Pro_DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics( SM_CXICON );
		int cyIcon = GetSystemMetrics( SM_CYICON );
		CRect rect;
		GetClientRect( &rect );
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);

	}
	else
	{	
		m_AX.MoveWindow( rect );
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAX_Pro_DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CAX_Pro_DemoDlg::OnFileOpen() 
{

	/******************************************************/
	/* SetModulePath() 
		Specify the path of fpdfcjk.bin file so that it could be used when rendering 
		the Chinese, Japanese and Korean text of a PDF. 	
	/*******************************************************/
	/*
	CString strPath = "";
	CFileDialog fdg1( true, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, "(*.bin)|*.bin", NULL);
	if(fdg1.DoModal() != IDOK) return;
	strPath = fdg1.GetPathName();
	int nPos;
	nPos = strPath.ReverseFind('\\');
	strPath = strPath.Left(nPos +1);
	m_AX.SetModulePath(strPath);*/

	CFileDialog fdg( true, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, _T("(*.pdf)|*.pdf"), NULL);
	if(fdg.DoModal() != IDOK) return;

	m_AX.CloseFile();
	m_AX.OpenFile(fdg.GetPathName() ,NULL );

	m_outlinetree.DestroyWindow();
	m_outlinetree.Create(WS_VISIBLE | WS_TABSTOP | WS_CHILD | WS_BORDER
		 | TVS_LINESATROOT | TVS_HASLINES| TVS_DISABLEDRAGDROP ,
    CRect(0, 40, 200, 950), this, IDC_TREE1);

	CPDFOutline outline;
	outline = m_AX.GetOutlineFirstChild( outline.m_lpDispatch );
    
	if (outline != NULL)
	{	
		outline = NULL;
		ProcOutline(outline,NULL);
	}
	
	OnMENUITEMexpandtree();
    if (m_outlinetree.GetCount()>0)
	{
		ShowBookMark();
		m_bhidebookmark = TRUE;
	}
	else
	{
		HideBookMark();
		m_bhidebookmark = FALSE;
	}
	//OnHideBookmark();
}


void CAX_Pro_DemoDlg::OnCustomfileOpen() 
{
	CFileDialog fd(true,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,_T("(*.pdf)|*.pdf"),NULL);
	CFileException e;
    WCHAR* pFileName = new WCHAR [ MAX_PATH ];

	if ( fd.DoModal() != IDOK) 
		return;
	wcscpy ( pFileName, fd.GetPathName().LockBuffer());
	
	m_AX.CloseFile();

	if( !m_f.Open( pFileName, CFile::modeRead | CFile::typeBinary , &e ) )
	   {
		#ifdef _DEBUG
		afxDump << _T("File could not be opened ") << e.m_cause << "\n";
		#endif
		delete [] pFileName;
		return;
	   }	
	delete [] pFileName;
	m_outlinetree.DeleteAllItems();
	// OpenCustomFile method trigger two events: OnCustomFileGetSize and
	//OnCustomFileGetBlock;
	m_AX.OpenCustomFile(_T(""));
	m_bOpenCustomer = TRUE;

	m_outlinetree.DestroyWindow();
	m_outlinetree.Create(WS_VISIBLE | WS_TABSTOP | WS_CHILD | WS_BORDER
		| TVS_LINESATROOT | TVS_HASLINES| TVS_DISABLEDRAGDROP,
    CRect(0, 40, 200, 950), this, IDC_TREE1);
	CPDFOutline outline;
	outline = m_AX.GetOutlineFirstChild( outline.m_lpDispatch );

	if (outline != NULL)
	{	
		outline = NULL;
		ProcOutline(outline,NULL);
	}
	OnMENUITEMexpandtree();
    if (m_outlinetree.GetCount()>0)
	{
		ShowBookMark();
		m_bhidebookmark = TRUE;
	}
	else
	{
		HideBookMark();
		m_bhidebookmark = FALSE;
	}
}

// Use OpenMemFile to open PDF in the memory.
void CAX_Pro_DemoDlg::OnOpenMemfile() 
{
	CFileDialog fd(true,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,_T("(*.pdf)|*.pdf"),NULL);
	CFileException e;
    CString csFileName;
	
	if ( fd.DoModal() != IDOK) 
		return;
	csFileName = fd.GetPathName();
	m_AX.CloseFile();
	
	DWORD dwfilesize,dwreadbytes;
	HANDLE hFile = CreateFile(csFileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	dwfilesize = GetFileSize(hFile, NULL);
	m_pBuffer = new BYTE[dwfilesize];
	ReadFile(hFile, m_pBuffer, dwfilesize, &dwreadbytes,
		NULL);
	CloseHandle(hFile);
//	m_outlinetree.DeleteAllItems();
	m_AX.OpenMemFile((long)m_pBuffer, dwfilesize, _T(""));
	
	// 	or you could open pdf file in this way:
	//---------------------------------------------------------------------------------------
	// 	tagVARIANT source;
	// 	source.vt = VT_BSTR;
	// 	source.bstrVal = BSTR(m_pBuffer);
	// 	m_AX.OpenBuffer(source, dwfilesize, "");	
    
	m_outlinetree.DestroyWindow();
	m_outlinetree.Create(WS_VISIBLE | WS_TABSTOP | WS_CHILD | WS_BORDER
		| TVS_LINESATROOT | TVS_HASLINES| TVS_DISABLEDRAGDROP,
    CRect(0, 40, 200, 950), this, IDC_TREE1);
	CPDFOutline outline;
	outline = m_AX.GetOutlineFirstChild( outline.m_lpDispatch );

	if (outline != NULL)
	{	
		outline = NULL;
		ProcOutline(outline,NULL);
	}
	OnMENUITEMexpandtree();
    if (m_outlinetree.GetCount()>0)
	{
		ShowBookMark();
		m_bhidebookmark = TRUE;
	}
	else
	{
		HideBookMark();
		m_bhidebookmark = FALSE;
	}
}

// use openstream to open a PDF stream file
void CAX_Pro_DemoDlg::OnStreamfileOpen() 
{
 	IStream *pStm; 
 	CFileStatus fstatus; 
 	CFile file; 
 	LONG cb; 
 	
 	CFileDialog fd(true,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
 		_T("(*.pdf)|*.pdf"),NULL);
 	if ( fd.DoModal() != IDOK) 
 		return;
	m_AX.CloseFile();
 	if (file.Open(fd.GetPathName(),CFile::modeRead) && 
 		file.GetStatus(fd.GetPathName(), fstatus) && 
 		((cb = fstatus.m_size) != -1)) 
 	{ 
 		HGLOBAL hGlobal = GlobalAlloc(GMEM_MOVEABLE, cb); 
 		LPVOID pvData = NULL; 
 		if (hGlobal != NULL) 
 		{ 
 			if ((pvData = GlobalLock(hGlobal)) != NULL) 
 			{ 
 				file.Read(pvData, cb); 
 				GlobalUnlock(hGlobal); 
 				CreateStreamOnHGlobal(hGlobal, TRUE, &pStm);
 			}
 		}
 		m_outlinetree.DeleteAllItems();
 		m_AX.OpenStream(pStm, _T(""));
        
		GlobalFree(hGlobal);
 	}
 	pStm->Release();

	m_outlinetree.DestroyWindow();
	m_outlinetree.Create(WS_VISIBLE | WS_TABSTOP | WS_CHILD | WS_BORDER
		| TVS_LINESATROOT | TVS_HASLINES| TVS_DISABLEDRAGDROP,
    CRect(0, 40, 200, 950), this, IDC_TREE1);
	CPDFOutline outline;
	outline = m_AX.GetOutlineFirstChild( outline.m_lpDispatch );

	if (outline != NULL)
	{	
		outline = NULL;
		ProcOutline(outline,NULL);
	}
	OnMENUITEMexpandtree();
    if (m_outlinetree.GetCount()>0)
	{
		ShowBookMark();
		m_bhidebookmark = TRUE;
	}
	else
	{
		HideBookMark();
		m_bhidebookmark = FALSE;
	}
}

void CAX_Pro_DemoDlg::OnFileSave() 
{
	m_AX.Save();	
}


void CAX_Pro_DemoDlg::OnFileSaveas() 
{
	CFileDialog fdg(false, _T(".pdf"), NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, 
		_T("(*.pdf)|*.pdf"), NULL);
	if(fdg.DoModal() != IDOK) 
		return;
	m_AX.SaveAs( fdg.GetPathName() );
	
}

//print the File,which you could set several properties of the printer as follows;
void CAX_Pro_DemoDlg::OnFilePrint() 
{
	CPDFPrinter printer = m_AX.GetPrinter();
	if (!printer)
	{
		return;
	}
	//printer.SetPrinterName( "foxit PDF" );
	printer.SetPrinterRangeMode( 3 );
	printer.SetPrinterRangeFrom( 2 );
	printer.SetPrinterRangeTo( 3 );
	printer.SetPaperSize( 8 );
	printer.SetNumOfCopies( 2 );
	printer.PrintWithDialog();
	
}
//when you want to print a PDF file which do not need open it first.
void CAX_Pro_DemoDlg::OnPrintNotshow() 
{
#define _OpenFile_Normal_
#ifdef _OpenFile_Normal_
	CFileDialog fdg( true, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, _T("(*.pdf)|*.pdf"), NULL);
	if(fdg.DoModal() != IDOK) return;
	CString spath = fdg.GetPathName();
	CPDFPrinter printer = m_AX.OpenFileForPrinter( spath );
#else
/************************************************************************/
/*        OpenMemFileForPrinter()
		  test by zg													*/
/************************************************************************/
	CFileDialog fd(true,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,_T("(*.pdf)|*.pdf"),NULL);
	CFileException e;
    CString csFileName;
	
	if ( fd.DoModal() != IDOK) 
		return;
	csFileName = fd.GetPathName();
	m_AX.CloseFile();
	
	DWORD dwfilesize,dwreadbytes;
	HANDLE hFile = CreateFile(csFileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	dwfilesize = GetFileSize(hFile, NULL);
	m_pBuffer = new BYTE[dwfilesize];
	ReadFile(hFile, m_pBuffer, dwfilesize, &dwreadbytes,
		NULL);
	CloseHandle(hFile);
	CPDFPrinter printer = m_AX.OpenMemFileForPrinter((long)m_pBuffer, dwfilesize);

//end by zg
#endif
	if (!printer)
	{
		return;
	}
	printer.PrintWithDialog();	
	//printer.PrintQuiet();
}

//get the text using the Select Text Tool
void CAX_Pro_DemoDlg::OnCopyText() 
{
	CString m_spagetext = m_AX.GetSelectedText();
	if(OpenClipboard() && (m_spagetext != _T("")))
	{
	 HGLOBAL clipbuffer;
	 WCHAR * buffer;

	 EmptyClipboard();
	 clipbuffer = GlobalAlloc(GMEM_DDESHARE, (m_spagetext.GetLength() + 1)*(sizeof(TCHAR)));
	 buffer = ( WCHAR* )GlobalLock( clipbuffer );
	 wcscpy(buffer,  m_spagetext );
	 GlobalUnlock( clipbuffer );
	 SetClipboardData(CF_UNICODETEXT, clipbuffer);
	 CloseClipboard();

	 AfxMessageBox(_T("copy success!"), MB_OK);
	}

	long nSize = 0L;
    nSize = m_AX.GetSelectedTextEx(NULL, nSize);
	long *buf = new long[nSize];
	nSize = m_AX.GetSelectedTextEx(buf, nSize);
	delete []buf;

}

//search the text in the File
void CAX_Pro_DemoDlg::OnFindText() 
{
	CFindDlg fd;
	fd.init(&m_AX);
	fd.DoModal();
}


void CAX_Pro_DemoDlg::OnFindFile() 
{
	CFindFoldDlg *fd = new CFindFoldDlg;
	fd->init(&m_AX);
	fd -> Create(IDD_FIND_FOLD, NULL);
	fd -> ShowWindow( SW_SHOW );
}


void CAX_Pro_DemoDlg::OnFindFormtext() 
{
	CFindFormText ff;
	ff.init(&m_AX);
	ff.DoModal();
}


void CAX_Pro_DemoDlg::OnZoomIn() 
{   
	zoomfactor = m_AX.GetZoomLevel();

	if(zoomfactor + 10 > 6400) 
		zoomfactor = 6400;
	else 
		zoomfactor = zoomfactor + 10;
	
	m_AX.SetZoomLevel( zoomfactor );
	
}


void CAX_Pro_DemoDlg::OnZoomOut() 
{
    zoomfactor = m_AX.GetZoomLevel();

	if(zoomfactor - 10 > 0) 
		zoomfactor = zoomfactor - 10;

	m_AX.SetZoomLevel( zoomfactor );
}


void CAX_Pro_DemoDlg::OnZoomTo() 
{
	CZoom zoom;
	zoom.init(&m_AX);
	zoom.DoModal();

}


void CAX_Pro_DemoDlg::OnRotateRight() 
{
    if(rotatefactor == 3) 
		rotatefactor = 0;
	else 
		rotatefactor++;
	m_AX.SetRotate(rotatefactor);
}


void CAX_Pro_DemoDlg::OnRotateLeft() 
{  
	if(rotatefactor == 0) rotatefactor=3;
    else rotatefactor--;
	m_AX.SetRotate( rotatefactor );
}


void CAX_Pro_DemoDlg::OnFirstPage() 
{    
	m_AX.GoToPage(0);
}


void CAX_Pro_DemoDlg::OnLastPage() 
{
	int count = m_AX.GetPageCount();
	m_AX.GoToPage(count-1);	
}


void CAX_Pro_DemoDlg::OnNextPage() 
{   int count = m_AX.GetPageCount();  
    int current = m_AX.GetCurPage();

    if(current+1 <= count-1)
		m_AX.GoToPage(current+1);
   
	
	
}


void CAX_Pro_DemoDlg::OnPrevPage() 
{  
	int count = m_AX.GetPageCount();  
    int current = m_AX.GetCurPage();

    if(current-1 >= 0)
		m_AX.GoToPage(current-1);
	
	
}


void CAX_Pro_DemoDlg::OnMENUITEMexpandtree() //Spread all nodes
{
    // TODO: Add your command handler code here
	HTREEITEM hRootItem = m_outlinetree.GetRootItem();
    while(hRootItem != NULL)
	{
      MyExpandTree(hRootItem); 
	  hRootItem = m_outlinetree.GetNextSiblingItem(hRootItem);
	}
	
}

void CAX_Pro_DemoDlg::MyExpandTree(HTREEITEM hTreeItem)
{
    if(!m_outlinetree.ItemHasChildren(hTreeItem))
    {
        return;
    }
    HTREEITEM hNextItem = m_outlinetree.GetChildItem(hTreeItem);
    while (hNextItem != NULL)
    {
        MyExpandTree(hNextItem);
        hNextItem = m_outlinetree.GetNextItem(hNextItem, TVGN_NEXT);
    }
    m_outlinetree.Expand(hTreeItem,TVE_EXPAND);
}


void CAX_Pro_DemoDlg::ProcOutline(CPDFOutline outline,HTREEITEM hParentItem)
{
	outline=m_AX.GetOutlineFirstChild(outline.m_lpDispatch);
	
	while(outline!=NULL)
	{
       
		CString a = outline.GetOutlineTitle();
		TVINSERTSTRUCT tvis;
		HTREEITEM hItem = NULL;
		tvis.hParent = hParentItem;
		tvis.hInsertAfter = TVI_LAST;
		tvis.item.mask = TVIF_TEXT | TVIF_CHILDREN | TVIS_EXPANDEDONCE;
		tvis.item.pszText = a.LockBuffer ( );
		hItem = m_outlinetree.InsertItem ( &tvis );
		a.ReleaseBuffer();
		m_bookMarkMap.SetAt ( hItem, outline );
		ProcOutline(outline,hItem);
		outline=m_AX.GetOutlineNextSibling( outline.m_lpDispatch );

	}
}


void CAX_Pro_DemoDlg::OnClickTree1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	DWORD dw = GetMessagePos();
	POINTS ps = MAKEPOINTS( dw );	
	CPoint pt;
	pt.x = ps.x;
	pt.y = ps.y;
	
	m_outlinetree.ScreenToClient( &pt );
	UINT uFlags;
	HTREEITEM hItem = m_outlinetree. HitTest( pt, &uFlags );
	
	if ( NULL != hItem && TVHT_ONITEM & uFlags )
	{     
		CPDFOutline outline;

		if ( m_bookMarkMap.Lookup ( hItem, outline ) )
		{
			if ( outline != NULL)
			{
			   outline.NavigateOutline();
			}
			
		}
	}
			
	*pResult = 0;
}


void CAX_Pro_DemoDlg::OnHandTool() 
{

	m_AX.SetCurrentTool( _T("Hand Tool"));
	
}


void CAX_Pro_DemoDlg::OnZoomInTool() 
{
	m_AX.SetCurrentTool( _T("ZoomIn Tool") );	
}


void CAX_Pro_DemoDlg::OnZoomOutTool() 
{

	m_AX.SetCurrentTool( _T("ZoomOut Tool"));
	
}


void CAX_Pro_DemoDlg::OnPreviousView() 
{
	if(m_AX.ExistBackwardStack())
		m_AX.GoBackwardStack();

}


void CAX_Pro_DemoDlg::OnNextView() 
{
	if(m_AX.ExistForwardStack())
        m_AX.GoForwardStack();
}


void CAX_Pro_DemoDlg::OnGotoPage() 
{
	CGotopage m_gotopage;
	m_gotopage.init(&m_AX);
	m_gotopage.DoModal();	
}


void CAX_Pro_DemoDlg::OnHightlightRect() 
{	
	long PageNum;
	float left, top, right, bottom;

	m_AX.ConvertClientCoordToPageCoord( 20, 20, &PageNum, &left, &top );
	m_AX.ConvertClientCoordToPageCoord( 400, 400, &PageNum, &right, &bottom );
	m_AX.Highlight( PageNum, left, top, right, bottom );
	m_AX.SetViewRect( left, top, right - left, top - bottom );
}


void CAX_Pro_DemoDlg::OnAbout() 
{
	m_AX.AboutBox();
}

void CAX_Pro_DemoDlg::ShowBookMark()
{
    m_outlinetree.ShowWindow(TRUE);
	
	GetClientRect(&rect);
  
	rect.top = rect.top + 40;
	rect.left = rect.left + 200;	
	rect.right = rect.right - 20;
	m_AX.MoveWindow( rect );	 
}

void CAX_Pro_DemoDlg::HideBookMark()
{
    m_outlinetree.ShowWindow(FALSE);
	
	GetClientRect(&rect);
	rect.top = rect.top + 40;
	m_AX.MoveWindow( rect );	 
}

void CAX_Pro_DemoDlg::OnHideBookmark() 
{   
	 m_outlinetree.ShowWindow(!m_bhidebookmark);
     
     GetClientRect(&rect);
	 if(m_bhidebookmark)
		rect.top = rect.top + 40;
     else 
	 {   
		 rect.top = rect.top + 40;
		 rect.left = rect.left + 200;	
		 rect.right = rect.right - 20;
	 } 
	 m_AX.MoveWindow( rect );	 

	 m_bhidebookmark = !m_bhidebookmark;
}


void CAX_Pro_DemoDlg::OnFileClose() 
{
	m_AX.CloseFile();
//	m_outlinetree.DestroyWindow();	
    m_outlinetree.DeleteAllItems();
}


void CAX_Pro_DemoDlg::OnSinglePage() 
{
	m_AX.SetLayoutShowMode(0, 1);
}


void CAX_Pro_DemoDlg::OnFace() 
{
	
	m_AX.SetLayoutShowMode(0, 2);

}

void CAX_Pro_DemoDlg::OnContinuousPage() 
{  
    m_AX.SetLayoutShowMode(1, 1);	

	
}

void CAX_Pro_DemoDlg::OnContinuousFace() 
{
	m_AX.SetLayoutShowMode(1, 2);

}


void CAX_Pro_DemoDlg::OnActualSize() 
{
	m_AX.SetZoomLevel(0);
}


void CAX_Pro_DemoDlg::OnFitPage() 
{
	m_AX.SetZoomLevel(1);
}


void CAX_Pro_DemoDlg::OnFitWidth() 
{
	m_AX.SetZoomLevel(2);
}


void CAX_Pro_DemoDlg::OnSelectText() 
{
	m_AX.SetCurrentTool(_T("Select Text Tool"));
}


void CAX_Pro_DemoDlg::OnSnapShot() 
{
	m_AX.SetCurrentTool(_T("Snapshot Tool"));	
//	m_AX.SetCurrentTool("Magnifier");
}

BEGIN_EVENTSINK_MAP(CAX_Pro_DemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CAX_Pro_DemoDlg)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 6 /* OnHypeLink */, OnOnHypeLinkFoxitpdfsdkproctrl1, VTS_BSTR VTS_BSTR VTS_DISPATCH VTS_PBOOL)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 9 /* CustomFileGetSize */, OnCustomFileGetSizeFoxitpdfsdkproctrl1, VTS_PI4)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 10 /* CustomFileGetBlock */, OnCustomFileGetBlockFoxitpdfsdkproctrl1, VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 7 /* OnSearchProgress */, OnOnSearchProgressFoxitpdfsdkproctrl1, VTS_I4 VTS_I4)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 8 /* OnOpenDocument */, OnOnOpenDocumentFoxitpdfsdkproctrl1, VTS_BSTR)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 5 /* OnOpenPassword */, OnOnOpenPasswordFoxitpdfsdkproctrl1, VTS_PBSTR VTS_PBOOL)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 4 /* OnPageChange */, OnOnPageChangeFoxitpdfsdkproctrl1, VTS_NONE)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 3 /* OnZoomChange */, OnOnZoomChangeFoxitpdfsdkproctrl1, VTS_NONE)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 2 /* AfterDraw */, OnAfterDrawFoxitpdfsdkproctrl1, VTS_I4)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 1 /* BeforeDraw */, OnBeforeDrawFoxitpdfsdkproctrl1, VTS_I4)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 16 /* OnCloseDocument */, OnOnCloseDocumentFoxitpdfsdkproctrl1, VTS_BSTR)
	ON_EVENT(CAX_Pro_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 15 /* OnRButtonClick */, OnOnRButtonClickFoxitpdfsdkproctrl1, VTS_I4 VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//triggered when a hypelink is clicked
void CAX_Pro_DemoDlg::OnOnHypeLinkFoxitpdfsdkproctrl1(LPCTSTR linktype, LPCTSTR linkdata, LPDISPATCH dest, BOOL FAR* cancel) 
{
	CString strlinktype = linktype;
	CString strlinkdata = linkdata;

	if(strlinktype == "Launch")
	{ 

      int i = strlinkdata.ReverseFind(':');
	  CString filepath = strlinkdata.Left(i);
	  CString strbNewWindow = strlinkdata.Right(strlinkdata.GetLength()-i-1);
	  BOOL bNewWindow = _wtoi(strbNewWindow);

      if (filepath != "")
		{
			CString csExt = filepath.Right(4);
			if (!csExt.CollateNoCase(_T(".pdf")) )
			{   
				if(bNewWindow)
				{
				   m_AX.OpenFile(filepath,_T("")) ;
				}
				else
				{  
				   //m_AX.OpenFile(csSrcFile,"") ; 
					WCHAR *pSrcFile = new WCHAR [MAX_PATH];
					wcscpy(pSrcFile, filepath);
					m_AX.OpenFile(pSrcFile, _T(""));
				}
			}
			else
			{
              ShellExecute(NULL, _T("open"), filepath, NULL, NULL, SW_SHOWNORMAL);
			}
		}
		* cancel=TRUE;
	}

	else if(strlinktype=="GoToR")
	{
		int i=strlinkdata.ReverseFind(':');
		CString filepath=strlinkdata.Left(i);
		CString strbNewWindow=strlinkdata.Right(strlinkdata.GetLength()-i-1);
		BOOL bNewWindow=_wtoi(strbNewWindow);

		if (filepath !="")
		{
		  	CLink_Dest tempdest=dest;
			if(bNewWindow)
			{
				// m_AX2.OpenFile(filepath,"") ;
			}
			else
			{  
				//m_AX.OpenFile(csSrcFile,"") ; 
				WCHAR *pSrcFile=new WCHAR[MAX_PATH];
				wcscpy(pSrcFile, filepath);
				m_AX.OpenFile(_T("D:\\002.pdf"), _T(""));
				m_AX.GoToPageDest(tempdest);
			}
		}
		* cancel=TRUE;
	}
	
}


void CAX_Pro_DemoDlg::OnOnSearchProgressFoxitpdfsdkproctrl1(long pageNumber, long PageCount) 
{
	//triggered when you search a document,pageNumber is the page currently been searched,
	//PageCount is the total number of the pages
}


void CAX_Pro_DemoDlg::OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath) 
{
//	AfxMessageBox(FilePath);
	//MessageBox("Doc");
}


void CAX_Pro_DemoDlg::OnOnOpenPasswordFoxitpdfsdkproctrl1(BSTR FAR* Password, BOOL FAR* cancel) 
{

	CPasswordInputDlg dlg;
	if(dlg.DoModal() == IDOK)
	{
		*Password = dlg.m_csPassword.AllocSysString();
		*cancel = FALSE;
	}
// triggered when open a PDF File with Password
}


void CAX_Pro_DemoDlg::OnOnPageChangeFoxitpdfsdkproctrl1() 
{
	// triggered when page changed	
	//MessageBox("page");
}


void CAX_Pro_DemoDlg::OnOnZoomChangeFoxitpdfsdkproctrl1() 
{
	//triggered when ZoomLever changed
	
}


void CAX_Pro_DemoDlg::OnAfterDrawFoxitpdfsdkproctrl1(long dc) 
{
	// triggered after the painting of viewer contents is completed
	
}


void CAX_Pro_DemoDlg::OnBeforeDrawFoxitpdfsdkproctrl1(long dc) 
{
	// triggered before the painting of viewer contents is about to begin
	
}


void CAX_Pro_DemoDlg::OnJavaConsole() 
{

	m_AX.ShowDocJsDialog();
	
}


void CAX_Pro_DemoDlg::OnCustomFileGetSizeFoxitpdfsdkproctrl1(long FAR* size) 
{
	long len = m_f.GetLength();
	*size = len;
}	


void CAX_Pro_DemoDlg::OnCustomFileGetBlockFoxitpdfsdkproctrl1(long pos, long pBuf, long size) 
{
	m_f.Seek(pos, CFile::begin);
	m_f.Read((void *)pBuf, size);	
}


void CAX_Pro_DemoDlg::OnExit() 
{
	//exit( 0 );
	CDialog::OnCancel();
}


void CAX_Pro_DemoDlg::OnDocumentInfo() 
{

	//m_AX.ShowDocumentInfoDialog();
	
}


void CAX_Pro_DemoDlg::OnExportAnnotation() 
{		
	CFileDialog fdg( false, _T(".pdf"), NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, _T("(*.fdf)|*.fdf"), NULL );
	if( fdg.DoModal() != IDOK ) return;
    
	m_AX.ExportAnnotsToFDFFile( fdg.GetPathName() );
	
}


void CAX_Pro_DemoDlg::OnImportAnnotation() 
{
    CFileDialog fdg( true, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, _T("(*.fdf)|*.fdf"), NULL );
	if( fdg.DoModal() != IDOK ) return;
    
	m_AX.ImportAnnotsFromFDFFile( fdg.GetPathName() );
}


void CAX_Pro_DemoDlg::OnExportFrom() 
{
	CFileDialog fdg( false, _T(".pdf"), NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, _T("(*.fdf)|*.fdf"), NULL );
	if( fdg.DoModal() != IDOK ) return;
	
	if( m_AX.GetBHasFormFields() )
		m_AX.ExportFormToFDFFile( fdg.GetPathName() );
}


void CAX_Pro_DemoDlg::OnImportForm() 
{
	CFileDialog fdg( true, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, _T("(*.fdf)|*.fdf"), NULL );
	if( fdg.DoModal() != IDOK ) return;

	m_AX.ImportFormFromFDFFile( fdg.GetPathName() );
}


void CAX_Pro_DemoDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	GetClientRect(&rect);

	if(m_bhidebookmark)
	{
		rect.top = rect.top + 40;
		rect.left = rect.left + 200;
		rect.right = rect.right - 20;
	}
	else 
	{  
		rect.top = rect.top + 40;	
	} 
	Invalidate(TRUE);
	
}



void CAX_Pro_DemoDlg::OnChooseLanguage() 
{

	CLanSelDlg* pLS = new CLanSelDlg();
	pLS->init(&m_AX);
	pLS->DoModal();
	delete pLS;
}

//void CAX_Pro_DemoDlg::OnOnContextMenuFoxitpdfsdkproctrl1(long hWnd, long ClientX, long ClientY) 
//{
	// TODO: Add your control notification handler code here
//	AfxMessageBox("HeiHei");
	//m_AX.SetCurrentTool("Note Tool");
//}

void CAX_Pro_DemoDlg::OnOnRButtonClickFoxitpdfsdkproctrl1(long hWnd, long ClientX, long Client) 
{
	// TODO: Add your control notification handler code here
}



void CAX_Pro_DemoDlg::OnAddWatermark() 
{
	// TODO: Add your command handler code here
	CAddWatermarkDlg wm;
	wm.init(&m_AX);
	wm.DoModal();
}

void CAX_Pro_DemoDlg::OnAdvanceTool() 
{
	// TODO: Add your command handler code here
	m_wndToolBar.m_ctrlWzdCombo.ShowDropDown(TRUE);	
}



void CAX_Pro_DemoDlg::OnOnCloseDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath) 
{
	// TODO: Add your control notification handler code here
	if(m_pBuffer)
	{
		delete m_pBuffer;
		m_pBuffer = NULL;
	}
	if(m_bOpenCustomer) 
	{
		m_f.Close();
		m_bOpenCustomer = FALSE;
	}
	m_outlinetree.DeleteAllItems();
}

void CAX_Pro_DemoDlg::OnNavpanelShow() 
{
	// TODO: Add your command handler code here
/************************************************************************/
/*   ShowNavPanelByString()                                          
	 test by zg															*/
/************************************************************************/
	BOOL bPanelShow = m_AX.GetPanelStatus();
	m_AX.ShowNavigationPanels(FALSE);
	CDlgNavShow dlg;
	dlg.init(&m_AX);
	dlg.DoModal();

//	m_AX.ShowNavPanelByString("Layer");
//end by zg
}

void CAX_Pro_DemoDlg::OnUpdateNavpanelShow(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

}

void CAX_Pro_DemoDlg::OnGetscroloc() 
{
	// TODO: Add your command handler code here
/************************************************************************/
/*   GetScrollLocationEx()                                          
	 test by zg                                                         */
/************************************************************************/	
	long lHpos = 0;
	long lVpos = 0;
	m_AX.GetScrollLocation(&lHpos, &lVpos);

	VARIANT varHpos;
	VARIANT varVpos;
	m_AX.GetScrollLocationEx(&varHpos, &varVpos);
	long lvarHpos = varHpos.lVal;
	long lvarVpos = varVpos.lVal;
	CString str;
	str.Format(_T("Hor Pos: %d, Ver Pos: %d"), lvarHpos, lvarVpos);
	AfxMessageBox(str);
//end by zg
}

void CAX_Pro_DemoDlg::OnUploadfile2ftp() 
{
	// TODO: Add your command handler code here
/************************************************************************/
/*   UploadCurFileToFTPEx()                                          
	 test by zg                                                         */
/************************************************************************/	
// 	CFileDialog dlg( TRUE, ".pdf", NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, "PDF Files(*.pdf)|*.pdf|All Files(*.*)|*.*||", NULL );
// 	if( dlg.DoModal() != IDOK ) return;
// 
// 	CString strFilePath = dlg.GetPathName();
// 	BOOL bUploadFile = m_AX.UploadCurFileToFTP((LPCTSTR)strFilePath);
	CUploadFtpFileDlg ftpDlg;
	if ( IDOK == ftpDlg.DoModal())
	{
		BOOL bUploadFile = m_AX.UploadCurFileToFTP((LPCTSTR)ftpDlg.m_ftpname,(LPCTSTR)ftpDlg.m_username,(LPCTSTR)ftpDlg.m_userpassword,ftpDlg.m_port,(LPCTSTR)ftpDlg.m_filepath);
		//end by zg
	}
	

}

void CAX_Pro_DemoDlg::OnSetcrashlog() 
{
	// TODO: Add your command handler code here
/************************************************************************/
/*   SetCrashLog()                                        
	 test by zg                                                         */
/************************************************************************/	
	CString strFolder;
	LPMALLOC lpMalloc;
	
	if (::SHGetMalloc(&lpMalloc) != NOERROR) return ;
	
	WCHAR szDisplayName[_MAX_PATH];
	WCHAR szBuffer[_MAX_PATH];
	BROWSEINFO browseInfo;
	browseInfo.hwndOwner = m_hWnd;
	browseInfo.pidlRoot = NULL; // set root at Desktop
	browseInfo.pszDisplayName = szDisplayName;
	LPWSTR text = _T("Select a folder");
	browseInfo.lpszTitle = text;
	browseInfo.ulFlags = BIF_RETURNFSANCESTORS|BIF_RETURNONLYFSDIRS;
	browseInfo.lpfn = NULL;
	browseInfo.lParam = 0;
	
	LPITEMIDLIST lpItemIDList;
	if ((lpItemIDList = ::SHBrowseForFolder(&browseInfo)) != NULL)
	{
		// Get the path of the selected folder from the    item ID list.
		if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
		{
			//if (szBuffer[0] == '\0') return ;
			strFolder = szBuffer;
		}
		else return ; // strResult is empty
		
		lpMalloc->Free(lpItemIDList);
		lpMalloc->Release();
    }

	if (!strFolder.IsEmpty())
	{
		m_AX.SetCrashLog(strFolder);
	}
//end by zg
}

void CAX_Pro_DemoDlg::OnCovert() 
{
	// TODO: Add your command handler code here
	CDlgConvert dlg;
	dlg.Init(&m_AX);
	dlg.DoModal();
}

void CAX_Pro_DemoDlg::OnRemovewatermark() 
{
	// TODO: Add your command handler code here
	if (m_AX.RemoveEvaluationMark())
		AfxMessageBox(_T("Remove Success"));
}

void CAX_Pro_DemoDlg::OnGetpageText() 
{
	// TODO: Add your command handler code here
	CGetPageTextDlg dlg;
	dlg.Init(&m_AX);
    dlg.DoModal();
}

void CAX_Pro_DemoDlg::OnExportPagetopdf() 
{
	// TODO: Add your command handler code here
	CExportPageDlg dlg;
	dlg.Init(&m_AX);
	dlg.DoModal();
}

void CAX_Pro_DemoDlg::OnBufferfileOpen() 
{
	// TODO: Add your command handler code here
	//m_outlinetree.DeleteAllItems();
		CFileDialog fd(true,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,_T("(*.pdf)|*.pdf"),NULL);
	CFileException e;
    CString csFileName;
	
	if ( fd.DoModal() != IDOK) 
		return;
	csFileName = fd.GetPathName();
	m_AX.CloseFile();
	
	DWORD dwfilesize,dwreadbytes;
	HANDLE hFile = CreateFile(csFileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	dwfilesize = GetFileSize(hFile, NULL);
	m_pBuffer = new BYTE[dwfilesize];
	ReadFile(hFile, m_pBuffer, dwfilesize, &dwreadbytes,
		NULL);
	CloseHandle(hFile);
//	m_outlinetree.DeleteAllItems();
//	m_AX.OpenMemFile((long)m_pBuffer, dwfilesize, "");
	
	// 	or you could open pdf file in this way:
	//---------------------------------------------------------------------------------------
    tagVARIANT source;
	source.vt = VT_BSTR;
	source.bstrVal = BSTR(m_pBuffer);
	m_AX.OpenBuffer(source, dwfilesize, _T(""));

	m_outlinetree.DestroyWindow();
	m_outlinetree.Create(WS_VISIBLE | WS_TABSTOP | WS_CHILD | WS_BORDER
		| TVS_LINESATROOT | TVS_HASLINES| TVS_DISABLEDRAGDROP,
    CRect(0, 40, 200, 950), this, IDC_TREE1);
	CPDFOutline outline;
	outline = m_AX.GetOutlineFirstChild( outline.m_lpDispatch );

	if (outline != NULL)
	{	
		outline = NULL;
		ProcOutline(outline,NULL);
	}
	OnMENUITEMexpandtree();
    if (m_outlinetree.GetCount()>0)
	{
		ShowBookMark();
		m_bhidebookmark = TRUE;
	}
	else
	{
		HideBookMark();
		m_bhidebookmark = FALSE;
	}
}

void CAX_Pro_DemoDlg::OnZhongwen() 
{
	// TODO: Add your command handler code here
	/*m_AX.SetCurrentLanguageByString("D:\\lang_zh_cn.xml");*/
}

void CAX_Pro_DemoDlg::OnFileProperties() 
{
	// TODO: Add your command handler code here
	m_AX.ShowDocumentInfoDialog();
}

void CAX_Pro_DemoDlg::OnGetHyperlink() 
{
	// TODO: Add your command handler code here
	m_AX.RemoveAllHighlight();
	int nPageCount = m_AX.GetPageCount();
	m_pageindex = m_AX.GetCurPage();
	int nCount = m_AX.CountHyperLinks(m_pageindex);
	if (nCount == 0) return;
	m_step = m_step%nCount;
	m_AX.HighlightHyperLink(m_pageindex,m_step);
	++m_step;
	
}

void CAX_Pro_DemoDlg::OnGethyperlinkInfo() 
{
	// TODO: Add your command handler code here
	BOOL bRet = FALSE,bRet1 = FALSE;
	LPDISPATCH link_dest=NULL;
	BSTR linktype; BSTR linkdata;
    m_pageindex = m_AX.GetCurPage();
	int nLinkCount = m_AX.CountHyperLinks(m_pageindex);
	if (nLinkCount == 0) return;
	m_step = m_step%nLinkCount;
    bRet = m_AX.GetHyperLinkInfo(m_pageindex,m_step,&linktype,&linkdata,&link_dest);
    float top,left,bottom,right;
	bRet1 = m_AX.GetHyperLinkRect(m_pageindex, m_step, &top,&left,&bottom,&right);
	if (bRet1)
		m_AX.Highlight(m_pageindex,left,top,right,bottom);
	if(link_dest)
 		m_AX.GoToPageDest(link_dest);
	if (bRet&&bRet1)
	{
       CString strlinktype = linktype;
	   CString strlinkdata = linkdata;
	   CString strtemp = "LinkType:";
	   strtemp += linktype;
	   strtemp +="  LinkData:";
	   strtemp += linkdata;
	   MessageBox(strtemp);
	}
	++m_step;
}

void CAX_Pro_DemoDlg::OnShowToolTip() 
{
	// TODO: Add your command handler code here

	if (m_TitleState)
	{
		m_TitleState = FALSE;
	}
	else
	{
		m_TitleState = TRUE;
	}
	m_AX.ShowTitleBar( m_TitleState );

}

void CAX_Pro_DemoDlg::OnShowToolBar() 
{
	// TODO: Add your command handler code here
	if (m_ToolState)
	{
		m_ToolState = FALSE;
	}
	else
	{
		m_ToolState = TRUE;
	}
	m_AX.ShowToolBar(m_ToolState);
}

void CAX_Pro_DemoDlg::OnShowNavigationPanels() 
{
	// TODO: Add your command handler code here
	if (m_NavigationPanelState)
	{
		m_NavigationPanelState = FALSE;
	}
	else
	{
		m_NavigationPanelState = TRUE;
	}
	m_AX.ShowNavigationPanels(m_NavigationPanelState);
}
