// FindDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Pro_Demo.h"
#include "FindDlg.h"
#include "foxitpdfsdk.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindDlg dialog


CFindDlg::CFindDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFindDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindDlg)
	m_check1 = FALSE;
	m_check2 = FALSE;
	m_findtext = _T("");
	//}}AFX_DATA_INIT
	m_bFirst = TRUE;
}


void CFindDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindDlg)
	DDX_Check(pDX, IDC_CHECK1, m_check1);
	DDX_Check(pDX, IDC_CHECK2, m_check2);
	DDX_Text(pDX, IDC_EDIT1, m_findtext);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindDlg, CDialog)
	//{{AFX_MSG_MAP(CFindDlg)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindDlg message handlers


void CFindDlg::OnOK() 
{
	UpdateData(true);
	if(TRUE == m_bFirst)
	{
		//m_pAX->FindFirst(m_findtext,m_check1,m_check2);


/************************************************************************/
/*   FindFirstEx()                                          
	 test by zg                                                         */
/************************************************************************/   
		VARIANT var;
		BSTR bstr = m_findtext.AllocSysString();
		int  num = m_findtext.GetLength();

		SAFEARRAY *psa;   
		SAFEARRAYBOUND rgsabound[1];   
		rgsabound[0].cElements =num;   
		rgsabound[0].lLbound = 0;   
		psa = SafeArrayCreate(VT_UI2,1,rgsabound);
		for(long index=0; index<num; index++)   
		{   
			if(FAILED(SafeArrayPutElement(psa, &index, &bstr[index])))
				return;
		}   
		var.vt = VT_ARRAY | VT_UI2;
		var.parray = psa;

		m_pAX->FindFirstEx(var, m_check1, m_check2);
		SafeArrayDestroy(psa);
//end by zg

		m_bFirst = FALSE;
	}
	else
		//FindNext(BOOL) TRUE:down search, FALSE:up search
		m_pAX->FindNext(TRUE);
	
	// TODO: Add your control notification handler code here	

}

void CFindDlg::init(CFoxitPDFSDK* pAX)
{
	m_pAX = pAX;
}

void CFindDlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	m_bFirst = TRUE;
}

void CFindDlg::OnCheck2() 
{
	// TODO: Add your control notification handler code here
	m_bFirst = TRUE;	
}

void CFindDlg::OnChangeEdit1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	m_bFirst = TRUE;
}
