// FindFormText.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Pro_Demo.h"
#include "FindFormText.h"
#include "foxitpdfsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindFormText dialog


CFindFormText::CFindFormText(CWnd* pParent /*=NULL*/)
	: CDialog(CFindFormText::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindFormText)
	m_swhat = _T("");
	m_matchcase = FALSE;
	//}}AFX_DATA_INIT
	m_bFirst = TRUE;
}


void CFindFormText::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindFormText)
	DDX_Text(pDX, IDC_EDIT1, m_swhat);
	DDX_Check(pDX, IDC_CHECK1, m_matchcase);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindFormText, CDialog)
	//{{AFX_MSG_MAP(CFindFormText)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindFormText message handlers

void CFindFormText::OnButton1() 
{
	BOOL m_bExsitForm = m_pAX->GetBHasFormFields();  
    
	m_pAX->ShowFormFieldsMessageBar(TRUE);
	m_pAX->SetBHighlightFormFields(TRUE);
	m_pAX->SetFormFieldsHighlightColor( 0 );
	m_pAX->SetFormFieldsHighlightAlpha( 30 );

	UpdateData( TRUE );
	if ( m_bExsitForm )
	{
		if(m_bFirst)
		{
			if( !( m_pAX->FindFormFieldsTextFirst(m_swhat.LockBuffer(), m_matchcase) ) )
				AfxMessageBox(_T("find nothing!!"));
			m_bFirst = FALSE;
		}
	
		else
			m_pAX->FindFormFieldsTextNext();
	//	m_swhat.UnlockBuffer();
	}
	else
		AfxMessageBox(_T("There is no Form in the document!"));
}

void CFindFormText::init(CFoxitPDFSDK* pAX)
{
	m_pAX = pAX;
}

void CFindFormText::OnCancel() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();
}

void CFindFormText::OnChangeEdit1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	m_bFirst = TRUE;
}

void CFindFormText::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	m_bFirst = TRUE;
}
