// GetPageTextDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Pro_Demo.h"
#include "GetPageTextDlg.h"
#include "foxitpdfsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGetPageTextDlg dialog


CGetPageTextDlg::CGetPageTextDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetPageTextDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGetPageTextDlg)
	m_pagetext = _T("");
	m_pageindex = 0;
	//}}AFX_DATA_INIT
}


void CGetPageTextDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGetPageTextDlg)
	DDX_Text(pDX, IDC_EDIT_TEXT, m_pagetext);
	DDX_Text(pDX, IDC_EDIT_PAGEINDEX, m_pageindex);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGetPageTextDlg, CDialog)
	//{{AFX_MSG_MAP(CGetPageTextDlg)
	ON_EN_CHANGE(IDC_EDIT_PAGEINDEX, OnChangeEditPageindex)
	ON_BN_CLICKED(IDC_GETTEXT_BTN, OnGettextBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetPageTextDlg message handlers

void CGetPageTextDlg::OnChangeEditPageindex() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_pageindex<0||m_pageindex>=m_pAX->GetPageCount())
	{
		MessageBox(_T("Input invalid!"));
		m_pageindex = 0;
	}
	UpdateData(FALSE);
}

void CGetPageTextDlg::Init(CFoxitPDFSDK *pAX)
{
   m_pAX = pAX;
}

void CGetPageTextDlg::OnGettextBtn() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_pagetext = m_pAX->GetPageText(m_pageindex);
    UpdateData(FALSE);
}
