// MyToolBar.cpp : implementation file
//

#include "stdafx.h"
#include "MyToolBar.h"
#include "foxitpdfsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define COMBOPOS 3
#define COMBOLEN 120
#define COMBODROP 1000
/////////////////////////////////////////////////////////////////////////////
// CMyToolBar

CMyToolBar::CMyToolBar()
{	
	m_sSelection=_T("");
	m_sToolName=_T("Hand Tool");
}

CMyToolBar::~CMyToolBar()
{
}

void CMyToolBar::init(CFoxitPDFSDK* pAX)
{
	m_pAX = pAX;
}

BEGIN_MESSAGE_MAP(CMyToolBar, CToolBar)
	//{{AFX_MSG_MAP(CMyToolBar)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		ON_CBN_SELCHANGE(IDC_WZD_COMBO,OnSelChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyToolBar message handlers
BOOL CMyToolBar::LoadToolBarEx(UINT id)
{
	BOOL bRet;
	bRet = CToolBar::LoadToolBar( id );
	int pos = CommandToIndex( IDC_WZD_COMBO );
	SetButtonInfo(pos, IDC_WZD_COMBO, TBBS_SEPARATOR, COMBOLEN);
	CRect rect;
	GetItemRect( pos,&rect );
	rect.bottom += COMBODROP;
	rect.left += 70;
	rect.right += 100;
	m_ctrlWzdCombo.Create( WS_CHILD|WS_VISIBLE|CBS_DROPDOWNLIST,rect,this,IDC_WZD_COMBO );
	return bRet;
}

void CMyToolBar::OnSelChange()
{ 
	m_ctrlWzdCombo.GetLBText( m_ctrlWzdCombo.GetCurSel(),m_sToolName );

//	if( m_pAX->GetFilePath() == "" ) 
//		return;
//	else 
		m_pAX->SetCurrentTool( m_sToolName );
}