// Zoom.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Pro_Demo.h"
#include "Zoom.h"
#include "foxitpdfsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZoom dialog


CZoom::CZoom(CWnd* pParent /*=NULL*/)
	: CDialog(CZoom::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZoom)
	m_zoomfactor = 0;
	//}}AFX_DATA_INIT
}


void CZoom::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZoom)
	DDX_Text(pDX, IDC_EDIT1, m_zoomfactor);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CZoom, CDialog)
	//{{AFX_MSG_MAP(CZoom)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZoom message handlers

void CZoom::OnOK() 
{ 
	UpdateData(true);
	if (m_zoomfactor>2&&m_zoomfactor<10||m_zoomfactor>6400)
	{
		MessageBox(TEXT("Input value:0,1,2, 10 ~ 6400)"));
		m_zoomfactor = 0;
		UpdateData(FALSE);
		return;
	}
	m_pAX->SetZoomLevel(m_zoomfactor);	// TODO: Add extra validation here
	CDialog::OnCancel();
}

void CZoom::init(CFoxitPDFSDK* pAX)
{
	m_pAX = pAX;
}


void CZoom::OnCancel() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();
}

void CZoom::OnChangeEdit1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}
