// AX_Signature_DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include <WINCRYPT.H>
#include "AX_Signature_Demo.h"
#include "AX_Signature_DemoDlg.h"

#include "pdfsignaturefield.h"
#include "pdfsignaturemgr.h"

#pragma comment (lib, "crypt32.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SIGN_CONTENT_LEN	4098

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAX_Signature_DemoDlg dialog

CAX_Signature_DemoDlg::CAX_Signature_DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAX_Signature_DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAX_Signature_DemoDlg)
	m_bGray = FALSE;
	m_bBlur = FALSE;
	m_bHide = FALSE;
	m_bGrayPrint = FALSE;
	m_StraddleType = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nFileIndex=0;
}

void CAX_Signature_DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAX_Signature_DemoDlg)
	DDX_Control(pDX, IDC_LIST_SIGN, m_signlist);
	DDX_Control(pDX, IDC_R3rdSign, m_Click3rdSign);
	DDX_Control(pDX, IDC_RSign, m_ClickSign);
	DDX_Check(pDX, IDC_CHTURNGRAY, m_bGray);
	DDX_Check(pDX, IDC_CHTURNBLUR, m_bBlur);
	DDX_Check(pDX, IDC_CHHIDESIGN, m_bHide);
	DDX_Check(pDX, IDC_CHGRAYPRINT, m_bGrayPrint);
	DDX_CBString(pDX, IDC_STRADDLETYPE, m_StraddleType);
	DDX_Control(pDX, IDC_FOXITPDFSDKPROCTRL1, m_AX);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAX_Signature_DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CAX_Signature_DemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SIGNDOCUMENT, OnSigndocument)
	ON_BN_CLICKED(IDC_VERITY, OnVerity)
	ON_BN_CLICKED(IDC_3RDSIGN, On3rdsign)
	ON_BN_CLICKED(IDC_3RDVERIFY, On3rdverify)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_STRADDLESIGN, OnStraddlesign)
	ON_BN_CLICKED(IDC_Clear, OnClear)
	ON_BN_CLICKED(IDC_Remove, OnRemove)
	ON_BN_CLICKED(IDC_CHTURNGRAY, OnChturngray)
	ON_BN_CLICKED(IDC_CHTURNBLUR, OnChturnblur)
	ON_BN_CLICKED(IDC_CHHIDESIGN, OnChhidesign)
	ON_BN_CLICKED(IDC_CHGRAYPRINT, OnChgrayprint)
	ON_BN_CLICKED(IDC_BTNPRINT, OnBtnprint)
	ON_NOTIFY(NM_CLICK, IDC_LIST_SIGN, OnClickListSign)
	ON_COMMAND(IDC_OK_BTN, OnOK)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAX_Signature_DemoDlg message handlers

void CAX_Signature_DemoDlg::OnOK()
{
	return;
}

BOOL CAX_Signature_DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	//use UnLockActiveX Method to UnLock ActiveX 
	m_AX.UnLockActiveX(_T("Licence_ID"),_T("Unlock_code"));
	m_ClickSign.SetCheck(TRUE);

	CString strPath = GetModulePath();
	CString strFilePath = strPath + _T("..\\res\\test.pdf");
	m_AX.OpenFile( strFilePath, _T("") );				
	m_SigFieldMgr = m_AX.GetPDFSignatureMgr();
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
	}

	m_signlist.InsertColumn(0,_T("NO"),LVCFMT_CENTER, 60);
	m_signlist.InsertColumn(1,_T("Signer"),LVCFMT_CENTER,100);
	m_signlist.InsertColumn(2,_T("Reason"),LVCFMT_CENTER,100);
	m_signlist.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAX_Signature_DemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAX_Signature_DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAX_Signature_DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

CString CAX_Signature_DemoDlg::GetModulePath()
{
	WCHAR filepath[MAX_PATH];
	::GetModuleFileName(((CAX_Signature_DemoApp*)AfxGetApp())->m_hInstance,filepath,MAX_PATH);
	CString strPath(filepath);
	int nFind = strPath.ReverseFind('\\');
	return strPath.Left(nFind+1);
}

void CAX_Signature_DemoDlg::UpdateSignList()
{
	if(m_SigFieldMgr==NULL)
		return;
	m_signlist.DeleteAllItems();
	int nCount=m_SigFieldMgr.GetCounts();
	CString strTemp = _T("");
	for (int i(0);i!=nCount;++i)
	{
		CPDFSignatureField signField=m_SigFieldMgr.Get(i);
		m_signlist.InsertItem(i,_T("Obj 1"));
		
		strTemp.Format(_T("%d"),i);
		m_signlist.SetItemText(i, 0, strTemp);
		
		strTemp = signField.GetSigner();
		m_signlist.SetItemText(i, 1, strTemp); 
		
		strTemp = signField.GetReason();
		m_signlist.SetItemText(i, 2, strTemp);
	}
}

void CAX_Signature_DemoDlg::SignDocument( BYTE* pSrcBuf, DWORD dwSrcLen, BYTE*& pSignedBuf, DWORD& dwSignedLen )
{
	dwSignedLen = SIGN_CONTENT_LEN;
	pSignedBuf = new BYTE[dwSignedLen];
	memcpy (pSignedBuf, pSrcBuf, dwSignedLen);
	for (DWORD i=0; i<dwSignedLen; i++)
	{
		pSignedBuf[i]=pSignedBuf[i]+1;
	}
}

BOOL CAX_Signature_DemoDlg::VerifyByCustom( BYTE* pSrcBuf, DWORD dwSrcLen, BYTE* pSignedBuf, DWORD dwSignedLen )
{//Custom algorithm encrypt the source data, and verify whether the calculation results are consistent with the signed data.
	if(dwSignedLen == 0)
		return FALSE;
	BYTE* pTempBuf = new BYTE[dwSignedLen];
	memcpy (pTempBuf, pSrcBuf, dwSignedLen);
	for (DWORD i=0; i<dwSignedLen; i++)
	{
		pTempBuf[i]=pTempBuf[i]+1;
		if (pSignedBuf[i] != pTempBuf[i])
			return FALSE;
	}
	delete pTempBuf;
	return TRUE;
}

void CAX_Signature_DemoDlg::OnSigndocument() 
{//Use the digital certification for default sign.
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	BOOL bRet = FALSE;

	//set the position to locate the signature.
	CPDFSignatureField sigfield=m_SigFieldMgr.Add( 0, 100, 300, 300, 150 );

	//set Signature info
	SetSignatureInfo(sigfield);

	//Set digital certification. This is need to be set if you will sign by default ,but not by customer algorithm.
	CString strPath = GetModulePath();
	CString strCertPath  = strPath + _T("..\\res\\foxit_all.pfx");
	sigfield.SetCertPath( strCertPath, _T("123456") );
	
	//sign and save as pdf
	CString csFileIndex;
	csFileIndex.Format(_T("%d.pdf"),m_nFileIndex++);
	CString strSignedFile = strPath + _T("..\\res\\Signed_")+csFileIndex;
	bRet = m_SigFieldMgr.SignDocument( sigfield, strSignedFile, TRUE );
	if(!bRet)
	{
		MessageBox(_T("SignDocument failed."),_T("Default Sign"));
	}

	UpdateSignList();
}

void CAX_Signature_DemoDlg::OnVerity() 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	int nIndex=m_signlist.GetSelectionMark();
	if (nIndex<0)
	{
		MessageBox(L"Please select a signature");
		return;
	}
	CPDFSignatureField sigField=m_SigFieldMgr.Get(nIndex);
	if(sigField==NULL)
		return;

	CString strPath = GetModulePath();
	CString strInvalidImage = strPath + _T("..\\res\\SignitureInvalid.png");
	CString strValideImage = strPath + _T("..\\res\\SignitureValid.png");
	sigField.SetStatusImage(strValideImage, 2, 0, TRUE, TRUE, 0xffffff);			//set valid icon
	sigField.SetStatusImage(strInvalidImage, 3, 1, TRUE, FALSE, 0xffffff);			//set invalid icon

	//verify by default.
	if (sigField.IsSigned())
	{
		BOOL bRet = m_SigFieldMgr.Verify(sigField, TRUE);
		int nState = sigField.GetState();
		switch (nState)
		{
		case 0:
			MessageBox(_T("This signature is unkowned."),_T("Default Verify"));
			break;
		case 1:
			MessageBox(_T("This signature is unsigned."),_T("Default Verify"));
			break;
		case 2:
			MessageBox(_T("This signature is valid."),_T("Default Verify"));
			break;
		case 3:
			MessageBox(_T("This signature is invalid."),_T("Default Verify"));
			break;
		}
		
	}
}

void CAX_Signature_DemoDlg::On3rdsign() 
{//Use the custom  algorithm for custom sign.
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	BOOL bRet = FALSE;

	//set the position to locate the signature.
	CPDFSignatureField sigfield = m_SigFieldMgr.Add( 0, 300, 300, 500, 150 );

	if (sigfield == NULL)
 		return;

	//set Signature info
	SetSignatureInfo(sigfield);

	//save Signature info
	CString strPath = GetModulePath();
	CString csFileIndex;
	csFileIndex.Format(_T("%d.pdf"),m_nFileIndex++);
	CString strSignedFile = strPath + _T("..\\res\\Signed_")+csFileIndex;
	m_SigFieldMgr.SignDocument( sigfield, strSignedFile, FALSE );
	
	//Get the source data from the signed document.
	VARIANT varSource = sigfield.GetSourceBuffer( );
	BYTE* pSourceBuf = NULL;
	if (VT_EMPTY != varSource.vt&&VT_NULL != varSource.vt)
		pSourceBuf = (BYTE*)varSource.parray->pvData;
	DWORD dwSrcLen = sigfield.GetSourceBufferLen( );

	//Calculate the signed data by customer algorithm
	BYTE* pSignedBuf = NULL;
	DWORD dwSignedLen;
	SignDocument( pSourceBuf, dwSrcLen, pSignedBuf, dwSignedLen );

	//Sign and save as PDF
	VARIANT vaResult;
	VariantInit( &vaResult );
	vaResult.vt=VT_PTR;
	vaResult.pbVal=pSignedBuf;
	
	bRet = sigfield.CreateSignedDoc( vaResult, dwSignedLen );
	if(!bRet)
	{
		MessageBox(_T("Create the signed document failed."),_T("Custom Sign"));
	}
	delete pSignedBuf;
	UpdateSignList();
}


void CAX_Signature_DemoDlg::On3rdverify() 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	int nIndex=m_signlist.GetSelectionMark();
	if (nIndex<0)
	{
		MessageBox(L"Please select a signature");
		return;
	}
	CPDFSignatureField sigField=m_SigFieldMgr.Get(nIndex);
	if(sigField==NULL)
		return;
								
	CString strPath = GetModulePath();
	CString strInvalidImage = strPath + _T("..\\res\\SignitureInvalid.png");
	CString strValideImage = strPath + _T("..\\res\\SignitureValid.png");
	sigField.SetStatusImage(strValideImage, 2, 0, FALSE, TRUE, 0xffffff);	//set valid icon
	sigField.SetStatusImage(strInvalidImage, 3, 1, TRUE, FALSE, 0xffffff);	//set invalid icon

	if (sigField.IsSigned())
	{
		//The signature is signed by custom algorithm and will use the correspondence algorithm for verifying.
		m_SigFieldMgr.Verify(sigField, FALSE);
		
		//Get the source data from the signed document.
		VARIANT varsour = sigField.GetSourceBuffer();
		BYTE* pSourceBuf = NULL;
		if (VT_EMPTY != varsour.vt&&VT_NULL != varsour.vt)
			pSourceBuf = (BYTE*)varsour.parray->pvData;
		DWORD dwSrcLen = sigField.GetSourceBufferLen();
		
		//Get the signed data form the signed document.
		VARIANT varsign = sigField.GetSignedBuffer();
		BYTE* pSignedBuf = NULL;
		if (VT_EMPTY != varsign.vt&&VT_NULL != varsign.vt)
			pSignedBuf = (BYTE*)varsign.parray->pvData;
		DWORD dwSignedLen = sigField.GetSignedBufferLen();
		
		//Custom algorithm encrypt the source data, and verify whether the calculation results are consistent with the signed data.
		BOOL bValided = VerifyByCustom ( pSourceBuf, dwSrcLen, pSignedBuf, dwSignedLen );
		
		//Verify the results need to be returned through the "SetVerifyResult" function to control.
		if ( bValided )
		{
			sigField.SetVerifyResult( 2 );
			MessageBox(L"The signature is valid.",L"Custom Verify by event");
		}
		else
		{
			sigField.SetVerifyResult( 3 );
			MessageBox(L"The signature is invalid.",L"Custom Verify by event");
		}
	}
}

BEGIN_EVENTSINK_MAP(CAX_Signature_DemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CAX_Signature_DemoDlg)
	ON_EVENT(CAX_Signature_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 44 /* OnSetSignatureInfo */, OnOnSetSignatureInfoFoxitpdfsdkproctrl1, VTS_DISPATCH)
	ON_EVENT(CAX_Signature_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 45 /* OnSigning */, OnOnSigningFoxitpdfsdkproctrl1, VTS_DISPATCH)
	ON_EVENT(CAX_Signature_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 46 /* OnVerifying */, OnOnVerifyingFoxitpdfsdkproctrl1, VTS_DISPATCH)
	ON_EVENT(CAX_Signature_DemoDlg, IDC_FOXITPDFSDKPROCTRL1, 8 /* OnOpenDocument */, OnOnOpenDocumentFoxitpdfsdkproctrl1, VTS_BSTR)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CAX_Signature_DemoDlg::OnOnSetSignatureInfoFoxitpdfsdkproctrl1(LPDISPATCH pSignature) 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	CPDFSignatureField sigField;
	sigField.AttachDispatch(pSignature);

	//Prepare Signature info
	sigField.SetReason( _T("i Like Signing") );
	sigField.SetSigner( _T("James") );	
	sigField.SetSignerDN( _T("XXXX-XXX-XXXXXXXXX") );
	sigField.SetLocation( _T("China,FuZhou") );
	BOOL ret=sigField.SetAPOptions( 511 );			//show all
	ret=sigField.SetAPText( _T("Signing Sample") );

	//Set filter and subFilter if need.This mainly be used by customer algorithm.
	//when you signed by default algorithm they will be default set Filter with "Adobe.PPKLite" and SubFilter with "adbe.pkcs7.detached"
	sigField.SetFilter(_T("SampleFilter"));
	sigField.SetSubFilter(_T("SampleSubFilter"));
}

void CAX_Signature_DemoDlg::OnAdd() 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	CPDFSignatureField sigField = m_SigFieldMgr.Add(0, 100, 400, 300, 600);
	UpdateSignList();
}

void CAX_Signature_DemoDlg::OnOnSigningFoxitpdfsdkproctrl1(LPDISPATCH pSignature) 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
 	CPDFSignatureField sigField;
 	sigField.AttachDispatch(pSignature);

	//Set display image
 	CString strPath = GetModulePath();
	CString strImagePath = strPath + _T("..\\res\\timestamp.png");
	sigField.SetAPImage( strImagePath, TRUE, 0xFFFFFF );
 	
	//Set digital certification. This is need to be set if you will sign by default ,but not by customer algorithm.
 	CString strCertPath  = strPath + _T("..\\res\\foxit_all.pfx");
 	sigField.SetCertPath( strCertPath, _T("123456") );
 	
	BOOL bRet = FALSE;
	//Normal sign
	CString csFileIndex;
	csFileIndex.Format(_T("%d.pdf"),m_nFileIndex++);
	CString strSignedFile = strPath + _T("..\\res\\Signed_")+csFileIndex;
	if(m_ClickSign.GetCheck())
	{
		//sign and save as pdf
 		bRet=m_SigFieldMgr.SignDocument( sigField, strSignedFile, TRUE );
		if(!bRet)
		{
			MessageBox(_T("SignDocument failed."),_T("Default Sign"));
			return;
		}
		return ;
	}

	//Customer sign
	bRet = m_SigFieldMgr.SignDocument( sigField, strSignedFile, FALSE );
	if(!bRet)
	{
		MessageBox(_T("SignDocument failed."),_T("Custom Sign"));
		return;
	}

	//Get the source data from the signed document.
	VARIANT varSource = sigField.GetSourceBuffer( );
	BYTE* pSourceBuf =NULL;
	if (VT_EMPTY != varSource.vt&&VT_NULL != varSource.vt)
		pSourceBuf = (BYTE*)varSource.parray->pvData;
	DWORD dwSrcLen = sigField.GetSourceBufferLen( );
	
	//Calculate the signed data by customer algorithm
	BYTE* pSignedBuf = NULL;
	DWORD dwSignedLen;
	SignDocument( pSourceBuf, dwSrcLen, pSignedBuf, dwSignedLen );

	VARIANT vaResult;
	VariantInit( &vaResult );
	vaResult.vt=VT_PTR;
	vaResult.pbVal=pSignedBuf;
	
	//Sign and save as PDF
	bRet = sigField.CreateSignedDoc( vaResult, dwSignedLen );
	if(!bRet)
	{
		MessageBox(_T("Create the signed document failed."),_T("Custom Sign"));
		return;
	}

	UpdateSignList();
}

void CAX_Signature_DemoDlg::OnOnVerifyingFoxitpdfsdkproctrl1(LPDISPATCH pSignature) 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	CPDFSignatureField sigField;
 	sigField.AttachDispatch(pSignature);

	CString strPath = GetModulePath();
	CString strInvalidImage = strPath + _T("..\\res\\SignitureInvalid.png");
	CString strValideImage = strPath + _T("..\\res\\SignitureValid.png");
	sigField.SetStatusImage(strValideImage, 2, 0, FALSE, TRUE, 0xffffff);		//set valid icon
	sigField.SetStatusImage(strInvalidImage, 3, 1, TRUE, FALSE, 0xffffff);		//set invalid icon
	
	if (sigField.IsSigned())
	{
		if (m_ClickSign.GetCheck())
		{
			m_SigFieldMgr.Verify(sigField, TRUE);								//Normal verify
			int nState = sigField.GetState();
			switch (nState)
			{
			case 0:
				MessageBox(_T("This signature is unkowned."),_T("Default Verify by event"));
				break;
			case 1:
				MessageBox(_T("This signature is unsigned."),_T("Default Verify by event"));
				break;
			case 2:
				MessageBox(_T("This signature is valid."),_T("Default Verify by event"));
				break;
			case 3:
				MessageBox(_T("This signature is invalid."),_T("Default Verify by event"));
				break;
			}
		}
		else
		{
			//Customer verify
			m_SigFieldMgr.Verify(sigField, FALSE);								//beging customer verify
			
			//Get the source data from the signed document.
			VARIANT varsour = sigField.GetSourceBuffer();
			BYTE* pSourceBuf = NULL;
			if (VT_EMPTY != varsour.vt&&VT_NULL != varsour.vt)
				pSourceBuf = (BYTE*)varsour.parray->pvData;
			DWORD dwSrcLen = sigField.GetSourceBufferLen();
			
			//Get the signed data form the signed document.
			VARIANT varsign = sigField.GetSignedBuffer();
			BYTE* pSignedBuf = NULL;
			if (VT_EMPTY != varsign.vt&&VT_NULL != varsign.vt)
				pSourceBuf = (BYTE*)varsign.parray->pvData;
			DWORD dwSignedLen = sigField.GetSignedBufferLen();
			
			//Calculated result by customer algorithm
			BOOL bValided = VerifyByCustom ( pSourceBuf, dwSrcLen, pSignedBuf, dwSignedLen );
			
			//Set verify result by customer
			if ( bValided )
			{
				sigField.SetVerifyResult( 2 );
				MessageBox(L"The signature is valid.",L"Custom Verify by event");
			}
			else
			{
				sigField.SetVerifyResult( 3 );
				MessageBox(L"The signature is invalid.",L"Custom Verify by event");
			}
		}
	}

}

void CAX_Signature_DemoDlg::OnStraddlesign() 
{ //Here is a example for default signed
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	UpdateData();
	if (m_StraddleType.GetLength()==0)
	{
		MessageBox(_T("Please select a straddle type."));
		return;
	}

	//set the position to locate the signature.It will be hidden by default.
	CPDFSignatureField sigField = m_SigFieldMgr.Add(0, 100, 500, 300, 300);

	//Need to be set for initialize the straddle signature field.
	m_SigFieldMgr.InitStraddleValue(sigField);

	if(m_StraddleType==_T("Middle"))
		sigField.SetStraddleType(0);//0 : Middle Straddle Signature
	else if(m_StraddleType==_T("Left"))
		sigField.SetStraddleType(1);//1 : Left Straddle Signature
	else if(m_StraddleType==_T("Right"))
		sigField.SetStraddleType(2);//2 : Right Straddle Signature
	else if(m_StraddleType==_T("Up"))
		sigField.SetStraddleType(3);//3 : Up Straddle Signature
	else if(m_StraddleType==_T("Down"))
		sigField.SetStraddleType(4);//4 : Down Straddle Signature
	
	//Set the location of the signature.
	float pos = 200;
	pos = m_AX.GetPageHeight(0)/2;
	sigField.SetStraddlePos(pos);
	
	//Set the page range of the signature.
	CString pageRange = _T("0-1");
	sigField.SetStraddlePages(pageRange);
	
	//Set the status image,the status 0  has higher priority than "SetAPImage" function.
	//The corresponding image will be displayed based on the verify results.
	CString strPath = GetModulePath();
	CString strAPPath = strPath+_T("..\\res\\S0.png");
	sigField.SetStraddleBitmap(0, strAPPath);//the image for signature witch is unverified.
	strAPPath = strPath+_T("..\\res\\S1.png");
	sigField.SetStraddleBitmap(1, strAPPath);//the image for signature witch verify result is unsigned.
	strAPPath = strPath+_T("..\\res\\S2.png");
	sigField.SetStraddleBitmap(2, strAPPath);//the image for signature witch verify result is valid.
	strAPPath = strPath+_T("..\\res\\S3.png");
	sigField.SetStraddleBitmap(3, strAPPath);//the image for signature witch verify result is unvalid.
	
	//The proportion of the image in first page, the rest bisected by the other pages. Except Middle Straddle Signature.
	sigField.SetStraddleFirstPagePercent(0.3);

	//Set the signature image
	CString strImagePath = strPath + _T("..\\res\\timestamp.png");
	sigField.SetAPImage( strImagePath, TRUE, 0xFFFFFF );
	
	//show APImage.
	sigField.SetAPOptions( 128 );

	//Set digital certification. This is need to be set if you will sign by default ,but not by customer algorithm.
	CString strCertPath  = strPath + _T("..\\res\\foxit_all.pfx");
 	sigField.SetCertPath( strCertPath, _T("123456") );

	//Here is a example for default signed
	CString csFileIndex;
	csFileIndex.Format(_T("%d.pdf"),m_nFileIndex++);
	CString strSignedFile = strPath + _T("..\\res\\Signed_")+csFileIndex;
	BOOL bRet = m_SigFieldMgr.SignDocument( sigField, strSignedFile, TRUE );
	if(!bRet)
	{
		MessageBox(_T("Sign Document failed."),_T("Default Sign"));
		return;
	}
	// Or you can use custom algorithm
	/*
	m_SigFieldMgr.SignDocument( sigField, strSignedFile, FALSE );

	//Get source data from the source document
	BYTE* pSignedBuf = NULL;
	DWORD dwSignedLen;
	VARIANT varSource = sigField.GetSourceBuffer( );
	BYTE* pSourceBuf = (BYTE*)varSource.parray->pvData;
	DWORD dwSrcLen = sigField.GetSourceBufferLen( );
	
	//Calculate the signed data by customer algorithm
	SignDocument( pSourceBuf, dwSrcLen, pSignedBuf, dwSignedLen );

	VARIANT vaResult;
	VariantInit( &vaResult );
	vaResult.vt=VT_PTR;
	vaResult.pbVal=pSignedBuf;
	
	//Sign and save as PDF
	sigField.CreateSignedDoc( vaResult, dwSignedLen );
	*/

	UpdateSignList();
}

void CAX_Signature_DemoDlg::OnClear() 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	int nIndex=m_signlist.GetSelectionMark();
	if (nIndex<0)
	{
		MessageBox(L"Please select a signature");
		return;
	}
	CPDFSignatureField signField=m_SigFieldMgr.Get(nIndex);
	BOOL bRet = m_SigFieldMgr.Clear(signField);
	if(!bRet)
	{
		MessageBox(L"Clear Failed.\n\nNote that only signed signature can be cleared.");
		return;
	}
	UpdateSignList();
}

void CAX_Signature_DemoDlg::OnRemove() 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	int nIndex=m_signlist.GetSelectionMark();
	if (nIndex<0)
	{
		MessageBox(L"Please select a signature");
		return;
	}
	CPDFSignatureField signField=m_SigFieldMgr.Get(nIndex);
	if(!m_SigFieldMgr.Remove(signField))
	{
		MessageBox(L"Remove Failed.\n\nNote that only unsigned signature can be removed.");
		return;
	}
	UpdateSignList();
}

void CAX_Signature_DemoDlg::OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath) 
{
	// TODO: Add your control notification handler code here
	UpdateSignList();
}

void CAX_Signature_DemoDlg::OnChturngray() 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	UpdateData();
	int nIndex=m_signlist.GetSelectionMark();
	if (nIndex<0)
	{
		MessageBox(L"Please select a signature");
		return;
	}
	CPDFSignatureField signField=m_SigFieldMgr.Get(nIndex);
	if(signField==NULL)
		return;
	signField.TurnGray(m_bGray);	//view signature gray or not
}

void CAX_Signature_DemoDlg::OnChturnblur() 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	UpdateData();
	int nIndex=m_signlist.GetSelectionMark();
	if (nIndex<0)
	{
		MessageBox(L"Please select a signature");
		return;
	}
	CPDFSignatureField signField=m_SigFieldMgr.Get(nIndex);
	if(signField==NULL)
		return;
	signField.TurnBlur(m_bBlur);	//view signature blur or not
}

void CAX_Signature_DemoDlg::OnChhidesign() 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	UpdateData();
	int nIndex=m_signlist.GetSelectionMark();
	if (nIndex<0)
	{
		MessageBox(L"Please select a signature");
		return;
	}
	CPDFSignatureField signField=m_SigFieldMgr.Get(nIndex);
	if(signField==NULL)
		return;
	signField.SetVisible(!m_bHide);		//view signature or hide
}

void CAX_Signature_DemoDlg::OnChgrayprint() 
{
	// TODO: Add your control notification handler code here
	if (!m_SigFieldMgr)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	UpdateData();
	int nIndex=m_signlist.GetSelectionMark();
	if (nIndex<0)
	{
		MessageBox(L"Please select a signature");
		return;
	}
	CPDFSignatureField signField=m_SigFieldMgr.Get(nIndex);
	if(signField==NULL)
		return;
	signField.GrayPrint(m_bGrayPrint);		//set gray for print
}

void CAX_Signature_DemoDlg::OnBtnprint() 
{
	// TODO: Add your control notification handler code here
	m_AX.PrintWithDialog();
}

void CAX_Signature_DemoDlg::OnClickListSign(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	m_bBlur=FALSE;
	m_bGray=FALSE;
	m_bHide=FALSE;
	m_bGrayPrint=FALSE;
	UpdateData(FALSE);
	
	*pResult = 0;
}

void CAX_Signature_DemoDlg::SetSignatureInfo(CPDFSignatureField sigField)
{
	//Set the signature information.
	sigField.SetReason( _T("i Like Signing") );
	sigField.SetSigner( _T("James") );
	sigField.SetSignerDN( _T("XXXX-XXX-XXXXXXXXX") );
	sigField.SetLocation( _T("China,FuZhou") );
	sigField.SetAPText( _T("Signing Sample") );
	
	//Set the signature image
	CString strPath = GetModulePath();
	CString strImagePath = strPath + _T("..\\res\\timestamp.png");
	sigField.SetAPImage( strImagePath, TRUE, 0xFFFFFF );

	//Set filter and subFilter if need.This mainly be used by customer algorithm.
	//when you signed by default algorithm they will be default set Filter with "Adobe.PPKLite" and SubFilter with "adbe.pkcs7.detached"
	sigField.SetFilter(_T("SampleFilter"));
	sigField.SetSubFilter(_T("SampleSubFilter"));

	//show all
	sigField.SetAPOptions( 511 );
}
