// AX_Signature_DemoDlg.h : header file
//
//{{AFX_INCLUDES()
#include "foxitpdfsdk.h"
//}}AFX_INCLUDES

#if !defined(AFX_AX_SIGNATURE_DEMODLG_H__11A148A5_E724_4E1B_A1E6_002C433E4778__INCLUDED_)
#define AFX_AX_SIGNATURE_DEMODLG_H__11A148A5_E724_4E1B_A1E6_002C433E4778__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "pdfsignaturemgr.h"
/////////////////////////////////////////////////////////////////////////////
// CAX_Signature_DemoDlg dialog

class CAX_Signature_DemoDlg : public CDialog
{
// Construction
public:
	CAX_Signature_DemoDlg(CWnd* pParent = NULL);	// standard constructor


public:
	void SetSignatureInfo(CPDFSignatureField signField);
	CPDFSignatureMgr m_SigFieldMgr;

// Dialog Data
	//{{AFX_DATA(CAX_Signature_DemoDlg)
	enum { IDD = IDD_AX_SIGNATURE_DEMO_DIALOG };
	CListCtrl	m_signlist;
	CButton	m_Click3rdSign;
	CButton	m_ClickSign;
	BOOL	m_bGray;
	BOOL	m_bBlur;
	BOOL	m_bHide;
	BOOL	m_bGrayPrint;
	CString	m_StraddleType;
	CFoxitPDFSDK	m_AX;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAX_Signature_DemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	int m_nFileIndex;

	// Generated message map functions
	//{{AFX_MSG(CAX_Signature_DemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSigndocument();
	afx_msg void OnVerity();
	afx_msg void On3rdsign();
	afx_msg void On3rdverify();
	afx_msg void OnOnSetSignatureInfoFoxitpdfsdkproctrl1(LPDISPATCH pSignature);
	afx_msg void OnAdd();
	afx_msg void OnOnSigningFoxitpdfsdkproctrl1(LPDISPATCH pSignature);
	afx_msg void OnOnVerifyingFoxitpdfsdkproctrl1(LPDISPATCH pSignature);
	afx_msg void OnStraddlesign();
	afx_msg void OnClear();
	afx_msg void OnRemove();
	afx_msg void OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnChturngray();
	afx_msg void OnChturnblur();
	afx_msg void OnChhidesign();
	afx_msg void OnChgrayprint();
	afx_msg void OnBtnprint();
	afx_msg void OnClickListSign(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnOK();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void SignDocument( BYTE* pSrcBuf, DWORD dwSrcLen, BYTE*& pSignedBuf, DWORD& dwSignedLen );
	BOOL VerifyByCustom( BYTE* pSrcBuf, DWORD dwSrcLen, BYTE* pSignedBuf, DWORD dwSignedLen );
	CString GetModulePath();
	void UpdateSignList();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AX_SIGNATURE_DEMODLG_H__11A148A5_E724_4E1B_A1E6_002C433E4778__INCLUDED_)
